// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/cl-translate.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern Key_Value_List* oCL_OPERATOR_TABLEo;
extern DECLARE_STELLA_SPECIAL(oNEEDEXPLICITRETURNpo, boolean );

// Function signatures:
Symbol* destructure_call_tree(Cons* tree, Surrogate*& _return1, Cons*& _return2);
boolean use_cl_consesP();
boolean use_defconsmethodP(Method_Slot* method);
boolean use_cl_structsP();
boolean use_vector_structsP();
Cons* cl_translate_list_of_trees(Cons* trees);
Cons* cl_translate_void_sys(Cons* tree);
Object* cl_translate_typed_sys(Cons* tree);
Object* cl_translate_bad_sys(Cons* tree);
Object* cl_translate_a_tree(Object* tree);
Object* help_cl_translate_a_tree(Object* tree);
Object* cl_translate_global_symbol(Symbol* symbol);
Object* yield_global_lisp_symbol(Module* symbolmodule, char* symbolname);
Object* cl_translate_local_symbol(Symbol* symbol);
Cons* cl_translate_setq_tree(Cons* tree);
Object* yield_struct_slot_accessor_name(Surrogate* classtype, Symbol* slotname);
Object* yield_clos_slot_accessor_name(Symbol* slotname);
Cons* yield_slot_value_reader_tree(Symbol* slotname, Object* objectref, Surrogate* objecttype);
Cons* yield_slot_value_writer_tree(Symbol* slotname, Object* objectref, Surrogate* objecttype, Object* valueref);
Symbol* true_slot_name(Symbol* slotname, Surrogate* type);
Cons* cl_translate_fixed_slot_value_tree(Cons* tree);
Cons* cl_translate_fixed_slot_value_setter_tree(Cons* tree);
Object* cl_translate_call_method_tree(Cons* tree);
Symbol* method_call_type_for_vector_structs(Symbol* slotname, Surrogate* owner, boolean functionP);
Cons* cl_translate_normal_call_method_tree(Symbol* renamed_Operator, Surrogate* owner, Cons* arguments);
Cons* cl_translate_nth_tree(Cons* tree);
Cons* cl_translate_aref_tree(Cons* tree);
Object* cl_translate_argument_list_tree(Cons* tree);
boolean duplicate_cursor_variableP(Symbol* variable, Cons* iteratorbindings);
Cons* cl_translate_foreach_tree(Cons* tree);
Cons* maybe_wrap_with_continue_label(Cons* translatedloopbody);
Cons* cl_translate_let_tree(Cons* tree, boolean specialP);
Cons* cl_translate_special_tree(Cons* tree);
Cons* cl_translate_startup_time_progn_tree(Cons* tree);
Cons* cl_translate_unwind_protect_tree(Cons* tree);
Cons* cl_translate_signal_tree(Cons* tree);
Cons* cl_translate_handler_case_tree(Cons* tree);
Cons* cl_translate_handle_exception_tree(Cons* tree);
Object* cast(Object* value, Surrogate* type);
Object* cl_translate_cast_tree(Cons* tree);
Object* cl_translate_return_tree(Cons* tree);
Object* cl_translate_boolean_test(Object* tree, boolean invertP);
Object* cl_translate_plain_boolean_test(Object* tree, boolean invertP);
Cons* cl_translate_while_tree(Cons* tree);
Cons* cl_translate_conditional_tree(Cons* tree);
Cons* cl_translate_cond_tree(Cons* tree);
Cons* cl_translate_case_tree(Cons* tree);
Cons* cl_translate_boolean_tree(Cons* tree);
Object* cl_translate_class_name(Class* renamed_Class);
Object* yield_struct_constructor_name(Class* renamed_Class);
Cons* cl_translate_make_tree(Cons* tree);
Cons* cl_translate_new_tree(Cons* tree);
Cons* cl_translate_new_array_tree(Cons* tree);
Cons* cl_translate_operator_tree(Cons* tree);
Cons* yield_format_arguments(Cons* tree);
Cons* yield_print_tree(Cons* tree);
Cons* cl_translate_print_stream_tree(Cons* tree);
Cons* cl_translate_call_function_code_tree(Cons* tree);
Object* cl_translate_inline_call_tree(Cons* tree);
Cons* cl_translate_the_code_tree(Cons* tree);
Object* cl_translate_verbatim_tree(Cons* tree);
Cons* cl_translate_inline_tree(Cons* tree);
boolean generate_cl_type_declarationsP();
Object* lookup_cl_type_from_stella_type(Standard_Object* type);
Cons* cl_yield_typed_expression_tree(Cons* tree, Standard_Object* type);
Cons* cl_yield_method_parameter_type_declaration_trees(Method_Slot* method);
Cons* cl_yield_let_variable_type_declaration_trees(Cons* bindingstree);
Cons* cl_yield_global_variable_type_declaration_tree(Global_Variable* global);
Cons* cl_yield_declare_tree(Cons* declarations);
Object* cl_translate_unit(Translation_Unit* unit);
Cons* cl_translate_method_parameters(Method_Slot* method);
Cons* cl_translate_define_method_unit(Translation_Unit* unit);
Cons* yield_clos_slot_tree(Storage_Slot* slot);
Cons* yield_clos_class_tree(Class* renamed_Class);
List* compute_cl_struct_slots(Class* renamed_Class);
List* cl_struct_slots(Class* renamed_Class);
int cl_struct_slot_offset(Symbol* slotname, Surrogate* classtype);
Cons* yield_struct_slot_trees(Class* renamed_Class);
Cons* yield_struct_tree(Class* renamed_Class);
Object* yield_vector_struct_name(Class* renamed_Class);
Cons* yield_vector_struct_tree(Class* renamed_Class);
Cons* yield_condition_tree(Class* renamed_Class);
boolean cl_always_translate_to_clos_classP(Class* renamed_Class);
Cons* cl_translate_define_native_class_unit(Translation_Unit* unit);
Cons* cl_translate_define_global_variable_unit(Translation_Unit* unit);
Cons* cl_translate_defprint_unit(Translation_Unit* unit);
void help_startup_cl_translate1();
void help_startup_cl_translate2();
void help_startup_cl_translate3();
void help_startup_cl_translate4();
void startup_cl_translate();

// Auxiliary global declarations:
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_CALL_FUNCTION;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_CALL_METHOD;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_KEY_VALUE_LIST;
extern Symbol* SYM_CL_TRANSLATE_STELLA_i;
extern Symbol* SYM_CL_TRANSLATE_STELLA__;
extern Symbol* SYM_CL_TRANSLATE_STELLA_o;
extern Symbol* SYM_CL_TRANSLATE_STELLA_s;
extern Symbol* SYM_CL_TRANSLATE_STELLA_EQp;
extern Symbol* SYM_CL_TRANSLATE_STELLA_l;
extern Symbol* SYM_CL_TRANSLATE_STELLA_le;
extern Symbol* SYM_CL_TRANSLATE_STELLA_ge;
extern Symbol* SYM_CL_TRANSLATE_STELLA_g;
extern Symbol* SYM_CL_TRANSLATE_STELLA_e;
extern Symbol* SYM_CL_TRANSLATE_STELLA_xe;
extern Keyword* KWD_CL_TRANSLATE_USE_COMMON_LISP_CONSES;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_CONS;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_STANDARD_OBJECT;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_OBJECT;
extern Keyword* KWD_CL_TRANSLATE_USE_COMMON_LISP_STRUCTS;
extern Keyword* KWD_CL_TRANSLATE_USE_COMMON_LISP_VECTOR_STRUCTS;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_VOID;
extern Symbol* SYM_CL_TRANSLATE_STELLA_VOID_SYS;
extern Symbol* SYM_CL_TRANSLATE_STELLA_TYPED_SYS;
extern Symbol* SYM_CL_TRANSLATE_STELLA_BAD_SYS;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SETQ;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_SLOT_VALUE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_SLOT_VALUE_SETTER;
extern Symbol* SYM_CL_TRANSLATE_STELLA_PROGN;
extern Symbol* SYM_CL_TRANSLATE_STELLA_WITH_PROCESS_LOCK;
extern Symbol* SYM_CL_TRANSLATE_STELLA_LOOP;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_FOREACH;
extern Symbol* SYM_CL_TRANSLATE_STELLA_LET;
extern Symbol* SYM_CL_TRANSLATE_STELLA_STARTUP_TIME_PROGN;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SPECIAL;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_UNWIND_PROTECT;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_HANDLER_CASE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_HANDLE_EXCEPTION;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_SIGNAL;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CAST;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SAFE_CAST;
extern Symbol* SYM_CL_TRANSLATE_STELLA_RETURN;
extern Symbol* SYM_CL_TRANSLATE_STELLA_BREAK;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CONTINUE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_WHILE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_IF;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CHOOSE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_WHEN;
extern Symbol* SYM_CL_TRANSLATE_STELLA_UNLESS;
extern Symbol* SYM_CL_TRANSLATE_STELLA_AND;
extern Symbol* SYM_CL_TRANSLATE_STELLA_OR;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NOT;
extern Symbol* SYM_CL_TRANSLATE_STELLA_COND;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CASE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_MAKE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_NEW;
extern Symbol* SYM_CL_TRANSLATE_STELLA_MV_SETQ;
extern Symbol* SYM_CL_TRANSLATE_STELLA_QUOTE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_CALL_FUNCTION_CODE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_CALL_METHOD_CODE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SYS_INLINE_CALL;
extern Symbol* SYM_CL_TRANSLATE_STELLA_THE_CODE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_PRINT_STREAM;
extern Symbol* SYM_CL_TRANSLATE_STELLA_PRINT_NATIVE_STREAM;
extern Symbol* SYM_CL_TRANSLATE_STELLA_VERBATIM;
extern Symbol* SYM_CL_TRANSLATE_STELLA_INLINE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_IGNORE;
extern Keyword* KWD_CL_TRANSLATE_CONTINUE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_GET_KWD;
extern Symbol* SYM_CL_TRANSLATE_STELLA_GET_SGT;
extern Symbol* SYM_CL_TRANSLATE_STELLA_MODULE_LISP_PACKAGE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_VALUE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_REST;
extern Symbol* SYM_CL_TRANSLATE_STELLA_rrVALUE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_rrREST;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_SVAL;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NTH;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NTH_SETTER;
extern Symbol* SYM_CL_TRANSLATE_STELLA_AREF;
extern Symbol* SYM_CL_TRANSLATE_STELLA_AREF_SETTER;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NULLp;
extern Symbol* SYM_CL_TRANSLATE_STELLA_DEFINEDp;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_ARGUMENT_LIST;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_ARGUMENT_LIST_ITERATOR;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NORMAL_CALL;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NON_OBJECT_METHOD;
extern Symbol* SYM_CL_TRANSLATE_STELLA_PRINT_OBJECT;
extern Symbol* SYM_CL_TRANSLATE_STELLA_OBJECT_METHOD;
extern Keyword* KWD_CL_TRANSLATE_COMMON_LISP;
extern Keyword* KWD_CL_TRANSLATE_FUNCTION;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_CALL;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NULL;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_STRING;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_MUTABLE_STRING;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_NATIVE_VECTOR;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_ARRAY;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_INTEGER;
extern Symbol* SYM_CL_TRANSLATE_STELLA_ALLOCATE_ITERATOR;
extern Symbol* SYM_CL_TRANSLATE_STELLA_LENGTH;
extern Symbol* SYM_CL_TRANSLATE_STELLA_NEXTp;
extern Symbol* SYM_CL_TRANSLATE_STELLA_ARGUMENT;
extern Symbol* SYM_CL_TRANSLATE_STELLA_DO;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_FLOAT;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_INTEGER_WRAPPER;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_FLOAT_WRAPPER;
extern Symbol* SYM_CL_TRANSLATE_STELLA_PRIMARY_TYPE;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_LITERAL;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_BOOLEAN;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_NUMBER;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_SECOND_CLASS_OBJECT;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_CODE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_OTHERWISE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLASS_CL_NATIVE_TYPE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_oCONDITION_MESSAGE_KEYWORDo;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_MAKE;
extern Keyword* KWD_CL_TRANSLATE_INITIAL_ELEMENT;
extern Symbol* SYM_CL_TRANSLATE_STELLA_rrPRINT_STREAM;
extern Keyword* KWD_CL_TRANSLATE_WARN;
extern Keyword* KWD_CL_TRANSLATE_ERROR;
extern Keyword* KWD_CL_TRANSLATE_CONTINUABLE_ERROR;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_METHOD_CODE_CALL;
extern Surrogate* SGT_CL_TRANSLATE_STELLA_SHORT_INTEGER;
extern Symbol* SYM_CL_TRANSLATE_STELLA_GLOBAL_VARIABLE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLASS;
extern Symbol* SYM_CL_TRANSLATE_STELLA_METHOD;
extern Symbol* SYM_CL_TRANSLATE_STELLA_MACRO;
extern Symbol* SYM_CL_TRANSLATE_STELLA_PRINT_METHOD;
extern Symbol* SYM_CL_TRANSLATE_STELLA_TYPE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_SELF;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_DUMMY;
extern Symbol* SYM_CL_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp;
extern Symbol* SYM_CL_TRANSLATE_STELLA_DOCUMENTATION;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SELF;
extern Symbol* SYM_CL_TRANSLATE_STELLA_oCLSYS_SELFo;
extern Symbol* SYM_CL_TRANSLATE_STELLA_rrDEFCONSMETHOD;
extern Keyword* KWD_CL_TRANSLATE_VOID;
extern Symbol* SYM_CL_TRANSLATE_STELLA_SLOT_AUXILIARYp;
extern Keyword* KWD_CL_TRANSLATE_EMBEDDED;
extern Keyword* KWD_CL_TRANSLATE_INSTANCE;
extern Keyword* KWD_CL_TRANSLATE_ALLOCATION;
extern Keyword* KWD_CL_TRANSLATE_DOCUMENTATION;
extern Keyword* KWD_CL_TRANSLATE_ACCESSOR;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_ROOT_OBJECT;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLASS_CL_STRUCT_SLOTS;
extern Symbol* SYM_CL_TRANSLATE_STELLA_CLSYS_ROOT_STRUCT;
extern Keyword* KWD_CL_TRANSLATE_CONC_NAME;
extern Keyword* KWD_CL_TRANSLATE_CONSTRUCTOR;
extern Keyword* KWD_CL_TRANSLATE_COPIER;
extern Keyword* KWD_CL_TRANSLATE_PREDICATE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_;
extern Keyword* KWD_CL_TRANSLATE_INCLUDE;
extern Keyword* KWD_CL_TRANSLATE_UNBOUND_SPECIAL_VARIABLE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_STREAM;
extern Symbol* SYM_CL_TRANSLATE_STELLA_STARTUP_CL_TRANSLATE;
extern Symbol* SYM_CL_TRANSLATE_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
