// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/idl-class-out.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/




namespace stella {

// Function signatures:
Cons* idl_yield_initial_null_value();
Cons* idl_yield_attribute_tree(Storage_Slot* slot, Class* renamed_Class);
Cons* idl_yield_parameterized_attribute_tree(Storage_Slot* slot, Class* renamed_Class);
Cons* idl_yield_static_member_allocation_tree(Storage_Slot* slot, Class* renamed_Class);
Cons* idl_yield_operation_signature_tree(Method_Slot* method);
Cons* idl_yield_constructor_signature_tree(Method_Slot* method);
boolean illegal_idl_methodP(Method_Slot* methodslot);
Cons* idl_get_parameterized_attribute_definitions(Class* renamed_Class);
Cons* idl_get_attribute_definitions(Class* renamed_Class);
Cons* idl_get_static_variable_definitions(Class* renamed_Class);
boolean idl_constructorP(Method_Slot* method);
Cons* idl_get_constructor_definitions(Class* renamed_Class);
Cons* idl_get_operation_definitions(Class* renamed_Class);
Symbol* idl_class_category(Class* renamed_Class);
Cons* idl_translate_define_native_class_unit(Translation_Unit* unit);
void startup_idl_class_out();

// Auxiliary global declarations:
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_IDL_INTERFACE;
extern Keyword* KWD_IDL_CLASS_OUT_EMBEDDED;
extern Keyword* KWD_IDL_CLASS_OUT_INSTANCE;
extern Keyword* KWD_IDL_CLASS_OUT_CLASS;
extern Surrogate* SGT_IDL_CLASS_OUT_STELLA_METHOD_SLOT;
extern Surrogate* SGT_IDL_CLASS_OUT_STELLA_VOID;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_sIDL_THEORYsINTERFACE;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_sIDL_THEORYsSTRUCT;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_sIDL_THEORYsENUM;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_sIDL_THEORYsTYPEDEF;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_IDL_STRUCT;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_IDL_ENUM;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_IDL_TYPEDEF;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_IDL_DECLARATIONS;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_IDL_SIGNATURES;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_STARTUP_IDL_CLASS_OUT;
extern Symbol* SYM_IDL_CLASS_OUT_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
