// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/java-translate-file.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/




namespace stella {

// Function signatures:
void clt();
void jt();
void jptrans(Object* statement);
char* string_java_make_code_output_file_name(char* barefile, boolean donttruncateP);
char* java_make_global_output_file_name(Module* module, boolean donttruncateP);
void java_output_flotsam_units_to_file(Hash_Table* globalsht, Hash_Table* functionht, Cons* codemodulelist);
void java_output_flotsam_units_to_file_for_module(Module* module, Translation_Unit* classunit, Cons* globals, Cons* functions);
void java_output_file_header(Output_Stream* stream, char* filename);
void java_output_class_to_file(Class* renamed_Class);
void java_output_class_unit_to_file(Translation_Unit* classunit);
boolean java_flotsam_functionP(Method_Slot* method);
void java_output_startup_units_to_file(String_Hash_Table* startupht, Cons* keylist);
void java_push_into_hash_table(Hash_Table* ht, Object* key, Object* object);
void java_push_into_string_hash_table(String_Hash_Table* ht, char* key, Object* object);
boolean java_class_unit_defines_flotsam_classP(Translation_Unit* classunit);
void java_output_all_units_to_file();
void java_initialize_file_translation();
void java_translate_file(char* filename);
void java_translate_file_as_part_of_system(char* filename);
void java_translate_walked_system_units(Key_Value_List* systemunits);
void java_translate_system(char* systemname);
void startup_java_translate_file();

// Auxiliary global declarations:
extern Keyword* KWD_JAVA_TRANSLATE_FILE_COMMON_LISP;
extern Keyword* KWD_JAVA_TRANSLATE_FILE_JAVA;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_JAVA_GLOBAL;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_JAVA_SPECIAL;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_METHOD_CONSTRUCTORp;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_METHOD_NATIVEp;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_METHOD;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_MACRO;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_PRINT_METHOD;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_TYPE;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_VERBATIM;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_CLASS;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_GLOBAL_VARIABLE;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_METHOD_STARTUP_CLASSNAME;
extern Keyword* KWD_JAVA_TRANSLATE_FILE_TWO_PASSp;
extern Keyword* KWD_JAVA_TRANSLATE_FILE_FORCE_TRANSLATIONp;
extern Keyword* KWD_JAVA_TRANSLATE_FILE_PRODUCTION_SETTINGSp;
extern Symbol* SYM_JAVA_TRANSLATE_FILE_STELLA_STARTUP_JAVA_TRANSLATE_FILE;


} // end of namespace stella
