// stella-system.hh

// System-wide forward declarations:
namespace stella {

class Cons;
class Boolean_Wrapper;
class Integer_Wrapper;
class Float_Wrapper;
class String_Wrapper;
class Verbatim_String_Wrapper;
class Character_Wrapper;
class Wrapper;
class Surrogate;
class Symbol;
class Transient_Symbol;
class Keyword;
class Class;
class Storage_Slot;
class Method_Slot;
class Anchored_Type_Specifier;
class Parametric_Type_Specifier;
class Generalized_Symbol;
class Mutable_String_Wrapper;
class Cons_Iterator;
class List_Iterator;
class Destructive_List_Iterator;
class Set_Iterator;
class All_Purpose_Iterator;
class Types_To_Classes_Iterator;
class Property_List_Iterator;
class Kv_List_Iterator;
class Integer_Interval_Iterator;
class Reverse_Integer_Interval_Iterator;
class String_Iterator;
class List;
class Set;
class Class_Extension;
class Property_List;
class Kv_Cons;
class Key_Value_List;
class Recycle_List;
class Hash_Table;
class Integer_Hash_Table;
class Float_Hash_Table;
class String_Hash_Table;
class String_To_Integer_Hash_Table;
class Vector;
class Extensible_Vector;
class Extensible_Symbol_Array;
class Short_Vector_Sequence;
class Boolean_Vector;
class Integer_Vector;
class Active_List;
class Active_Set;
class Demon;
class Keyword_Key_Value_List;
class Active_Object;
class Collection;
class Table;
class Global_Variable;
class Quoted_Expression;
class Module;
class World;
class Cs_Value;
class Interval;
class Taxonomy_Node;
class Taxonomy_Graph;
class Function_Code_Wrapper;
class Method_Code_Wrapper;
class System_Definition;
class Output_Stream;
class Input_Stream;
class Output_File_Stream;
class Input_File_Stream;
class Output_String_Stream;
class Input_String_Stream;
class Stella_Hash_Table;
class Object;
class Standard_Object;
class Set_Mixin;
class Dynamic_Slots_Mixin;
class Context_Sensitive_Object;
class Context_Sensitive_Mixin;
class All_Class_Slots_Iterator;
class Slot;
class Transient_Mixin;
class Abstract_Iterator;
class Sequence_Mixin;
class Number_Wrapper;
class Translation_Unit;
class Lisp_Code;
class Compound_Type_Specifier;
class Memoization_Table;
class Mru_Memoization_Table;
class Literal_Wrapper;
class S_Expression_Iterator;
class Line_Iterator;
class Character_Iterator;
class Context;
class Iterator;
class Relation;
class Hook_List;
class Tokenizer_Table;
class Tokenizer_Token;
class Tokenizer_Stream_State;
class Stream_Tokenizer;
class Stella_Token;
class Xml_Expression_Iterator;
class Decoded_Date_Time;
class Calendar_Date;
class Relative_Date;
class Reference_Count_Object;
class Abstract_Dictionary_Iterator;
class Dictionary_Iterator;
class Interval_Iterator;
class Abstract_Collection;
class Sequence;
class Abstract_Dictionary;
class Dictionary;
class Abstract_Hash_Table;
class Vector_Sequence;
class Active_Collection_Mixin;
class Mappable_Object;
class Polymorphic_Relation;
class Thing;
class Stella_Exception;
class Read_Exception;
class Unhandled_Exception;
class Evaluation_Exception;
class No_Such_Object_Exception;
class No_Such_Context_Exception;
class Code_Wrapper;
class Stream;
class Stream_Iterator;
class Date_Time_Object;

} // end of namespace stella


// System components:
#include "stella/cpp-lib/cpp-primal.hh"
#include "stella/hierarchy.hh"
#include "stella/taxonomies.hh"
#include "stella/streams.hh"
#include "stella/primal.hh"
#include "stella/type-predicates.hh"
#include "stella/conses.hh"
#include "stella/lists.hh"
#include "stella/collections.hh"
#include "stella/iterators.hh"
#include "stella/symbols.hh"
#include "stella/literals.hh"
#include "stella/classes.hh"
#include "stella/methods.hh"
#include "stella/defclass.hh"
#include "stella/date-time.hh"
#include "stella/date-time-parser.hh"
#include "stella/stella-in.hh"
#include "stella/foreach.hh"
#include "stella/walk.hh"
#include "stella/cl-translate.hh"
#include "stella/cl-translate-file.hh"
#include "stella/dynamic-slots.hh"
#include "stella/dynamic-literal-slots.hh"
#include "stella/modules.hh"
#include "stella/contexts.hh"
#include "stella/read.hh"
#include "stella/macros.hh"
#include "stella/memoize.hh"
#include "stella/demons.hh"
#include "stella/more-demons.hh"
#include "stella/name-utility.hh"
#include "stella/translate-file.hh"
#include "stella/systems.hh"
#include "stella/describe.hh"
#include "stella/cpp-translate-file.hh"
#include "stella/cpp-translate.hh"
#include "stella/cpp-class-out.hh"
#include "stella/cpp-output.hh"
#include "stella/java-translate-file.hh"
#include "stella/java-translate.hh"
#include "stella/java-class-out.hh"
#include "stella/java-output.hh"
#include "stella/idl-translate.hh"
#include "stella/idl-class-out.hh"
#include "stella/idl-translate-file.hh"
#include "stella/idl-output.hh"
#include "stella/startup.hh"
#include "stella/startup-system.hh"
