// systems.cc

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

#include "stella/stella-system.hh"

namespace stella {

Object* evaluate_command(Object* command, boolean finalizeP) {
  { boolean dummy1;

    { 
      BIND_STELLA_SPECIAL(oTRANSLATIONERRORSo, int, 0);
      BIND_STELLA_SPECIAL(oTRANSLATIONWARNINGSo, int, 0);
      BIND_STELLA_SPECIAL(oIGNORETRANSLATIONERRORSpo, boolean, FALSE);
      BIND_STELLA_SPECIAL(oTRANSLATIONUNITSo, List*, NULL);
      BIND_STELLA_SPECIAL(oTRANSLATIONPHASEo, Keyword*, KWD_SYSTEMS_DEFINE);
      BIND_STELLA_SPECIAL(oEVALUATIONTREEo, Object*, NULL);
      { Object* renamed_Operator = NULL;
        Object* result = NULL;

        { Surrogate* test_value_000 = safe_primary_type(command);

          if (test_value_000 == SGT_SYSTEMS_STELLA_CONS) {
            { Object* command_000 = command;
              Cons* command = ((Cons*)(command_000));

              renamed_Operator = command->value;
              if (subtype_of_symbolP(safe_primary_type(renamed_Operator))) {
                { Object* operator_000 = renamed_Operator;
                  Symbol* renamed_Operator = ((Symbol*)(operator_000));

                  if (renamed_Operator == SYM_SYSTEMS_STELLA_IN_MODULE) {
                    handle_in_module_tree(command, FALSE, dummy1);
                  }
                  else {
                    if (declaration_treeP(command)) {
                      oTRANSLATIONUNITSo.set(list(0));
                      walk_top_level_tree(command, FALSE);
                      switch (oTRANSLATIONUNITSo.get()->reverse()->length()) {
                        case 0: 
                          { Output_String_Stream* stream_000 = new_output_string_stream();

                            *(stream_000->native_stream) << "While evaluating '" << oEVALUATIONTREEo.get();
                            if (((boolean)(oEVALUATIONPARENTTREEo.get()))) {
                              *(stream_000->native_stream) << endl << "' inside '" << oEVALUATIONPARENTTREEo.get();
                            }
                            *(stream_000->native_stream) << "':" << endl;
                            *(stream_000->native_stream) << "Couldn't translate " << "`" << command << "'";
                            throw *new_evaluation_exception(stream_000->the_string_reader());
                          }
                        break;
                        case 1: 
                          result = ((Translation_Unit*)(oTRANSLATIONUNITSo.get()->first()))->the_object;
                        break;
                        default:
                          { Cons* results = NIL;

                            { Translation_Unit* unit = NULL;
                              Cons* iter_000 = oTRANSLATIONUNITSo.get()->the_cons_list;
                              Cons* collect_000 = NULL;

                              while (!(iter_000 == NIL)) {
                                unit = ((Translation_Unit*)(iter_000->value));
                                iter_000 = iter_000->rest;
                                if (!((boolean)(collect_000))) {
                                  {
                                    collect_000 = cons(unit->the_object, NIL);
                                    if (results == NIL) {
                                      results = collect_000;
                                    }
                                    else {
                                      add_cons_to_end_of_cons_list(results, collect_000);
                                    }
                                  }
                                }
                                else {
                                  {
                                    collect_000->rest = cons(unit->the_object, NIL);
                                    collect_000 = collect_000->rest;
                                  }
                                }
                              }
                            }
                            result = results;
                          }
                        break;
                      }
                    }
                    else if (string_equalP(renamed_Operator->symbol_name, "in-package")) {
                    }
                    else {
                      evaluate(command);
                    }
                  }
                }
              }
              else {
                evaluate(command);
              }
            }
          }
          else if (subtype_of_keywordP(test_value_000)) {
            { Object* command_001 = command;
              Keyword* command = ((Keyword*)(command_001));

              result = command;
            }
          }
          else if (subtype_of_surrogateP(test_value_000)) {
            { Object* command_002 = command;
              Surrogate* command = ((Surrogate*)(command_002));

              result = command;
            }
          }
          else {
            evaluate(command);
          }
        }
        if ((!translation_errorsP()) &&
            finalizeP) {
          oTRANSLATIONPHASEo.set(KWD_SYSTEMS_FINALIZE);
          if (((boolean)(oCURRENTSYSTEMDEFINITIONo.get()))) {
            run_system_finalization(oCURRENTSYSTEMDEFINITIONo.get());
          }
          else {
            cout << "Can't run finalization because *currentSystemDefinition* is not set." << endl;
          }
        }
        return (result);
      }
    }
  }
}

void load_file(char* file) {
  // Read logic commands from `file' and evaluate them.
  // The file should begin with an `in-module' declaration that specifies
  // the module within which all remaining commands are to be evaluated
  // The remaining commands are evaluated one-by-one, applying the function
  // `evaluate' to each of them.
  if (!probe_fileP(file)) {
    { Output_String_Stream* stream_000 = new_output_string_stream();

      *(stream_000->native_stream) << "File " << "`" << file << "'" << " does not exist.";
      throw *new_stella_exception(stream_000->the_string_reader());
    }
  }
  { boolean toplevelinvocationP = oCURRENTFILEo.get() == NULL;
    boolean skipcommandP = FALSE;
    boolean seeninmoduleP = FALSE;
    Cons* commands = NIL;
    Input_File_Stream* inputstream = NULL;

    try {
      { 
        BIND_STELLA_SPECIAL(oCURRENTFILEo, char*, file_base_name(file));
        inputstream = new_input_file_stream(file);
        { 
          BIND_STELLA_SPECIAL(oMODULEo, Module*, oMODULEo.get());
          BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
          { Object* tree = NULL;
            S_Expression_Iterator* iter_000 = s_expressions(inputstream);

            while (iter_000->nextP()) {
              tree = iter_000->value;
              if (safe_primary_type(tree) == SGT_SYSTEMS_STELLA_CONS) {
                { Object* tree_000 = tree;
                  Cons* tree = ((Cons*)(tree_000));

                  skipcommandP = handle_in_module_tree(tree, seeninmoduleP, seeninmoduleP);
                  if (skipcommandP) {
                    continue;
                  }
                  { Object* renamed_Operator = tree->value;

                    if (subtype_of_symbolP(safe_primary_type(renamed_Operator))) {
                      { Object* operator_000 = renamed_Operator;
                        Symbol* renamed_Operator = ((Symbol*)(operator_000));

                        if ((renamed_Operator == SYM_SYSTEMS_STELLA_DEFMODULE) ||
                            ((renamed_Operator == SYM_SYSTEMS_STELLA_DEFSYSTEM) ||
                             ((renamed_Operator == SYM_SYSTEMS_STELLA_DEFCLASS) ||
                              ((renamed_Operator == SYM_SYSTEMS_STELLA_DEFSLOT) ||
                               ((renamed_Operator == SYM_SYSTEMS_STELLA_DEFUN) ||
                                (renamed_Operator == SYM_SYSTEMS_STELLA_DEFMETHOD)))))) {
                          evaluate_command(tree, FALSE);
                        }
                        else {
                          if (((boolean)(lookup_command(renamed_Operator)))) {
                            commands = cons(tree, commands);
                          }
                          else {
                            evaluate_command(tree, FALSE);
                          }
                        }
                      }
                    }
                    else {
                      evaluate_command(tree, FALSE);
                    }
                  }
                }
              }
              else {
                evaluate_command(tree, FALSE);
              }
            }
          }
          { 
            BIND_STELLA_SPECIAL(oTRANSLATIONPHASEo, Keyword*, KWD_SYSTEMS_FINALIZE);
            run_system_finalization(oCURRENTSYSTEMDEFINITIONo.get());
          }
          { Object* tree = NULL;
            Cons* iter_001 = commands->reverse();

            while (!(iter_001 == NIL)) {
              tree = iter_001->value;
              iter_001 = iter_001->rest;
              evaluate_command(tree, TRUE);
            }
          }
        }
      }
    }
catch (...) {
      if (toplevelinvocationP) {
        sweep_transients();
      }
      if (((boolean)(inputstream))) {
        inputstream->free();
      }
      throw;
    }
    if (toplevelinvocationP) {
      sweep_transients();
    }
    if (((boolean)(inputstream))) {
      inputstream->free();
    }
  }
}

void load_file_evaluator_wrapper(Cons* arguments) {
  load_file(((String_Wrapper*)(arguments->value))->wrapper_value);
}

// A list of all defined systems.
List* oSYSTEMDEFINITIONSo = NULL;

char* make_system_definition_file_name(char* name) {
  return (string_concatenate(system_definitions_directory(), directory_separator_string(), 2, string_downcase(name), "-system.ste"));
}

Cons* parse_list_of_file_paths(Cons* files) {
  { Cons* strings = NIL;

    { Object* filespec = NULL;
      Cons* iter_000 = files;

      while (!(iter_000 == NIL)) {
        filespec = iter_000->value;
        iter_000 = iter_000->rest;
        strings = cons(wrap_string(implode_pathname(filespec)), strings);
      }
    }
    return (strings->reverse());
  }
}

System_Definition* define_system(Object* name, Cons* options) {
  { char* stringname = NULL;

    { Surrogate* test_value_000 = safe_primary_type(name);

      if (subtype_of_stringP(test_value_000)) {
        { Object* name_000 = name;
          String_Wrapper* name = ((String_Wrapper*)(name_000));

          stringname = name->wrapper_value;
        }
      }
      else if (subtype_of_symbolP(test_value_000)) {
        { Object* name_001 = name;
          Symbol* name = ((Symbol*)(name_001));

          stringname = string_downcase(name->symbol_name);
        }
      }
      else {
        cout << "Illegal system name: " << name;
        return (NULL);
      }
    }
    { System_Definition* self_000 = new_system_definition();

      self_000->name = stringname;
      { System_Definition* system = self_000;

        { Property_List* self_001 = new_property_list();

          self_001->the_plist = options;
          { Property_List* plist = self_001;

            { System_Definition* value_000 = NULL;

              { System_Definition* s = NULL;
                Cons* iter_000 = oSYSTEMDEFINITIONSo->the_cons_list;

                while (!(iter_000 == NIL)) {
                  s = ((System_Definition*)(iter_000->value));
                  iter_000 = iter_000->rest;
                  if (string_eqlP(s->name, stringname)) {
                    value_000 = s;
                    break;
                  }
                }
              }
              { System_Definition* oldsystem = value_000;

                { Object* key = NULL;
                  Object* value = NULL;
                  Cons* iter_001 = plist->the_plist;

                  while (!(iter_001 == NIL)) {
                    key = iter_001->value;
                    value = iter_001->rest->value;
                    iter_001 = iter_001->rest->rest;
                    { Generalized_Symbol* test_value_001 = ((Generalized_Symbol*)(key));

                      if (test_value_001 == KWD_SYSTEMS_DIRECTORY) {
                        system->directory = implode_pathname(value);
                      }
                      else if (test_value_001 == KWD_SYSTEMS_FILES) {
                        system->files = parse_list_of_file_paths(((Cons*)(value)));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_REQUIRED_SYSTEMS) {
                        system->required_systems = ((Cons*)(value));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_LISP_ONLY_FILES) {
                        system->lisp_only_files = parse_list_of_file_paths(((Cons*)(value)));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_CPP_ONLY_FILES) {
                        system->cpp_only_files = parse_list_of_file_paths(((Cons*)(value)));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_JAVA_ONLY_FILES) {
                        system->java_only_files = parse_list_of_file_paths(((Cons*)(value)));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_PREPROCESSED_FILES) {
                        system->preprocessed_files = parse_list_of_file_paths(((Cons*)(value)));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_CARDINAL_MODULE) {
                        system->cardinal_module = ((String_Wrapper*)(value))->wrapper_value;
                      }
                      else if (test_value_001 == KWD_SYSTEMS_ROOT_SOURCE_DIRECTORY) {
                        system->source_root_directory = ((String_Wrapper*)(value))->wrapper_value;
                      }
                      else if (test_value_001 == KWD_SYSTEMS_ROOT_NATIVE_DIRECTORY) {
                        system->native_root_directory = ((String_Wrapper*)(value))->wrapper_value;
                      }
                      else if (test_value_001 == KWD_SYSTEMS_ROOT_BINARY_DIRECTORY) {
                        system->binary_root_directory = ((String_Wrapper*)(value))->wrapper_value;
                      }
                      else if ((test_value_001 == KWD_SYSTEMS_BANNER) ||
                          (test_value_001 == KWD_SYSTEMS_COPYRIGHT_HEADER)) {
                        system->banner = ((String_Wrapper*)(value))->wrapper_value;
                      }
                      else if (test_value_001 == KWD_SYSTEMS_PRODUCTION_SETTINGS) {
                        system->production_settings = ((Cons*)(value));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_DEVELOPMENT_SETTINGS) {
                        system->development_settings = ((Cons*)(value));
                      }
                      else if (test_value_001 == KWD_SYSTEMS_FINALIZATION_FUNCTION) {
                        system->finalization_function = ((Symbol*)(value));
                      }
                      else {
                        { Output_String_Stream* stream_000 = new_output_string_stream();

                          *(stream_000->native_stream) << "`" << test_value_001 << "'" << " is not a valid case option";
                          throw *new_stella_exception(stream_000->the_string_reader());
                        }
                      }
                    }
                  }
                }
                oSYSTEMDEFINITIONSo->push(system);
                if (((boolean)(oldsystem))) {
                  cout << "Redefining system " << "`" << system->name << "'" << endl << endl;
                  oSYSTEMDEFINITIONSo->remove(oldsystem);
                }
                return (system);
              }
            }
          }
        }
      }
    }
  }
}

System_Definition* defsystem(Symbol* name, Cons* options) {
  // Define a system of files that collectively define
  // a Stella application.
  //    Required options are:
  //    :directory -- the path from the Stella root directory to the directory
  //                  containing the system files.  Can be a string or a list
  //                  of strings (do not include directory separators).
  //    :files -- a list of files in the system, containing strings and lists
  //              of strings; the latter defines exploded paths to files
  //              in subdirectories.
  //    Optional options are:
  //    :required-systems -- a list of systems (strings) that should be loaded
  //                         prior to loading this system.
  //    :cardinal-module -- the name (a string) of the principal module for this
  //                        system.
  return (define_system(name, options));
}

System_Definition* defsystem_evaluator_wrapper(Cons* arguments) {
  return (defsystem(((Symbol*)(arguments->value)), arguments->rest));
}

System_Definition* get_system_definition(char* name) {
  { System_Definition* value_000 = NULL;

    { System_Definition* s = NULL;
      Cons* iter_000 = oSYSTEMDEFINITIONSo->the_cons_list;

      while (!(iter_000 == NIL)) {
        s = ((System_Definition*)(iter_000->value));
        iter_000 = iter_000->rest;
        if (string_equalP(s->name, name)) {
          value_000 = s;
          break;
        }
      }
    }
    { System_Definition* system = value_000;

      if (!((boolean)(system))) {
        { char* systemfilename = make_system_definition_file_name(name);

          if (!probe_fileP(systemfilename)) {
            *(STANDARD_ERROR->native_stream) << "ERROR>> File " << systemfilename << " does not exist." << endl << "   Can't define system " << name << endl;
            return (NULL);
          }
          load_file(systemfilename);
          { System_Definition* value_001 = NULL;

            { System_Definition* s = NULL;
              Cons* iter_001 = oSYSTEMDEFINITIONSo->the_cons_list;

              while (!(iter_001 == NIL)) {
                s = ((System_Definition*)(iter_001->value));
                iter_001 = iter_001->rest;
                if (string_equalP(s->name, name)) {
                  value_001 = s;
                  break;
                }
              }
            }
            system = value_001;
          }
          if (!((boolean)(system))) {
            *(STANDARD_ERROR->native_stream) << "ERROR>>  Can't find a system definition for system " << name << endl << "   within file " << systemfilename << "." << endl;
          }
        }
      }
      return (system);
    }
  }
}

Module* get_cardinal_module(System_Definition* system) {
  { char* name = system->cardinal_module;
    Module* module = NULL;

    if (name != NULL) {
      module = get_stella_module(name, FALSE);
      if (!((boolean)(module))) {
        module = get_stella_module(string_upcase(name), FALSE);
      }
    }
    if (!((boolean)(module))) {
      *(STANDARD_WARNING->native_stream) << "Warning: " << "No cardinal module defined for system: " << "`" << system << "'" << endl << endl;
    }
    return (module);
  }
}

void help_get_system_files(char* filename, List* collection, boolean probefileP) {
  if ((!probefileP) ||
      probe_fileP(filename)) {
    collection->push(wrap_string(filename));
  }
}

List* get_system_files(System_Definition* system, Keyword* type, boolean probefilesP) {
  { List* files = new_list();
    char* filename = NULL;

    { 
      BIND_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONo, System_Definition*, get_system_definition(system->name));
      BIND_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONSUBDIRECTORYo, char*, (((boolean)(oCURRENTSYSTEMDEFINITIONo.get())) ? oCURRENTSYSTEMDEFINITIONo.get()->directory : NULL));
      if (((boolean)(oCURRENTSYSTEMDEFINITIONo.get()))) {
        {
          { String_Wrapper* f = NULL;
            Cons* iter_000 = oCURRENTSYSTEMDEFINITIONo.get()->files;

            while (!(iter_000 == NIL)) {
              f = ((String_Wrapper*)(iter_000->value));
              iter_000 = iter_000->rest;
              if (type == KWD_SYSTEMS_JAVA) {
                filename = java_translate_class_namestring(wrap_string(string_concatenate("Startup-", f->wrapper_value, 0)))->wrapper_value;
              }
              else {
                filename = make_file_name_from_relative_path(f, type);
              }
              help_get_system_files(filename, files, probefilesP);
            }
          }
          if (type == KWD_SYSTEMS_JAVA) {
            if (!((boolean)(get_cardinal_module(oCURRENTSYSTEMDEFINITIONo.get())))) {
              cout << "No cardinal module defined for system " << "`" << system->name << "'" << endl << endl;
              return (NIL_LIST);
            }
            { Class* renamed_Class = NULL;
              Iterator* iter_001 = all_classes(get_cardinal_module(oCURRENTSYSTEMDEFINITIONo.get()), TRUE);

              while (iter_001->nextP()) {
                renamed_Class = ((Class*)(iter_001->value));
                filename = renamed_Class->java_make_code_output_file_name(FALSE);
                help_get_system_files(filename, files, probefilesP);
              }
            }
            filename = string_java_make_code_output_file_name(java_yield_flotsam_class_name(get_cardinal_module(oCURRENTSYSTEMDEFINITIONo.get())), FALSE);
            help_get_system_files(filename, files, probefilesP);
          }
          else {
          }
        }
      }
      else {
        *(STANDARD_WARNING->native_stream) << "Warning: " << "Can't find a system named " << "`" << system->name << "'" << endl << endl;
      }
    }
    return (files);
  }
}

void clean_system(char* systemname) {
  { System_Definition* system = get_system_definition(systemname);

    if (!((boolean)(system))) {
      return;
    }
    { String_Wrapper* f = NULL;
      Cons* iter_000 = get_system_files(system, KWD_SYSTEMS_LISP, TRUE)->the_cons_list;

      while (!(iter_000 == NIL)) {
        f = ((String_Wrapper*)(iter_000->value));
        iter_000 = iter_000->rest;
        delete_file(f->wrapper_value);
      }
    }
    { String_Wrapper* f = NULL;
      Cons* iter_001 = get_system_files(system, KWD_SYSTEMS_JAVA, TRUE)->the_cons_list;

      while (!(iter_001 == NIL)) {
        f = ((String_Wrapper*)(iter_001->value));
        iter_001 = iter_001->rest;
        delete_file(f->wrapper_value);
      }
    }
    { String_Wrapper* f = NULL;
      Cons* iter_002 = get_system_files(system, KWD_SYSTEMS_CPP, TRUE)->the_cons_list;

      while (!(iter_002 == NIL)) {
        f = ((String_Wrapper*)(iter_002->value));
        iter_002 = iter_002->rest;
        delete_file(f->wrapper_value);
      }
    }
    { String_Wrapper* f = NULL;
      Cons* iter_003 = get_system_files(system, KWD_SYSTEMS_LISP_BINARY, TRUE)->the_cons_list;

      while (!(iter_003 == NIL)) {
        f = ((String_Wrapper*)(iter_003->value));
        iter_003 = iter_003->rest;
        delete_file(f->wrapper_value);
      }
    }
  }
}

void compute_optimization_levels(System_Definition* system, boolean productionmodeP) {
  { Cons* settings = NULL;

    if (productionmodeP) {
      settings = system->production_settings;
    }
    else {
      settings = system->development_settings;
    }
    if (!((boolean)(settings))) {
      settings = get_quoted_tree("((3 2 3 3) \"/STELLA\")", "/STELLA");
    }
    set_optimization_levels(((Integer_Wrapper*)(settings->nth(0)))->wrapper_value, ((Integer_Wrapper*)(settings->nth(1)))->wrapper_value, ((Integer_Wrapper*)(settings->nth(2)))->wrapper_value, ((Integer_Wrapper*)(settings->nth(3)))->wrapper_value);
  }
}

Keyword* lisp_keyword_to_stella_keyword(Keyword* key) {
  { Keyword* stellakeyword = NULL;

    return (stellakeyword);
  }
}

Property_List* vet_options(Object* plist, Cons* legaloptions) {
  { Property_List* propertylist = NULL;

    { Surrogate* test_value_000 = safe_primary_type(plist);

      if (subtype_ofP(test_value_000, SGT_SYSTEMS_STELLA_PROPERTY_LIST)) {
        { Object* plist_000 = plist;
          Property_List* plist = ((Property_List*)(plist_000));

          propertylist = plist;
        }
      }
      else if (test_value_000 == SGT_SYSTEMS_STELLA_CONS) {
        { Object* plist_001 = plist;
          Cons* plist = ((Cons*)(plist_001));

          { Property_List* self_000 = new_property_list();

            self_000->the_plist = plist;
            propertylist = self_000;
          }
        }
      }
      else if (subtype_ofP(test_value_000, SGT_SYSTEMS_STELLA_LIST)) {
        { Object* plist_002 = plist;
          List* plist = ((List*)(plist_002));

          { Property_List* self_001 = new_property_list();

            self_001->the_plist = plist->the_cons_list;
            propertylist = self_001;
          }
        }
      }
      else {
        *(STANDARD_WARNING->native_stream) << "Warning: " << "Illegal argument passed to 'vet-options'" << endl;
        return (new_property_list());
      }
    }
    { Object* key = NULL;
      Object* value = NULL;
      Cons* iter_000 = propertylist->the_plist;

      while (!(iter_000 == NIL)) {
        key = iter_000->value;
        value = iter_000->rest->value;
        iter_000 = iter_000->rest->rest;
        if ((!stella_objectP(key)) ||
            ((!keywordP(key)) ||
             (((boolean)(legaloptions)) &&
              (!legaloptions->memberP(key))))) {
          {
          }
          if (!stella_objectP(key)) {
            { Property_List* newplist = new_property_list();

              { Object* key = NULL;
                Object* value = NULL;
                Cons* iter_001 = propertylist->the_plist;

                while (!(iter_001 == NIL)) {
                  key = iter_001->value;
                  value = iter_001->rest->value;
                  iter_001 = iter_001->rest->rest;
                  newplist->insert_at(stellify(key), stellify(value));
                }
              }
              propertylist->the_plist = newplist->the_plist;
            }
            vet_options(propertylist, legaloptions);
            return (propertylist);
          }
          propertylist->remove_at(key);
          cout << "Skipping illegal option: " << "`" << key << "'" << endl << endl;
          if (keywordP(key)) {
            cout << "   Legal options are: " << "`" << legaloptions << "'" << endl << endl;
          }
          else {
            cout << "   Option must be a keyword." << endl;
          }
          vet_options(propertylist, legaloptions);
          return (propertylist);
        }
      }
    }
    return (propertylist);
  }
}

boolean make_system(char* systemname, Keyword* language, Cons* options) {
  // Translate, compile and load all out-of-date files in `files'.
  // If :development-settings? is set, translate with safety set to high; otherwise,
  // use production mode settings (defined in the 'defsystem').
  // If :force-recompilation? is `true', retranslate/recompile the entire system.
  // If :two-pass?, the translator makes two passes over the source files.
  // Otherwise, the translator will make one pass in the case that the
  // system is already loaded (and is being remade), and two passes otherwise.
  // Runs system startup functions unless :startup? is set to `false'.
  // If :load-system? is FALSE, then files are translated but not loaded.
  { Property_List* self_000 = new_property_list();

    self_000->the_plist = options;
    { Property_List* plist = self_000;
      boolean developmentsettingsP = FALSE;
      boolean forcetranslationP = FALSE;
      boolean forcerecompilationP = FALSE;
      boolean twopassP = ((boolean)(get_system_definition(systemname))) &&
          (!get_system_definition(systemname)->loadedP);
      boolean loadsystemP = language == KWD_SYSTEMS_COMMON_LISP;
      boolean startupsystemP = language == KWD_SYSTEMS_COMMON_LISP;
      boolean updatedsystemP = FALSE;
      System_Definition* system = get_system_definition(systemname);

      if (!((boolean)(system))) {
        cout << "Can't find a declaration for system named " << systemname << endl << "  Possibly a global path name needs to be set." << endl;
        return (FALSE);
      }
      language = ((Keyword*)(stellify(language)));
      vet_options(plist, get_quoted_tree("((:FORCE-TRANSLATION? :DEVELOPMENT-SETTINGS? :TWO-PASS? :FORCE-RECOMPILATION? :LOAD-SYSTEM? :STARTUP?) \"/STELLA\")", "/STELLA"));
      { Object* key = NULL;
        Object* value = NULL;
        Cons* iter_000 = plist->the_plist;

        while (!(iter_000 == NIL)) {
          key = iter_000->value;
          value = iter_000->rest->value;
          iter_000 = iter_000->rest->rest;
          { boolean truevalueP = eqlP(value, TRUE_WRAPPER);

            { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(key));

              if (test_value_000 == KWD_SYSTEMS_DEVELOPMENT_SETTINGSp) {
                developmentsettingsP = truevalueP;
              }
              else if (test_value_000 == KWD_SYSTEMS_FORCE_TRANSLATIONp) {
                forcetranslationP = truevalueP;
              }
              else if (test_value_000 == KWD_SYSTEMS_FORCE_RECOMPILATIONp) {
                forcerecompilationP = truevalueP;
              }
              else if (test_value_000 == KWD_SYSTEMS_TWO_PASSp) {
                twopassP = truevalueP;
              }
              else if (test_value_000 == KWD_SYSTEMS_LOAD_SYSTEMp) {
                loadsystemP = truevalueP;
              }
              else if (test_value_000 == KWD_SYSTEMS_STARTUPp) {
                startupsystemP = truevalueP;
              }
              else {
                { Output_String_Stream* stream_000 = new_output_string_stream();

                  *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
                  throw *new_stella_exception(stream_000->the_string_reader());
                }
              }
            }
          }
        }
      }
      if (forcerecompilationP ||
          ((!system->loadedP) &&
           (forcetranslationP ||
            system_needs_translationP(systemname, language)))) {
        load_preprocessed_files(systemname);
      }
      updatedsystemP = translate_system(systemname, language, 6, KWD_SYSTEMS_TWO_PASSp, (twopassP ? TRUE_WRAPPER : FALSE_WRAPPER), KWD_SYSTEMS_FORCE_TRANSLATIONp, (forcetranslationP ? TRUE_WRAPPER : FALSE_WRAPPER), KWD_SYSTEMS_DEVELOPMENT_SETTINGSp, (developmentsettingsP ? TRUE_WRAPPER : FALSE_WRAPPER));
      if (loadsystemP &&
          load_system(systemname, language, 4, KWD_SYSTEMS_FORCE_RECOMPILATIONp, (forcerecompilationP ? TRUE_WRAPPER : FALSE_WRAPPER), KWD_SYSTEMS_STARTUPp, (startupsystemP ? TRUE_WRAPPER : FALSE_WRAPPER))) {
        updatedsystemP = TRUE;
      }
      return (updatedsystemP);
    }
  }
}

Boolean_Wrapper* make_system_evaluator_wrapper(Cons* arguments) {
  return ((make_system(((String_Wrapper*)(arguments->value))->wrapper_value, ((Keyword*)(arguments->rest->value)), arguments->rest->rest) ? TRUE_WRAPPER : FALSE_WRAPPER));
}

void run_system_finalization(System_Definition* system) {
  { char* fnname = NULL;
    Method_Slot* finalizationfn = NULL;

    if (fnname != NULL) {
      finalizationfn = lookup_function_by_name(fnname);
    }
    if (((boolean)(finalizationfn))) {
      ((void  (*) ())finalizationfn->function_code)();
    }
  }
}

Cons* system_definition_source_files(System_Definition* system) {
  { Cons* files = copy_cons_list(system->files);

    if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_SYSTEMS_COMMON_LISP) {
      files = files->subtract(system->java_only_files);
      files = files->subtract(system->cpp_only_files);
    }
    else if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_SYSTEMS_JAVA) {
      files = files->subtract(system->lisp_only_files);
      files = files->subtract(system->cpp_only_files);
    }
    else if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_SYSTEMS_CPP) {
      files = files->subtract(system->lisp_only_files);
      files = files->subtract(system->java_only_files);
    }
    else {
      { Output_String_Stream* stream_000 = new_output_string_stream();

        *(stream_000->native_stream) << "`" << oTRANSLATOROUTPUTLANGUAGEo.get() << "'" << " is not a valid case option";
        throw *new_stella_exception(stream_000->the_string_reader());
      }
    }
    return (files);
  }
}

Cons* files_plus_system_startup(Cons* files) {
  return (files->concatenate(cons_list(1, wrap_string(system_startup_file_name(NULL))), 0));
}

Cons* system_definition_native_files(System_Definition* system) {
  { Cons* files = copy_cons_list(system->files);

    if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_SYSTEMS_COMMON_LISP) {
      files = files->renamed_Union(system->lisp_only_files);
      if (oCURRENT_ENVIRONMENT_FEATURESo->membP(KWD_SYSTEMS_USE_COMMON_LISP_STRUCTS)) {
        files = cons(wrap_string(cl_yield_struct_class_file_name(system->name)), files);
      }
    }
    else if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_SYSTEMS_JAVA) {
      files = files->renamed_Union(system->java_only_files);
    }
    else if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_SYSTEMS_CPP) {
      files = files->renamed_Union(system->cpp_only_files);
    }
    else {
      { Output_String_Stream* stream_000 = new_output_string_stream();

        *(stream_000->native_stream) << "`" << oTRANSLATOROUTPUTLANGUAGEo.get() << "'" << " is not a valid case option";
        throw *new_stella_exception(stream_000->the_string_reader());
      }
    }
    return (files);
  }
}

boolean system_loadedP(char* name) {
  // Return `true' if system `name' has been loaded.
  { boolean test_value_000 = FALSE;

    if (string_equalP(name, "STELLA")) {
      test_value_000 = TRUE;
    }
    else {
      { boolean foundP_000 = FALSE;

        { System_Definition* sys = NULL;
          Cons* iter_000 = oSYSTEMDEFINITIONSo->the_cons_list;

          while (!(iter_000 == NIL)) {
            sys = ((System_Definition*)(iter_000->value));
            iter_000 = iter_000->rest;
            if (string_equalP(sys->name, name) &&
                sys->loadedP) {
              foundP_000 = TRUE;
              break;
            }
          }
        }
        test_value_000 = foundP_000;
      }
    }
    { boolean value_000 = test_value_000;

      return (value_000);
    }
  }
}

void load_preprocessed_files(char* systemname) {
  if ((!running_as_lispP()) ||
      (!((boolean)(get_system_definition(systemname)->preprocessed_files)))) {
    return;
  }
  { 
    BIND_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONo, System_Definition*, get_system_definition(systemname));
    BIND_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONSUBDIRECTORYo, char*, (((boolean)(oCURRENTSYSTEMDEFINITIONo.get())) ? oCURRENTSYSTEMDEFINITIONo.get()->directory : NULL));
    if (((boolean)(oCURRENTSYSTEMDEFINITIONo.get()))) {
      {
        { Cons* preprocessedfiles = NIL;

          { String_Wrapper* f = NULL;
            Cons* iter_000 = oCURRENTSYSTEMDEFINITIONo.get()->preprocessed_files;
            Cons* collect_000 = NULL;

            while (!(iter_000 == NIL)) {
              f = ((String_Wrapper*)(iter_000->value));
              iter_000 = iter_000->rest;
              if (!((boolean)(collect_000))) {
                {
                  collect_000 = cons(wrap_string(make_file_name(f->wrapper_value, KWD_SYSTEMS_STELLA, TRUE)), NIL);
                  if (preprocessedfiles == NIL) {
                    preprocessedfiles = collect_000;
                  }
                  else {
                    add_cons_to_end_of_cons_list(preprocessedfiles, collect_000);
                  }
                }
              }
              else {
                {
                  collect_000->rest = cons(wrap_string(make_file_name(f->wrapper_value, KWD_SYSTEMS_STELLA, TRUE)), NIL);
                  collect_000 = collect_000->rest;
                }
              }
            }
          }
          disable_environment_feature(1, KWD_SYSTEMS_WARN_ABOUT_UNDEFINED_METHODS);
          { Object* f = NULL;
            Cons* iter_001 = preprocessedfiles;

            while (!(iter_001 == NIL)) {
              f = iter_001->value;
              iter_001 = iter_001->rest;
              translate_file(((String_Wrapper*)(f))->wrapper_value, oTRANSLATOROUTPUTLANGUAGEo.get(), FALSE);
            }
          }
          enable_environment_feature(1, KWD_SYSTEMS_WARN_ABOUT_UNDEFINED_METHODS);
          { String_Wrapper* f = NULL;
            Cons* iter_002 = oCURRENTSYSTEMDEFINITIONo.get()->preprocessed_files;

            while (!(iter_002 == NIL)) {
              f = ((String_Wrapper*)(iter_002->value));
              iter_002 = iter_002->rest;
              compile_and_load_file(f->wrapper_value, oTRANSLATOROUTPUTLANGUAGEo.get(), FALSE);
              if (oCURRENT_ENVIRONMENT_FEATURESo->membP(KWD_SYSTEMS_USE_COMMON_LISP_STRUCTS)) {
                delete_file(make_file_name(f->wrapper_value, KWD_SYSTEMS_LISP, TRUE));
              }
            }
          }
          { Symbol* startupfn = NULL;
            Cons* iter_003 = startup_names_from_files(oCURRENTSYSTEMDEFINITIONo.get()->preprocessed_files);

            while (!(iter_003 == NIL)) {
              startupfn = ((Symbol*)(iter_003->value));
              iter_003 = iter_003->rest;
            }
          }
        }
      }
    }
    else {
      *(STANDARD_WARNING->native_stream) << "Warning: " << "Can't find a system named " << "`" << systemname << "'" << endl << endl;
    }
  }
}

boolean load_system(char* systemname, Keyword* language, int options, ...) {
  // Load (and compile out-of-date files) a simple system of 'files'.
  if (!running_as_lispP()) {
    return (FALSE);
  }
  language = ((Keyword*)(stellify(language)));
  { Property_List* self_000 = new_property_list();

    { Cons* arglist_000 = NIL;

      { Object* arg_000 = NULL;
        va_list iter_000;
        int iter_000_count = options;
        Cons* collect_000 = NULL;

        va_start(iter_000, options);
        while ((iter_000_count--) > 0) {
          arg_000 = va_arg(iter_000, Object*);
          if (!((boolean)(collect_000))) {
            {
              collect_000 = cons(arg_000, NIL);
              if (arglist_000 == NIL) {
                arglist_000 = collect_000;
              }
              else {
                add_cons_to_end_of_cons_list(arglist_000, collect_000);
              }
            }
          }
          else {
            {
              collect_000->rest = cons(arg_000, NIL);
              collect_000 = collect_000->rest;
            }
          }
        }
        va_end(iter_000);
      }
      self_000->the_plist = arglist_000;
    }
    { Property_List* plist = self_000;
      boolean forcerecompilationP = FALSE;
      boolean startupsystemP = TRUE;
      boolean translatedfileP = FALSE;

      vet_options(plist, get_quoted_tree("((:FORCE-RECOMPILATION? :STARTUP?) \"/STELLA\")", "/STELLA"));
      { Object* key = NULL;
        Object* value = NULL;
        Cons* iter_001 = plist->the_plist;

        while (!(iter_001 == NIL)) {
          key = iter_001->value;
          value = iter_001->rest->value;
          iter_001 = iter_001->rest->rest;
          { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(key));

            if (test_value_000 == KWD_SYSTEMS_FORCE_RECOMPILATIONp) {
              forcerecompilationP = eqlP(value, TRUE_WRAPPER);
            }
            else if (test_value_000 == KWD_SYSTEMS_STARTUPp) {
              startupsystemP = eqlP(value, TRUE_WRAPPER);
            }
            else {
              { Output_String_Stream* stream_000 = new_output_string_stream();

                *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
                throw *new_stella_exception(stream_000->the_string_reader());
              }
            }
          }
        }
      }
      { 
        BIND_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONo, System_Definition*, get_system_definition(systemname));
        BIND_STELLA_SPECIAL(oCURRENTSYSTEMDEFINITIONSUBDIRECTORYo, char*, (((boolean)(oCURRENTSYSTEMDEFINITIONo.get())) ? oCURRENTSYSTEMDEFINITIONo.get()->directory : NULL));
        if (((boolean)(oCURRENTSYSTEMDEFINITIONo.get()))) {
          {
            if (oCURRENTSYSTEMDEFINITIONo.get()->loadedP) {
              cout << "Loading system " << "`" << systemname << "'" << " over top of itself." << endl << endl;
            }
            { String_Wrapper* file = NULL;
              Cons* iter_002 = files_plus_system_startup(system_definition_native_files(oCURRENTSYSTEMDEFINITIONo.get()));

              while (!(iter_002 == NIL)) {
                file = ((String_Wrapper*)(iter_002->value));
                iter_002 = iter_002->rest;
                if (!(compile_and_load_file(file->wrapper_value, language, forcerecompilationP))) {
                  return (FALSE);
                }
                translatedfileP = TRUE;
              }
            }
            oCURRENTSYSTEMDEFINITIONo.get()->loadedP = TRUE;
            if (startupsystemP) {
              run_system_startup_function(oCURRENTSYSTEMDEFINITIONo.get());
            }
          }
        }
        else {
          *(STANDARD_WARNING->native_stream) << "Warning: " << "Can't find a system named " << "`" << systemname << "'" << endl << endl;
        }
      }
      return (translatedfileP);
    }
  }
}

boolean compile_and_load_file(char* file, Keyword* language, boolean forcerecompilationP) {
  if (language == KWD_SYSTEMS_COMMON_LISP) {
    cl_compile_and_load_file(file, TRUE, forcerecompilationP);
    return (TRUE);
  }
  else if (language == KWD_SYSTEMS_JAVA) {
    cout << "'compile-and-load-file' NOT IMPLEMENTED FOR :java" << endl;
    return (FALSE);
  }
  else if (language == KWD_SYSTEMS_CPP) {
    cout << "'compile-and-load-file' NOT IMPLEMENTED FOR :cpp" << endl;
    return (FALSE);
  }
  else {
    { Output_String_Stream* stream_000 = new_output_string_stream();

      *(stream_000->native_stream) << "`" << language << "'" << " is not a valid case option";
      throw *new_stella_exception(stream_000->the_string_reader());
    }
  }
}

void run_system_startup_function(System_Definition* system) {
  if (!running_as_lispP()) {
    return;
  }
}

char* System_Definition::system_startup_function_name() {
  { System_Definition* system = this;

    return (string_system_startup_function_name(system->name));
  }
}

char* string_system_startup_function_name(char* systemname) {
  return (string_upcase(string_concatenate("startup-", systemname, 1, "-system")));
}

Symbol* system_startup_function_symbol(System_Definition* system) {
  return (intern_symbol_in_module(system->system_startup_function_name(), get_cardinal_module(system), TRUE));
}

Symbol* startup_name_from_file(char* file) {
  if (!probe_fileP(make_file_name(file, KWD_SYSTEMS_STELLA, TRUE))) {
    return (NULL);
  }
  { char* longname = make_file_name(file, KWD_SYSTEMS_STELLA, TRUE);
    Input_File_Stream* inputstream = new_input_file_stream(longname);
    Module* savedmodule = oMODULEo.get();
    boolean seeninmoduleP = FALSE;
    boolean unusedP = FALSE;
    Symbol* startupfnname = NULL;

    { 
      BIND_STELLA_SPECIAL(oTRANSIENTOBJECTSpo, boolean, TRUE);
      { Object* tree = NULL;
        S_Expression_Iterator* iter_000 = s_expressions(inputstream);

        while (iter_000->nextP()) {
          tree = iter_000->value;
          { 
            BIND_STELLA_SPECIAL(oTRANSIENTOBJECTSpo, boolean, FALSE);
            if (safe_primary_type(tree) == SGT_SYSTEMS_STELLA_CONS) {
              { Object* tree_000 = tree;
                Cons* tree = ((Cons*)(tree_000));

                unusedP = handle_in_module_tree(tree, seeninmoduleP, seeninmoduleP);
                {
                }
                if (seeninmoduleP) {
                  startupfnname = yield_startup_function_name(file);
                  savedmodule->change_module();
                  inputstream->free();
                  return (startupfnname);
                }
              }
            }
            else {
            }
          }
        }
      }
    }
    *(STANDARD_WARNING->native_stream) << "Warning: " << "Missing IN-MODULE declaration for file " << "`" << file << "'" << endl << endl;
    return (NULL);
  }
}

Cons* startup_names_from_files(Cons* files) {
  { Cons* names = NIL;

    { String_Wrapper* f = NULL;
      Cons* iter_000 = files;
      Cons* collect_000 = NULL;

      while (!(iter_000 == NIL)) {
        f = ((String_Wrapper*)(iter_000->value));
        iter_000 = iter_000->rest;
        if (!((boolean)(collect_000))) {
          {
            collect_000 = cons(startup_name_from_file(f->wrapper_value), NIL);
            if (names == NIL) {
              names = collect_000;
            }
            else {
              add_cons_to_end_of_cons_list(names, collect_000);
            }
          }
        }
        else {
          {
            collect_000->rest = cons(startup_name_from_file(f->wrapper_value), NIL);
            collect_000 = collect_000->rest;
          }
        }
      }
    }
    return (names);
  }
}

char* system_startup_file_name(System_Definition* system) {
  if (!((boolean)(system))) {
    system = oCURRENTSYSTEMDEFINITIONo.get();
  }
  if (((boolean)(system))) {
    return ("startup-system");
  }
  else {
    return (NULL);
  }
}

boolean system_startup_fileP(char* file) {
  if (file == NULL) {
    file = oCURRENTFILEo.get();
  }
  return ((file != NULL) &&
      string_eqlP(file_base_name(file), system_startup_file_name(NULL)));
}

boolean system_started_upP(char* systemname, char* systemmodulename) {
  if (string_eqlP(string_upcase(systemname), "STELLA")) {
    return (((boolean)(oMODULEo.get())));
  }
  if (!((boolean)(get_stella_module(systemmodulename, FALSE)))) {
    return (FALSE);
  }
  { Symbol* startupfunctionsymbol = lookup_symbol_in_module(string_system_startup_function_name(systemname), get_stella_module(systemmodulename, FALSE), TRUE);
    Method_Slot* startupfunction = (((boolean)(startupfunctionsymbol)) ? lookup_function(startupfunctionsymbol) : ((Method_Slot*)(NULL)));

    return (((boolean)(startupfunction)) &&
        (startupfunction->function_code != NULL));
  }
}

Cons* yield_startup_required_systems(System_Definition* system) {
  { Cons* startupforms = NIL;

    { String_Wrapper* systemname = NULL;
      Cons* iter_000 = system->required_systems;
      Cons* collect_000 = NULL;

      while (!(iter_000 == NIL)) {
        systemname = ((String_Wrapper*)(iter_000->value));
        iter_000 = iter_000->rest;
        if (!((boolean)(collect_000))) {
          {
            collect_000 = cons(listO(4, SYM_SYSTEMS_STELLA_UNLESS, listO(3, SYM_SYSTEMS_STELLA_SYSTEM_STARTED_UPp, systemname, cons(wrap_string(get_cardinal_module(get_system_definition(systemname->wrapper_value))->module_full_name), NIL)), cons(system_startup_function_symbol(get_system_definition(systemname->wrapper_value)), NIL), NIL), NIL);
            if (startupforms == NIL) {
              startupforms = collect_000;
            }
            else {
              add_cons_to_end_of_cons_list(startupforms, collect_000);
            }
          }
        }
        else {
          {
            collect_000->rest = cons(listO(4, SYM_SYSTEMS_STELLA_UNLESS, listO(3, SYM_SYSTEMS_STELLA_SYSTEM_STARTED_UPp, systemname, cons(wrap_string(get_cardinal_module(get_system_definition(systemname->wrapper_value))->module_full_name), NIL)), cons(system_startup_function_symbol(get_system_definition(systemname->wrapper_value)), NIL), NIL), NIL);
            collect_000 = collect_000->rest;
          }
        }
      }
    }
    return (listO(3, SYM_SYSTEMS_STELLA_STARTUP_TIME_PROGN, KWD_SYSTEMS_EARLY_INITS, startupforms->concatenate(NIL, 0)));
  }
}

Cons* collect_startup_forms_from_system_file(System_Definition* system) {
  { char* systemfilename = make_system_definition_file_name(system->name);
    Input_File_Stream* inputstream = new_input_file_stream(systemfilename);
    Module* module = NULL;
    Cons* startupform = NULL;
    Cons* startupforms = NIL;

    { 
      BIND_STELLA_SPECIAL(oMODULEo, Module*, oMODULEo.get());
      BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
      { Object* tree = NULL;
        S_Expression_Iterator* iter_000 = s_expressions(inputstream);
        Cons* collect_000 = NULL;

        while (iter_000->nextP()) {
          tree = iter_000->value;
          startupform = NULL;
          if (safe_primary_type(tree) == SGT_SYSTEMS_STELLA_CONS) {
            { Object* tree_000 = tree;
              Cons* tree = ((Cons*)(tree_000));

              if (tree->value == SYM_SYSTEMS_STELLA_DEFMODULE) {
                evaluate(tree);
                module = get_stella_module(coerce_to_module_name(tree->rest->value, TRUE), TRUE);
                if (((boolean)(module))) {
                  startupform = listO(4, SYM_SYSTEMS_STELLA_STARTUP_TIME_PROGN, KWD_SYSTEMS_MODULES, yield_define_module(module), NIL);
                }
              }
              if (tree->value == SYM_SYSTEMS_STELLA_IN_MODULE) {
                evaluate(tree);
              }
            }
          }
          else {
          }
          if (!((boolean)(startupform))) {
            continue;
          }
          if (!((boolean)(collect_000))) {
            {
              collect_000 = cons(startupform, NIL);
              if (startupforms == NIL) {
                startupforms = collect_000;
              }
              else {
                add_cons_to_end_of_cons_list(startupforms, collect_000);
              }
            }
          }
          else {
            {
              collect_000->rest = cons(startupform, NIL);
              collect_000 = collect_000->rest;
            }
          }
        }
      }
    }
    return (startupforms);
  }
}

void create_system_startup_file(System_Definition* system) {
  if (!((boolean)(oCURRENTSYSTEMDEFINITIONo.get()))) {
    cout << "Must be within a system environment to create startup file " << endl << "   for system " << "`" << system->name << "'" << "." << endl << endl;
    return;
  }
  { 
    BIND_STELLA_SPECIAL(oMODULEo, Module*, get_cardinal_module(system));
    BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
    { char* file = make_file_name(system_startup_file_name(system), KWD_SYSTEMS_STELLA, TRUE);
      Output_File_Stream* outputstream = new_output_file_stream(file);
      Cons* startupfnnames = NIL;
      Cons* startupforms = NIL;

      { String_Wrapper* f = NULL;
        Cons* iter_000 = system_definition_source_files(system);
        Cons* collect_000 = NULL;

        while (!(iter_000 == NIL)) {
          f = ((String_Wrapper*)(iter_000->value));
          iter_000 = iter_000->rest;
          if (!((boolean)(collect_000))) {
            {
              collect_000 = cons(startup_name_from_file(f->wrapper_value), NIL);
              if (startupfnnames == NIL) {
                startupfnnames = collect_000;
              }
              else {
                add_cons_to_end_of_cons_list(startupfnnames, collect_000);
              }
            }
          }
          else {
            {
              collect_000->rest = cons(startup_name_from_file(f->wrapper_value), NIL);
              collect_000 = collect_000->rest;
            }
          }
        }
      }
      cl_output_file_header(outputstream, file);
      startupforms = cons(listO(3, SYM_SYSTEMS_STELLA_IN_MODULE, wrap_string(get_cardinal_module(system)->module_full_name), NIL), startupforms);
      startupforms = cons(listO(3, SYM_SYSTEMS_STELLA_DEFUN, system_startup_function_symbol(system), listO(4, NIL, KWD_SYSTEMS_PUBLICp, SYM_SYSTEMS_STELLA_TRUE, NIL)), startupforms);
      if (string_eqlP(string_upcase(system->name), "STELLA")) {
        startupforms = cons(listO(4, SYM_SYSTEMS_STELLA_STARTUP_TIME_PROGN, KWD_SYSTEMS_EARLY_INITS, listO(3, SYM_SYSTEMS_STELLA_STARTUP, SYM_SYSTEMS_STELLA_FALSE, NIL), NIL), startupforms);
      }
      else {
        if (((boolean)(system->required_systems))) {
          startupforms = cons(yield_startup_required_systems(system), startupforms);
        }
        { Cons* form = NULL;
          Cons* iter_001 = collect_startup_forms_from_system_file(system);

          while (!(iter_001 == NIL)) {
            form = ((Cons*)(iter_001->value));
            iter_001 = iter_001->rest;
            startupforms = cons(form, startupforms);
          }
        }
        { Symbol* startupfn = NULL;
          Cons* iter_002 = startupfnnames;

          while (!(iter_002 == NIL)) {
            startupfn = ((Symbol*)(iter_002->value));
            iter_002 = iter_002->rest;
            if (!((boolean)(lookup_function(startupfn)))) {
              { 
                BIND_STELLA_SPECIAL(oMODULEo, Module*, startupfn->home_module());
                BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
                define_method_from_parse_tree(listO(3, SYM_SYSTEMS_STELLA_DEFUN, startupfn, listO(4, NIL, KWD_SYSTEMS_PUBLICp, SYM_SYSTEMS_STELLA_TRUE, NIL)));
              }
            }
          }
        }
        { Cons* startupfncalls = NIL;

          { Symbol* startupfn = NULL;
            Cons* iter_003 = startupfnnames;
            Cons* collect_001 = NULL;

            while (!(iter_003 == NIL)) {
              startupfn = ((Symbol*)(iter_003->value));
              iter_003 = iter_003->rest;
              if (!((boolean)(collect_001))) {
                {
                  collect_001 = cons(cons(startupfn, NIL), NIL);
                  if (startupfncalls == NIL) {
                    startupfncalls = collect_001;
                  }
                  else {
                    add_cons_to_end_of_cons_list(startupfncalls, collect_001);
                  }
                }
              }
              else {
                {
                  collect_001->rest = cons(cons(startupfn, NIL), NIL);
                  collect_001 = collect_001->rest;
                }
              }
            }
          }
          startupforms = cons(listO(4, SYM_SYSTEMS_STELLA_STARTUP_TIME_PROGN, listO(7, SYM_SYSTEMS_STELLA_FOREACH, SYM_SYSTEMS_STELLA_PHASE, SYM_SYSTEMS_STELLA_IN, listO(4, SYM_SYSTEMS_STELLA_INTERVAL, listO(3, SYM_SYSTEMS_STELLA_PHASE_TO_INTEGER, KWD_SYSTEMS_EARLY_INITS, NIL), listO(3, SYM_SYSTEMS_STELLA_PHASE_TO_INTEGER, KWD_SYSTEMS_FINAL, NIL), NIL), SYM_SYSTEMS_STELLA_DO, listO(4, SYM_SYSTEMS_STELLA_SETQ, SYM_SYSTEMS_STELLA_oSTARTUP_TIME_PHASEo, SYM_SYSTEMS_STELLA_PHASE, NIL), startupfncalls->concatenate(NIL, 0)), listO(4, SYM_SYSTEMS_STELLA_SETQ, SYM_SYSTEMS_STELLA_oSTARTUP_TIME_PHASEo, wrap_integer(999), NIL), NIL), startupforms);
        }
      }
      { 
        BIND_STELLA_SPECIAL(oPRINTREADABLYpo, boolean, TRUE);
        BIND_STELLA_SPECIAL(oPRINTPRETTYpo, boolean, TRUE);
        { Cons* form = NULL;
          Cons* iter_004 = startupforms->reverse();

          while (!(iter_004 == NIL)) {
            form = ((Cons*)(iter_004->value));
            iter_004 = iter_004->rest;
            *(outputstream->native_stream) << form << endl << endl;
          }
        }
      }
      outputstream->free();
    }
  }
}

void make_stella(boolean forcerecompilationP) {
  make_system("STELLA", KWD_SYSTEMS_COMMON_LISP, cons_list(4, KWD_SYSTEMS_FORCE_TRANSLATIONp, (forcerecompilationP ? TRUE_WRAPPER : FALSE_WRAPPER), KWD_SYSTEMS_DEVELOPMENT_SETTINGSp, FALSE_WRAPPER));
}

String_Wrapper* parse_configuration_file_line(char* line, Wrapper*& _return1) {
  { int start = 0;
    int hashpos = string_position(line, '#', 0);
    int equalpos = string_position(line, '=', 0);
    int end = equalpos;
    int length = strlen(line);
    char* property = NULL;
    char* valuestring = NULL;
    Object* value = NULL;

    { boolean alwaysP_000 = TRUE;

      { int i = NULL_INTEGER;
        int iter_000 = 0;
        int upper_bound_000 = (((hashpos != NULL_INTEGER) ? hashpos : length)) - 1;

        while (iter_000 <= upper_bound_000) {
          i = iter_000;
          iter_000 = iter_000 + 1;
          if (!(oCHARACTER_TYPE_TABLEo[(int)(unsigned char) (line[i])] == KWD_SYSTEMS_WHITE_SPACE)) {
            alwaysP_000 = FALSE;
            break;
          }
        }
      }
      if (alwaysP_000) {
        _return1 = NULL;
        return (NULL);
      }
    }
    if ((equalpos == NULL_INTEGER) ||
        (equalpos == 0)) {
      *(STANDARD_WARNING->native_stream) << "Warning: " << "Illegal line in configuration file: " << "`" << line << "'" << endl;
      _return1 = NULL;
      return (NULL);
    }
    while (oCHARACTER_TYPE_TABLEo[(int)(unsigned char) (line[start])] == KWD_SYSTEMS_WHITE_SPACE) {
      start = start + 1;
    }
    while (oCHARACTER_TYPE_TABLEo[(int)(unsigned char) (line[(end - 1)])] == KWD_SYSTEMS_WHITE_SPACE) {
      end = end - 1;
    }
    if (end <= start) {
      *(STANDARD_WARNING->native_stream) << "Warning: " << "Illegal property in configuration file: " << "`" << line << "'" << endl;
      _return1 = NULL;
      return (NULL);
    }
    property = string_subsequence(line, start, end);
    valuestring = string_subsequence(line, equalpos + 1, length);
    if (string_equalP(valuestring, "TRUE")) {
      value = TRUE_WRAPPER;
    }
    else if (string_equalP(valuestring, "FALSE")) {
      value = FALSE_WRAPPER;
    }
    else {
      try {
        { Surrogate* test_value_000 = safe_primary_type(value = read_s_expression_from_string(valuestring));

          if (subtype_of_integerP(test_value_000) ||
              subtype_of_floatP(test_value_000)) {
          }
          else {
            value = wrap_string(valuestring);
          }
        }
      }
      catch (Read_Exception& _e) {
        Read_Exception* e = &_e;

        value = wrap_string(valuestring);
      }
    }
    _return1 = ((Wrapper*)(value));
    return (wrap_string(property));
  }
}

Key_Value_List* oSYSTEM_CONFIGURATION_TABLEo = NULL;

Key_Value_List* load_configuration_file(char* file) {
  // Read a configuration `file' and return its content as a configuration table.
  // Also enter each property read into the global system configuration table.
  // Assumes Java-style property file syntax.  Each property name is represented
  // as a wrapped string and each value as a wrapped string/integer/float or boolean.
  { Key_Value_List* configuration = new_key_value_list();

    { char* line = NULL;
      Line_Iterator* iter_000 = lines(new_input_file_stream(file));

      while (iter_000->nextP()) {
        line = iter_000->value;
        { String_Wrapper* key = NULL;
          Wrapper* value = NULL;

          key = parse_configuration_file_line(line, value);
          if (((boolean)(key))) {
            configuration->insert_at(key, value);
            oSYSTEM_CONFIGURATION_TABLEo->insert_at(key, value);
          }
        }
      }
    }
    return (configuration);
  }
}

Wrapper* lookup_configuration_property(char* property, Wrapper* defaultvalue, Key_Value_List* configuration) {
  // Lookup `property' in `configuration' and return its value.
  // Use the global system configuration table if `configuration' is NULL.  Return
  // `defaultValue' if `property' is not defined.
  if (!((boolean)(configuration))) {
    configuration = oSYSTEM_CONFIGURATION_TABLEo;
  }
  { Wrapper* value = ((Wrapper*)(configuration->lookup(wrap_string(property))));

    if (((boolean)(value))) {
      return (value);
    }
    else {
      return (defaultvalue);
    }
  }
}

Wrapper* set_configuration_property(char* property, Wrapper* value, Key_Value_List* configuration) {
  // Set `property' in `configuration' to `value' and return it.
  // Use the global system configuration table if `configuration' is NULL.
  if (!((boolean)(configuration))) {
    configuration = oSYSTEM_CONFIGURATION_TABLEo;
  }
  configuration->insert_at(wrap_string(property), value);
  return (value);
}

void configure_stella(char* file) {
  // Perform STELLA run-time configuration.  If supplied, load the
  // configuration file `file' first which should be supplied with a physical pathname.
  if ((file != NULL) &&
      probe_fileP(file)) {
    load_configuration_file(file);
  }
  define_logical_host_property("PL", KWD_SYSTEMS_ROOT_DIRECTORY, lookup_configuration_property("PowerLoomRootDirectory", NULL, NULL));
}

void help_startup_systems1() {
  {
    KWD_SYSTEMS_DEFINE = ((Keyword*)(intern_rigid_symbol_wrt_module("DEFINE", NULL, 2)));
    SGT_SYSTEMS_STELLA_CONS = ((Surrogate*)(intern_rigid_symbol_wrt_module("CONS", NULL, 1)));
    SYM_SYSTEMS_STELLA_IN_MODULE = ((Symbol*)(intern_rigid_symbol_wrt_module("IN-MODULE", NULL, 0)));
    KWD_SYSTEMS_FINALIZE = ((Keyword*)(intern_rigid_symbol_wrt_module("FINALIZE", NULL, 2)));
    SYM_SYSTEMS_STELLA_DEFMODULE = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFMODULE", NULL, 0)));
    SYM_SYSTEMS_STELLA_DEFSYSTEM = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFSYSTEM", NULL, 0)));
    SYM_SYSTEMS_STELLA_DEFCLASS = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFCLASS", NULL, 0)));
    SYM_SYSTEMS_STELLA_DEFSLOT = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFSLOT", NULL, 0)));
    SYM_SYSTEMS_STELLA_DEFUN = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFUN", NULL, 0)));
    SYM_SYSTEMS_STELLA_DEFMETHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFMETHOD", NULL, 0)));
    KWD_SYSTEMS_DIRECTORY = ((Keyword*)(intern_rigid_symbol_wrt_module("DIRECTORY", NULL, 2)));
    KWD_SYSTEMS_FILES = ((Keyword*)(intern_rigid_symbol_wrt_module("FILES", NULL, 2)));
    KWD_SYSTEMS_REQUIRED_SYSTEMS = ((Keyword*)(intern_rigid_symbol_wrt_module("REQUIRED-SYSTEMS", NULL, 2)));
    KWD_SYSTEMS_LISP_ONLY_FILES = ((Keyword*)(intern_rigid_symbol_wrt_module("LISP-ONLY-FILES", NULL, 2)));
    KWD_SYSTEMS_CPP_ONLY_FILES = ((Keyword*)(intern_rigid_symbol_wrt_module("CPP-ONLY-FILES", NULL, 2)));
    KWD_SYSTEMS_JAVA_ONLY_FILES = ((Keyword*)(intern_rigid_symbol_wrt_module("JAVA-ONLY-FILES", NULL, 2)));
    KWD_SYSTEMS_PREPROCESSED_FILES = ((Keyword*)(intern_rigid_symbol_wrt_module("PREPROCESSED-FILES", NULL, 2)));
    KWD_SYSTEMS_CARDINAL_MODULE = ((Keyword*)(intern_rigid_symbol_wrt_module("CARDINAL-MODULE", NULL, 2)));
    KWD_SYSTEMS_ROOT_SOURCE_DIRECTORY = ((Keyword*)(intern_rigid_symbol_wrt_module("ROOT-SOURCE-DIRECTORY", NULL, 2)));
    KWD_SYSTEMS_ROOT_NATIVE_DIRECTORY = ((Keyword*)(intern_rigid_symbol_wrt_module("ROOT-NATIVE-DIRECTORY", NULL, 2)));
    KWD_SYSTEMS_ROOT_BINARY_DIRECTORY = ((Keyword*)(intern_rigid_symbol_wrt_module("ROOT-BINARY-DIRECTORY", NULL, 2)));
    KWD_SYSTEMS_BANNER = ((Keyword*)(intern_rigid_symbol_wrt_module("BANNER", NULL, 2)));
    KWD_SYSTEMS_COPYRIGHT_HEADER = ((Keyword*)(intern_rigid_symbol_wrt_module("COPYRIGHT-HEADER", NULL, 2)));
    KWD_SYSTEMS_PRODUCTION_SETTINGS = ((Keyword*)(intern_rigid_symbol_wrt_module("PRODUCTION-SETTINGS", NULL, 2)));
    KWD_SYSTEMS_DEVELOPMENT_SETTINGS = ((Keyword*)(intern_rigid_symbol_wrt_module("DEVELOPMENT-SETTINGS", NULL, 2)));
    KWD_SYSTEMS_FINALIZATION_FUNCTION = ((Keyword*)(intern_rigid_symbol_wrt_module("FINALIZATION-FUNCTION", NULL, 2)));
    KWD_SYSTEMS_JAVA = ((Keyword*)(intern_rigid_symbol_wrt_module("JAVA", NULL, 2)));
    KWD_SYSTEMS_LISP = ((Keyword*)(intern_rigid_symbol_wrt_module("LISP", NULL, 2)));
    KWD_SYSTEMS_CPP = ((Keyword*)(intern_rigid_symbol_wrt_module("CPP", NULL, 2)));
    KWD_SYSTEMS_LISP_BINARY = ((Keyword*)(intern_rigid_symbol_wrt_module("LISP-BINARY", NULL, 2)));
    SGT_SYSTEMS_STELLA_PROPERTY_LIST = ((Surrogate*)(intern_rigid_symbol_wrt_module("PROPERTY-LIST", NULL, 1)));
    SGT_SYSTEMS_STELLA_LIST = ((Surrogate*)(intern_rigid_symbol_wrt_module("LIST", NULL, 1)));
    KWD_SYSTEMS_COMMON_LISP = ((Keyword*)(intern_rigid_symbol_wrt_module("COMMON-LISP", NULL, 2)));
    KWD_SYSTEMS_DEVELOPMENT_SETTINGSp = ((Keyword*)(intern_rigid_symbol_wrt_module("DEVELOPMENT-SETTINGS?", NULL, 2)));
    KWD_SYSTEMS_FORCE_TRANSLATIONp = ((Keyword*)(intern_rigid_symbol_wrt_module("FORCE-TRANSLATION?", NULL, 2)));
    KWD_SYSTEMS_FORCE_RECOMPILATIONp = ((Keyword*)(intern_rigid_symbol_wrt_module("FORCE-RECOMPILATION?", NULL, 2)));
    KWD_SYSTEMS_TWO_PASSp = ((Keyword*)(intern_rigid_symbol_wrt_module("TWO-PASS?", NULL, 2)));
    KWD_SYSTEMS_LOAD_SYSTEMp = ((Keyword*)(intern_rigid_symbol_wrt_module("LOAD-SYSTEM?", NULL, 2)));
    KWD_SYSTEMS_STARTUPp = ((Keyword*)(intern_rigid_symbol_wrt_module("STARTUP?", NULL, 2)));
    KWD_SYSTEMS_USE_COMMON_LISP_STRUCTS = ((Keyword*)(intern_rigid_symbol_wrt_module("USE-COMMON-LISP-STRUCTS", NULL, 2)));
    KWD_SYSTEMS_STELLA = ((Keyword*)(intern_rigid_symbol_wrt_module("STELLA", NULL, 2)));
    KWD_SYSTEMS_WARN_ABOUT_UNDEFINED_METHODS = ((Keyword*)(intern_rigid_symbol_wrt_module("WARN-ABOUT-UNDEFINED-METHODS", NULL, 2)));
    SYM_SYSTEMS_STELLA_UNLESS = ((Symbol*)(intern_rigid_symbol_wrt_module("UNLESS", NULL, 0)));
    SYM_SYSTEMS_STELLA_SYSTEM_STARTED_UPp = ((Symbol*)(intern_rigid_symbol_wrt_module("SYSTEM-STARTED-UP?", NULL, 0)));
    SYM_SYSTEMS_STELLA_STARTUP_TIME_PROGN = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-TIME-PROGN", NULL, 0)));
    KWD_SYSTEMS_EARLY_INITS = ((Keyword*)(intern_rigid_symbol_wrt_module("EARLY-INITS", NULL, 2)));
    KWD_SYSTEMS_MODULES = ((Keyword*)(intern_rigid_symbol_wrt_module("MODULES", NULL, 2)));
    KWD_SYSTEMS_PUBLICp = ((Keyword*)(intern_rigid_symbol_wrt_module("PUBLIC?", NULL, 2)));
    SYM_SYSTEMS_STELLA_TRUE = ((Symbol*)(intern_rigid_symbol_wrt_module("TRUE", NULL, 0)));
    SYM_SYSTEMS_STELLA_STARTUP = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP", NULL, 0)));
    SYM_SYSTEMS_STELLA_FALSE = ((Symbol*)(intern_rigid_symbol_wrt_module("FALSE", NULL, 0)));
    SYM_SYSTEMS_STELLA_FOREACH = ((Symbol*)(intern_rigid_symbol_wrt_module("FOREACH", NULL, 0)));
    SYM_SYSTEMS_STELLA_PHASE = ((Symbol*)(intern_rigid_symbol_wrt_module("PHASE", NULL, 0)));
    SYM_SYSTEMS_STELLA_IN = ((Symbol*)(intern_rigid_symbol_wrt_module("IN", NULL, 0)));
    SYM_SYSTEMS_STELLA_INTERVAL = ((Symbol*)(intern_rigid_symbol_wrt_module("INTERVAL", NULL, 0)));
    SYM_SYSTEMS_STELLA_PHASE_TO_INTEGER = ((Symbol*)(intern_rigid_symbol_wrt_module("PHASE-TO-INTEGER", NULL, 0)));
    KWD_SYSTEMS_FINAL = ((Keyword*)(intern_rigid_symbol_wrt_module("FINAL", NULL, 2)));
    SYM_SYSTEMS_STELLA_DO = ((Symbol*)(intern_rigid_symbol_wrt_module("DO", NULL, 0)));
    SYM_SYSTEMS_STELLA_SETQ = ((Symbol*)(intern_rigid_symbol_wrt_module("SETQ", NULL, 0)));
    SYM_SYSTEMS_STELLA_oSTARTUP_TIME_PHASEo = ((Symbol*)(intern_rigid_symbol_wrt_module("*STARTUP-TIME-PHASE*", NULL, 0)));
  }
}

void startup_systems() {
  { 
    BIND_STELLA_SPECIAL(oMODULEo, Module*, oSTELLA_MODULEo);
    BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
    if (current_startup_time_phaseP(2)) {
      help_startup_systems1();
      KWD_SYSTEMS_WHITE_SPACE = ((Keyword*)(intern_rigid_symbol_wrt_module("WHITE-SPACE", NULL, 2)));
      SYM_SYSTEMS_STELLA_CONFIGURATION_TABLE = ((Symbol*)(intern_rigid_symbol_wrt_module("CONFIGURATION-TABLE", NULL, 0)));
      KWD_SYSTEMS_ROOT_DIRECTORY = ((Keyword*)(intern_rigid_symbol_wrt_module("ROOT-DIRECTORY", NULL, 2)));
      SYM_SYSTEMS_STELLA_STARTUP_SYSTEMS = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-SYSTEMS", NULL, 0)));
      SYM_SYSTEMS_STELLA_METHOD_STARTUP_CLASSNAME = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-STARTUP-CLASSNAME", NULL, 0)));
    }
    if (current_startup_time_phaseP(4)) {
      oSYSTEMDEFINITIONSo = new_list();
      oSYSTEM_CONFIGURATION_TABLEo = new_key_value_list();
    }
    if (current_startup_time_phaseP(5)) {
      define_stella_type_from_stringified_source("(DEFTYPE CONFIGURATION-TABLE (KEY-VALUE-LIST OF STRING-WRAPPER WRAPPER))");
    }
    if (current_startup_time_phaseP(6)) {
      finalize_classes();
    }
    if (current_startup_time_phaseP(7)) {
      define_function_object("EVALUATE-COMMAND", "(DEFUN (EVALUATE-COMMAND OBJECT) ((COMMAND OBJECT) (FINALIZE? BOOLEAN)))", ((cpp_function_code)(&evaluate_command)), NULL);
      define_function_object("LOAD-FILE", "(DEFUN LOAD-FILE ((FILE STRING)) :DOCUMENTATION \"Read logic commands from `file' and evaluate them.\nThe file should begin with an `in-module' declaration that specifies\nthe module within which all remaining commands are to be evaluated\nThe remaining commands are evaluated one-by-one, applying the function\n`evaluate' to each of them.\" :COMMAND? TRUE :PUBLIC? TRUE)", ((cpp_function_code)(&load_file)), ((cpp_function_code)(&load_file_evaluator_wrapper)));
      define_function_object("MAKE-SYSTEM-DEFINITION-FILE-NAME", "(DEFUN (MAKE-SYSTEM-DEFINITION-FILE-NAME FILE-NAME) ((NAME STRING)))", ((cpp_function_code)(&make_system_definition_file_name)), NULL);
      define_function_object("PARSE-LIST-OF-FILE-PATHS", "(DEFUN (PARSE-LIST-OF-FILE-PATHS (CONS OF STRING-WRAPPER)) ((FILES CONS)))", ((cpp_function_code)(&parse_list_of_file_paths)), NULL);
      define_function_object("DEFINE-SYSTEM", "(DEFUN (DEFINE-SYSTEM SYSTEM-DEFINITION) ((NAME OBJECT) (OPTIONS CONS)))", ((cpp_function_code)(&define_system)), NULL);
      define_function_object("DEFSYSTEM", "(DEFUN (DEFSYSTEM SYSTEM-DEFINITION) ((NAME SYMBOL) |&REST| (OPTIONS OBJECT)) :COMMAND? TRUE :EVALUATE-ARGUMENTS? FALSE :PUBLIC? TRUE :DOCUMENTATION \"Define a system of files that collectively define\na Stella application.\n   Required options are:\n   :directory -- the path from the Stella root directory to the directory\n                 containing the system files.  Can be a string or a list\n                 of strings (do not include directory separators).\n   :files -- a list of files in the system, containing strings and lists\n             of strings; the latter defines exploded paths to files\n             in subdirectories.\n   Optional options are:\n   :required-systems -- a list of systems (strings) that should be loaded\n                        prior to loading this system.\n   :cardinal-module -- the name (a string) of the principal module for this\n                       system.\")", ((cpp_function_code)(&defsystem)), ((cpp_function_code)(&defsystem_evaluator_wrapper)));
      define_function_object("GET-SYSTEM-DEFINITION", "(DEFUN (GET-SYSTEM-DEFINITION SYSTEM-DEFINITION) ((NAME STRING)))", ((cpp_function_code)(&get_system_definition)), NULL);
      define_function_object("GET-CARDINAL-MODULE", "(DEFUN (GET-CARDINAL-MODULE MODULE) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&get_cardinal_module)), NULL);
      define_function_object("HELP-GET-SYSTEM-FILES", "(DEFUN HELP-GET-SYSTEM-FILES ((FILENAME FILE-NAME) (COLLECTION LIST) (PROBEFILE? BOOLEAN)))", ((cpp_function_code)(&help_get_system_files)), NULL);
      define_function_object("GET-SYSTEM-FILES", "(DEFUN (GET-SYSTEM-FILES (LIST OF STRING-WRAPPER)) ((SYSTEM SYSTEM-DEFINITION) (TYPE KEYWORD) (PROBEFILES? BOOLEAN)))", ((cpp_function_code)(&get_system_files)), NULL);
      define_function_object("CLEAN-SYSTEM", "(DEFUN CLEAN-SYSTEM ((SYSTEMNAME STRING)))", ((cpp_function_code)(&clean_system)), NULL);
      define_function_object("COMPUTE-OPTIMIZATION-LEVELS", "(DEFUN COMPUTE-OPTIMIZATION-LEVELS ((SYSTEM SYSTEM-DEFINITION) (PRODUCTIONMODE? BOOLEAN)))", ((cpp_function_code)(&compute_optimization_levels)), NULL);
      define_function_object("LISP-KEYWORD-TO-STELLA-KEYWORD", "(DEFUN (LISP-KEYWORD-TO-STELLA-KEYWORD KEYWORD) ((KEY KEYWORD)))", ((cpp_function_code)(&lisp_keyword_to_stella_keyword)), NULL);
      define_function_object("VET-OPTIONS", "(DEFUN (VET-OPTIONS PROPERTY-LIST) ((PLIST OBJECT) (LEGALOPTIONS (CONS OF KEYWORD))))", ((cpp_function_code)(&vet_options)), NULL);
      define_function_object("MAKE-SYSTEM", "(DEFUN (MAKE-SYSTEM BOOLEAN) ((SYSTEMNAME STRING) (LANGUAGE KEYWORD) |&REST| (OPTIONS OBJECT)) :DOCUMENTATION \"Translate, compile and load all out-of-date files in `files'.\nIf :development-settings? is set, translate with safety set to high; otherwise,\nuse production mode settings (defined in the 'defsystem').\nIf :force-recompilation? is `true', retranslate/recompile the entire system.\nIf :two-pass?, the translator makes two passes over the source files.\nOtherwise, the translator will make one pass in the case that the\nsystem is already loaded (and is being remade), and two passes otherwise.\nRuns system startup functions unless :startup? is set to `false'.\nIf :load-system? is FALSE, then files are translated but not loaded.\" :PUBLIC? TRUE :COMMAND? TRUE)", ((cpp_function_code)(&make_system)), ((cpp_function_code)(&make_system_evaluator_wrapper)));
      define_function_object("RUN-SYSTEM-FINALIZATION", "(DEFUN RUN-SYSTEM-FINALIZATION ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&run_system_finalization)), NULL);
      define_function_object("SYSTEM-DEFINITION-SOURCE-FILES", "(DEFUN (SYSTEM-DEFINITION-SOURCE-FILES (CONS OF STRING-WRAPPER)) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&system_definition_source_files)), NULL);
      define_function_object("FILES-PLUS-SYSTEM-STARTUP", "(DEFUN (FILES-PLUS-SYSTEM-STARTUP (CONS OF STRING-WRAPPER)) ((FILES (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&files_plus_system_startup)), NULL);
      define_function_object("SYSTEM-DEFINITION-NATIVE-FILES", "(DEFUN (SYSTEM-DEFINITION-NATIVE-FILES (CONS OF STRING-WRAPPER)) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&system_definition_native_files)), NULL);
      define_function_object("SYSTEM-LOADED?", "(DEFUN (SYSTEM-LOADED? BOOLEAN) ((NAME STRING)) :DOCUMENTATION \"Return `true' if system `name' has been loaded.\" :PUBLIC? TRUE)", ((cpp_function_code)(&system_loadedP)), NULL);
      define_function_object("LOAD-PREPROCESSED-FILES", "(DEFUN LOAD-PREPROCESSED-FILES ((SYSTEMNAME STRING)))", ((cpp_function_code)(&load_preprocessed_files)), NULL);
      define_function_object("LOAD-SYSTEM", "(DEFUN (LOAD-SYSTEM BOOLEAN) ((SYSTEMNAME STRING) (LANGUAGE KEYWORD) |&REST| (OPTIONS OBJECT)) :DOCUMENTATION \"Load (and compile out-of-date files) a simple system of 'files'.\" :PUBLIC? TRUE)", ((cpp_function_code)(&load_system)), NULL);
      define_function_object("COMPILE-AND-LOAD-FILE", "(DEFUN (COMPILE-AND-LOAD-FILE BOOLEAN) ((FILE FILE-NAME) (LANGUAGE KEYWORD) (FORCERECOMPILATION? BOOLEAN)))", ((cpp_function_code)(&compile_and_load_file)), NULL);
      define_function_object("RUN-SYSTEM-STARTUP-FUNCTION", "(DEFUN RUN-SYSTEM-STARTUP-FUNCTION ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&run_system_startup_function)), NULL);
      define_method_object("(DEFMETHOD (SYSTEM-STARTUP-FUNCTION-NAME STRING) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_method_code)(&System_Definition::system_startup_function_name)), ((cpp_method_code)(NULL)));
      define_method_object("(DEFMETHOD (SYSTEM-STARTUP-FUNCTION-NAME STRING) ((SYSTEMNAME STRING)))", ((cpp_method_code)(NULL)), ((cpp_method_code)(NULL)));
      define_function_object("SYSTEM-STARTUP-FUNCTION-SYMBOL", "(DEFUN (SYSTEM-STARTUP-FUNCTION-SYMBOL SYMBOL) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&system_startup_function_symbol)), NULL);
      define_function_object("STARTUP-NAME-FROM-FILE", "(DEFUN (STARTUP-NAME-FROM-FILE SYMBOL) ((FILE FILE-NAME)))", ((cpp_function_code)(&startup_name_from_file)), NULL);
      define_function_object("STARTUP-NAMES-FROM-FILES", "(DEFUN (STARTUP-NAMES-FROM-FILES (CONS OF SYMBOL)) ((FILES (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&startup_names_from_files)), NULL);
      define_function_object("SYSTEM-STARTUP-FILE-NAME", "(DEFUN (SYSTEM-STARTUP-FILE-NAME STRING) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&system_startup_file_name)), NULL);
      define_function_object("SYSTEM-STARTUP-FILE?", "(DEFUN (SYSTEM-STARTUP-FILE? BOOLEAN) ((FILE FILE-NAME)))", ((cpp_function_code)(&system_startup_fileP)), NULL);
      define_function_object("SYSTEM-STARTED-UP?", "(DEFUN (SYSTEM-STARTED-UP? BOOLEAN) ((SYSTEMNAME STRING) (SYSTEMMODULENAME STRING)))", ((cpp_function_code)(&system_started_upP)), NULL);
      define_function_object("YIELD-STARTUP-REQUIRED-SYSTEMS", "(DEFUN (YIELD-STARTUP-REQUIRED-SYSTEMS CONS) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&yield_startup_required_systems)), NULL);
      define_function_object("COLLECT-STARTUP-FORMS-FROM-SYSTEM-FILE", "(DEFUN (COLLECT-STARTUP-FORMS-FROM-SYSTEM-FILE (CONS OF CONS)) ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&collect_startup_forms_from_system_file)), NULL);
      define_function_object("CREATE-SYSTEM-STARTUP-FILE", "(DEFUN CREATE-SYSTEM-STARTUP-FILE ((SYSTEM SYSTEM-DEFINITION)))", ((cpp_function_code)(&create_system_startup_file)), NULL);
      define_function_object("MAKE-STELLA", "(DEFUN MAKE-STELLA ((FORCERECOMPILATION? BOOLEAN)))", ((cpp_function_code)(&make_stella)), NULL);
      define_function_object("PARSE-CONFIGURATION-FILE-LINE", "(DEFUN (PARSE-CONFIGURATION-FILE-LINE STRING-WRAPPER WRAPPER) ((LINE STRING)))", ((cpp_function_code)(&parse_configuration_file_line)), NULL);
      define_function_object("LOAD-CONFIGURATION-FILE", "(DEFUN (LOAD-CONFIGURATION-FILE CONFIGURATION-TABLE) ((FILE FILE-NAME)) :DOCUMENTATION \"Read a configuration `file' and return its content as a configuration table.\nAlso enter each property read into the global system configuration table.\nAssumes Java-style property file syntax.  Each property name is represented\nas a wrapped string and each value as a wrapped string/integer/float or boolean.\" :PUBLIC? TRUE)", ((cpp_function_code)(&load_configuration_file)), NULL);
      define_function_object("LOOKUP-CONFIGURATION-PROPERTY", "(DEFUN (LOOKUP-CONFIGURATION-PROPERTY WRAPPER) ((PROPERTY STRING) (DEFAULTVALUE WRAPPER) (CONFIGURATION CONFIGURATION-TABLE)) :DOCUMENTATION \"Lookup `property' in `configuration' and return its value.\nUse the global system configuration table if `configuration' is NULL.  Return\n`defaultValue' if `property' is not defined.\" :PUBLIC? TRUE)", ((cpp_function_code)(&lookup_configuration_property)), NULL);
      define_function_object("SET-CONFIGURATION-PROPERTY", "(DEFUN (SET-CONFIGURATION-PROPERTY WRAPPER) ((PROPERTY STRING) (VALUE WRAPPER) (CONFIGURATION CONFIGURATION-TABLE)) :DOCUMENTATION \"Set `property' in `configuration' to `value' and return it.\nUse the global system configuration table if `configuration' is NULL.\" :PUBLIC? TRUE)", ((cpp_function_code)(&set_configuration_property)), NULL);
      define_function_object("CONFIGURE-STELLA", "(DEFUN CONFIGURE-STELLA ((FILE FILE-NAME)) :DOCUMENTATION \"Perform STELLA run-time configuration.  If supplied, load the\nconfiguration file `file' first which should be supplied with a physical pathname.\" :PUBLIC? TRUE)", ((cpp_function_code)(&configure_stella)), NULL);
      define_function_object("STARTUP-SYSTEMS", "(DEFUN STARTUP-SYSTEMS () :PUBLIC? TRUE)", ((cpp_function_code)(&startup_systems)), NULL);
      { Method_Slot* function = lookup_function(SYM_SYSTEMS_STELLA_STARTUP_SYSTEMS);

        set_dynamic_slot_value(function->dynamic_slots, SYM_SYSTEMS_STELLA_METHOD_STARTUP_CLASSNAME, wrap_string("Startup-Systems"), NULL_STRING_WRAPPER);
      }
    }
    if (current_startup_time_phaseP(8)) {
      finalize_slots();
      cleanup_unfinalized_classes();
    }
    if (current_startup_time_phaseP(9)) {
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *SYSTEMDEFINITIONS* (LIST OF SYSTEM-DEFINITION) (NEW LIST) :DOCUMENTATION \"A list of all defined systems.\")");
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *SYSTEM-CONFIGURATION-TABLE* CONFIGURATION-TABLE (NEW CONFIGURATION-TABLE))");
    }
  }
}

Keyword* KWD_SYSTEMS_DEFINE = NULL;

Surrogate* SGT_SYSTEMS_STELLA_CONS = NULL;

Symbol* SYM_SYSTEMS_STELLA_IN_MODULE = NULL;

Keyword* KWD_SYSTEMS_FINALIZE = NULL;

Symbol* SYM_SYSTEMS_STELLA_DEFMODULE = NULL;

Symbol* SYM_SYSTEMS_STELLA_DEFSYSTEM = NULL;

Symbol* SYM_SYSTEMS_STELLA_DEFCLASS = NULL;

Symbol* SYM_SYSTEMS_STELLA_DEFSLOT = NULL;

Symbol* SYM_SYSTEMS_STELLA_DEFUN = NULL;

Symbol* SYM_SYSTEMS_STELLA_DEFMETHOD = NULL;

Keyword* KWD_SYSTEMS_DIRECTORY = NULL;

Keyword* KWD_SYSTEMS_FILES = NULL;

Keyword* KWD_SYSTEMS_REQUIRED_SYSTEMS = NULL;

Keyword* KWD_SYSTEMS_LISP_ONLY_FILES = NULL;

Keyword* KWD_SYSTEMS_CPP_ONLY_FILES = NULL;

Keyword* KWD_SYSTEMS_JAVA_ONLY_FILES = NULL;

Keyword* KWD_SYSTEMS_PREPROCESSED_FILES = NULL;

Keyword* KWD_SYSTEMS_CARDINAL_MODULE = NULL;

Keyword* KWD_SYSTEMS_ROOT_SOURCE_DIRECTORY = NULL;

Keyword* KWD_SYSTEMS_ROOT_NATIVE_DIRECTORY = NULL;

Keyword* KWD_SYSTEMS_ROOT_BINARY_DIRECTORY = NULL;

Keyword* KWD_SYSTEMS_BANNER = NULL;

Keyword* KWD_SYSTEMS_COPYRIGHT_HEADER = NULL;

Keyword* KWD_SYSTEMS_PRODUCTION_SETTINGS = NULL;

Keyword* KWD_SYSTEMS_DEVELOPMENT_SETTINGS = NULL;

Keyword* KWD_SYSTEMS_FINALIZATION_FUNCTION = NULL;

Keyword* KWD_SYSTEMS_JAVA = NULL;

Keyword* KWD_SYSTEMS_LISP = NULL;

Keyword* KWD_SYSTEMS_CPP = NULL;

Keyword* KWD_SYSTEMS_LISP_BINARY = NULL;

Surrogate* SGT_SYSTEMS_STELLA_PROPERTY_LIST = NULL;

Surrogate* SGT_SYSTEMS_STELLA_LIST = NULL;

Keyword* KWD_SYSTEMS_COMMON_LISP = NULL;

Keyword* KWD_SYSTEMS_DEVELOPMENT_SETTINGSp = NULL;

Keyword* KWD_SYSTEMS_FORCE_TRANSLATIONp = NULL;

Keyword* KWD_SYSTEMS_FORCE_RECOMPILATIONp = NULL;

Keyword* KWD_SYSTEMS_TWO_PASSp = NULL;

Keyword* KWD_SYSTEMS_LOAD_SYSTEMp = NULL;

Keyword* KWD_SYSTEMS_STARTUPp = NULL;

Keyword* KWD_SYSTEMS_USE_COMMON_LISP_STRUCTS = NULL;

Keyword* KWD_SYSTEMS_STELLA = NULL;

Keyword* KWD_SYSTEMS_WARN_ABOUT_UNDEFINED_METHODS = NULL;

Symbol* SYM_SYSTEMS_STELLA_UNLESS = NULL;

Symbol* SYM_SYSTEMS_STELLA_SYSTEM_STARTED_UPp = NULL;

Symbol* SYM_SYSTEMS_STELLA_STARTUP_TIME_PROGN = NULL;

Keyword* KWD_SYSTEMS_EARLY_INITS = NULL;

Keyword* KWD_SYSTEMS_MODULES = NULL;

Keyword* KWD_SYSTEMS_PUBLICp = NULL;

Symbol* SYM_SYSTEMS_STELLA_TRUE = NULL;

Symbol* SYM_SYSTEMS_STELLA_STARTUP = NULL;

Symbol* SYM_SYSTEMS_STELLA_FALSE = NULL;

Symbol* SYM_SYSTEMS_STELLA_FOREACH = NULL;

Symbol* SYM_SYSTEMS_STELLA_PHASE = NULL;

Symbol* SYM_SYSTEMS_STELLA_IN = NULL;

Symbol* SYM_SYSTEMS_STELLA_INTERVAL = NULL;

Symbol* SYM_SYSTEMS_STELLA_PHASE_TO_INTEGER = NULL;

Keyword* KWD_SYSTEMS_FINAL = NULL;

Symbol* SYM_SYSTEMS_STELLA_DO = NULL;

Symbol* SYM_SYSTEMS_STELLA_SETQ = NULL;

Symbol* SYM_SYSTEMS_STELLA_oSTARTUP_TIME_PHASEo = NULL;

Keyword* KWD_SYSTEMS_WHITE_SPACE = NULL;

Symbol* SYM_SYSTEMS_STELLA_CONFIGURATION_TABLE = NULL;

Keyword* KWD_SYSTEMS_ROOT_DIRECTORY = NULL;

Symbol* SYM_SYSTEMS_STELLA_STARTUP_SYSTEMS = NULL;

Symbol* SYM_SYSTEMS_STELLA_METHOD_STARTUP_CLASSNAME = NULL;

} // end of namespace stella
