// cpp-translate.cc

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

#include "stella/stella-system.hh"

namespace stella {

boolean cpp_use_garbage_collectorP() {
  return (oCURRENT_ENVIRONMENT_FEATURESo->memberP(KWD_CPP_TRANSLATE_USE_CPP_GARBAGE_COLLECTOR));
}

// Temporary List of declarations for unused return parameters
DEFINE_STELLA_SPECIAL(oDUMMYDECLARATIONSo, Cons* , NULL);

// Current index of dummy parameter for unused return value
DEFINE_STELLA_SPECIAL(oCURRENTDUMMYINDEXo, int , NULL_INTEGER);

// Mapping from STELLA operators to C++ operators
Key_Value_List* oOPERATOR_TABLEo = NULL;

Cons* cpp_lookup_operator_table(Symbol* renamed_Operator) {
  { Cons* entry = ((Cons*)(oOPERATOR_TABLEo->lookup(renamed_Operator)));
    Cons* copiedentry = NIL;

    if (((boolean)(entry))) {
      { String_Wrapper* wrapper = NULL;
        Cons* iter_000 = entry;
        Cons* collect_000 = NULL;

        while (!(iter_000 == NIL)) {
          wrapper = ((String_Wrapper*)(iter_000->value));
          iter_000 = iter_000->rest;
          if (!((boolean)(collect_000))) {
            {
              collect_000 = cons(wrap_string(wrapper->wrapper_value), NIL);
              if (copiedentry == NIL) {
                copiedentry = collect_000;
              }
              else {
                add_cons_to_end_of_cons_list(copiedentry, collect_000);
              }
            }
          }
          else {
            {
              collect_000->rest = cons(wrap_string(wrapper->wrapper_value), NIL);
              collect_000 = collect_000->rest;
            }
          }
        }
      }
      return (copiedentry);
    }
    return (NULL);
  }
}

String_Wrapper* cpp_yield_renamed_reserved_word(Symbol* word) {
  return (wrap_string(string_concatenate("renamed_", string_capitalize(word->symbol_name), 0)));
}

String_Hash_Table* cpp_create_reserved_word_table() {
  { String_Hash_Table* table = new_string_hash_table();

    { Object* word = NULL;
      Cons* iter_000 = listO(49, SYM_CPP_TRANSLATE_STELLA_ASM, SYM_CPP_TRANSLATE_STELLA_AUTO, SYM_CPP_TRANSLATE_STELLA_BREAK, SYM_CPP_TRANSLATE_STELLA_CASE, SYM_CPP_TRANSLATE_STELLA_CATCH, SYM_CPP_TRANSLATE_STELLA_CHAR, SYM_CPP_TRANSLATE_STELLA_CLASS, SYM_CPP_TRANSLATE_STELLA_CONST, SYM_CPP_TRANSLATE_STELLA_CONTINUE, SYM_CPP_TRANSLATE_STELLA_DEFAULT, SYM_CPP_TRANSLATE_STELLA_DELETE, SYM_CPP_TRANSLATE_STELLA_DO, SYM_CPP_TRANSLATE_STELLA_DOUBLE, SYM_CPP_TRANSLATE_STELLA_ELSE, SYM_CPP_TRANSLATE_STELLA_ENUM, SYM_CPP_TRANSLATE_STELLA_EXTERN, SYM_CPP_TRANSLATE_STELLA_FLOAT, SYM_CPP_TRANSLATE_STELLA_FOR, SYM_CPP_TRANSLATE_STELLA_FRIEND, SYM_CPP_TRANSLATE_STELLA_GOTO, SYM_CPP_TRANSLATE_STELLA_IF, SYM_CPP_TRANSLATE_STELLA_INLINE, SYM_CPP_TRANSLATE_STELLA_INT, SYM_CPP_TRANSLATE_STELLA_LONG, SYM_CPP_TRANSLATE_STELLA_NEW, SYM_CPP_TRANSLATE_STELLA_OPERATOR, SYM_CPP_TRANSLATE_STELLA_PRIVATE, SYM_CPP_TRANSLATE_STELLA_PROTECTED, SYM_CPP_TRANSLATE_STELLA_PUBLIC, SYM_CPP_TRANSLATE_STELLA_REGISTER, SYM_CPP_TRANSLATE_STELLA_RETURN, SYM_CPP_TRANSLATE_STELLA_SHORT, SYM_CPP_TRANSLATE_STELLA_SIGNED, SYM_CPP_TRANSLATE_STELLA_SIZEOF, SYM_CPP_TRANSLATE_STELLA_STATIC, SYM_CPP_TRANSLATE_STELLA_STRUCT, SYM_CPP_TRANSLATE_STELLA_SWITCH, SYM_CPP_TRANSLATE_STELLA_TEMPLATE, SYM_CPP_TRANSLATE_STELLA_THROW, SYM_CPP_TRANSLATE_STELLA_TRY, SYM_CPP_TRANSLATE_STELLA_TYPEDEF, SYM_CPP_TRANSLATE_STELLA_UNION, SYM_CPP_TRANSLATE_STELLA_UNSIGNED, SYM_CPP_TRANSLATE_STELLA_VIRTUAL, SYM_CPP_TRANSLATE_STELLA_VOID, SYM_CPP_TRANSLATE_STELLA_VOLATILE, SYM_CPP_TRANSLATE_STELLA_WHILE, SYM_CPP_TRANSLATE_STELLA_TYPENAME, NIL);

      while (!(iter_000 == NIL)) {
        word = iter_000->value;
        iter_000 = iter_000->rest;
        table->insert_at(((Symbol*)(word))->symbol_name, cpp_yield_renamed_reserved_word(((Symbol*)(word))));
      }
    }
    table->insert_at("++", wrap_string("stella_Increment"));
    table->insert_at("--", wrap_string("stella_Decrement"));
    return (table);
  }
}

String_Hash_Table* oCPP_RESERVED_WORD_TABLEo = NULL;

String_Wrapper* cpp_lookup_reserved_word_table(Symbol* word) {
  { String_Wrapper* entry = ((String_Wrapper*)(oCPP_RESERVED_WORD_TABLEo->lookup(word->symbol_name)));

    if (((boolean)(entry))) {
      return (wrap_string(entry->wrapper_value));
    }
    else {
      return (NULL);
    }
  }
}

// Home module of the currently translated unit.  Needed for
// proper name translation for units whose home module is different than the
// file module (occurs in some PowerLoom files - I thought we had outlawed that).
DEFINE_STELLA_SPECIAL(oCPP_CURRENT_UNIT_MODULEo, Module* , NULL);

Cons* cpp_translate_unit(Translation_Unit* unit) {
  { 
    BIND_STELLA_SPECIAL(oCPP_CURRENT_UNIT_MODULEo, Module*, oMODULEo.get());
    if (((boolean)(unit->the_object))) {
      oCPP_CURRENT_UNIT_MODULEo.set(unit->the_object->home_module());
    }
    { Symbol* test_value_000 = unit->category;

      if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_GLOBAL_VARIABLE) {
        return (cpp_translate_define_global_variable_unit(unit));
      }
      else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_CLASS) {
        return (cpp_translate_define_native_class_unit(unit));
      }
      else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_TYPE) {
        return (NIL);
      }
      else if ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_METHOD) ||
          (test_value_000 == SYM_CPP_TRANSLATE_STELLA_MACRO)) {
        return (cpp_translate_define_method_unit(unit));
      }
      else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_PRINT_METHOD) {
        return (cpp_translate_defprint_unit(unit));
      }
      else if ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_STARTUP_TIME_PROGN) ||
          (test_value_000 == SYM_CPP_TRANSLATE_STELLA_VERBATIM)) {
        return (((Cons*)(cpp_translate_a_tree(unit->the_object))));
      }
      else {
        { Output_String_Stream* stream_000 = new_output_string_stream();

          *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
          throw *new_stella_exception(stream_000->the_string_reader());
        }
      }
    }
  }
}

Cons* cpp_translate_list_of_trees(Cons* trees) {
  { Cons* cursor = trees;

    while (!(cursor == NIL)) {
      cursor->value = cpp_translate_a_tree(cursor->value);
      cursor = cursor->rest;
    }
    return (trees);
  }
}

Object* cpp_translate_a_tree(Object* tree) {
  if (safe_primary_type(tree) == SGT_CPP_TRANSLATE_STELLA_CONS) {
    { Object* tree_000 = tree;
      Cons* tree = ((Cons*)(tree_000));

      if (tree == NIL) {
        return (tree->cpp_translate_atomic_tree());
      }
      { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(tree->value));

        if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SPECIAL) {
          return (cpp_translate_special_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_VERBATIM) {
          return (cpp_translate_verbatim_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_UNWIND_PROTECT) {
          return (cpp_translate_unwind_protect(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_SIGNAL) {
          return (cpp_translate_signal(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_HANDLER_CASE) {
          return (cpp_translate_handler_case(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_HANDLE_EXCEPTION) {
          return (cpp_translate_handle_exception(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_VOID_SYS) {
          return (cpp_translate_void_sys(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_BAD_SYS) {
          return (cpp_translate_bad_sys(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_TYPED_SYS) {
          return (cpp_translate_typed_sys(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SETQ) {
          return (cpp_translate_setq_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE) {
          return (cpp_translate_sys_slot_value(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_SLOT_VALUE) {
          return (cpp_translate_sys_referenced_slot_value(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE_SETTER) {
          return (cpp_translate_sys_slot_value_setter(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD) {
          return (cpp_translate_method_call(tree->rest, FALSE));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_CALL_METHOD) {
          return (cpp_translate_method_call(tree->rest, TRUE));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION) {
          return (cpp_translate_function_call(tree->rest, NULL));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_PROGN) {
          return (cpp_translate_progn(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_WITH_PROCESS_LOCK) {
          return (cpp_translate_with_process_lock(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_LOOP) {
          return (cpp_translate_loop(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_FOREACH) {
          return (cpp_translate_foreach_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_LET) {
          return (cpp_translate_let_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_STARTUP_TIME_PROGN) {
          return (cpp_translate_startup_time_progn(tree));
        }
        else if ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_CAST) ||
            (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SAFE_CAST)) {
          return (cpp_translate_cast(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_RETURN) {
          return (cpp_translate_return_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_BREAK) {
          return (cpp_translate_break(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_CONTINUE) {
          return (cpp_translate_continue(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_WHILE) {
          return (cpp_translate_while(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_IF) {
          return (cpp_translate_if_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_CHOOSE) {
          return (cpp_translate_choose_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_WHEN) {
          return (cpp_translate_when_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_UNLESS) {
          return (cpp_translate_unless_tree(tree));
        }
        else if ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_AND) ||
            ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_OR) ||
             ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_NOT) ||
              ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_EQp) ||
               ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_g) ||
                ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_ge) ||
                 ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_l) ||
                  ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_le) ||
                   ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_ii) ||
                    (test_value_000 == SYM_CPP_TRANSLATE_STELLA___)))))))))) {
          return (cpp_translate_operator_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_COND) {
          return (cpp_translate_cond_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_CASE) {
          return (cpp_translate_case_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_MAKE) {
          return (cpp_translate_make_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_NEW) {
          return (cpp_translate_sys_new(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_MV_SETQ) {
          return (cpp_translate_mv_setq(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION_CODE) {
          return (cpp_translate_call_function_code(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD_CODE) {
          return (cpp_translate_call_method_code(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_INLINE_CALL) {
          return (cpp_translate_inline_call_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_THE_CODE) {
          return (cpp_translate_the_code(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_SYS_POINTER_TO_FUNCTION) {
          return (cpp_translate_sys_pointer_to_function(tree));
        }
        else if ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_INLINE) ||
            (test_value_000 == SYM_CPP_TRANSLATE_STELLA_IGNORE)) {
          return (cpp_translate_inline_tree(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_PRINT_STREAM) {
          return (cpp_translate_print_stream(tree));
        }
        else if (test_value_000 == SYM_CPP_TRANSLATE_STELLA_PRINT_NATIVE_STREAM) {
          return (cpp_translate_print_native_stream(tree));
        }
        else {
          { Output_String_Stream* stream_000 = new_output_string_stream();

            *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
            throw *new_stella_exception(stream_000->the_string_reader());
          }
        }
      }
    }
  }
  else {
    if (!((boolean)(tree))) {
      return (cpp_translate_null());
    }
    return (tree->cpp_translate_atomic_tree());
  }
}

Cons* cpp_translate_verbatim_tree(Cons* tree) {
  { Cons* cursor = tree->rest;
    Object* verbatimcode = NULL;

    while (!(cursor == NIL)) {
      if (cursor->value == KWD_CPP_TRANSLATE_CPP) {
        verbatimcode = cursor->rest->value;
        return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_VERBATIM, verbatimcode, NIL));
      }
      cursor = cursor->rest->rest;
    }
    throw *new_stella_exception("Verbatim has no :cpp option");
  }
}

Cons* cpp_translate_special_tree(Cons* tree) {
  if (!(special_implementation_style() == KWD_CPP_TRANSLATE_UNBIND_WITH_DESTRUCTORS)) {
    cerr << "Safety violation: " << "INTERNAL ERROR: Unexpected special implementation style";
  }
  { Cons* odeclarations = NIL;
    Symbol* variable = NULL;
    Standard_Object* type = NULL;
    Object* initialvaluetree = NULL;

    { Cons* declaration = NULL;
      Cons* iter_000 = ((Cons*)(tree->rest->value));
      Cons* collect_000 = NULL;

      while (!(iter_000 == NIL)) {
        declaration = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        variable = ((Symbol*)(declaration->value));
        type = ((Standard_Object*)(declaration->rest->value));
        initialvaluetree = declaration->rest->rest->value;
        if (!((boolean)(collect_000))) {
          {
            collect_000 = cons(listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string("BIND_STELLA_SPECIAL"), NIL), listO(5, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_global_name(variable), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_and_pointerize_type_spec(type), NIL), cpp_translate_a_tree(initialvaluetree), NIL), NIL), NIL);
            if (odeclarations == NIL) {
              odeclarations = collect_000;
            }
            else {
              add_cons_to_end_of_cons_list(odeclarations, collect_000);
            }
          }
        }
        else {
          {
            collect_000->rest = cons(listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string("BIND_STELLA_SPECIAL"), NIL), listO(5, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_global_name(variable), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_and_pointerize_type_spec(type), NIL), cpp_translate_a_tree(initialvaluetree), NIL), NIL), NIL);
            collect_000 = collect_000->rest;
          }
        }
      }
    }
    return (listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK, NIL, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, odeclarations->concatenate(cpp_translate_list_of_trees(tree->rest->rest)->concatenate(NIL, 0), 0)), NIL));
  }
}

Cons* cpp_translate_inline_tree(Cons* tree) {
  return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_COMMENT, wrap_string("inline method"), NIL));
}

Cons* tokenize_verbatim_method_body(Cons* tree) {
  { Standard_Object* dummy1;
    boolean dummy2;

    { Method_Slot* method = ((Method_Slot*)(slot_from_expression_tree(tree)));
      char* body = ((Verbatim_String_Wrapper*)(lookup_verbatim_tree(((Cons*)(walk_verbatim_tree(((Cons*)(inlinable_method_body(method))), dummy1))), NULL)))->wrapper_value;
      int bodystart = 0;
      int bodylength = strlen(body);
      List* parameters = new_list();
      int parameterposition = 0;
      char* identifierchars = "_ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789$";
      Cons* result = NIL;
      char ch = NULL_CHARACTER;
      int cursor = 0;
      int end = 0;

      { Symbol* par = NULL;
        Cons* iter_000 = method->method_parameter_names_reader()->the_cons_list;
        Cons* collect_000 = NULL;

        while (!(iter_000 == NIL)) {
          par = ((Symbol*)(iter_000->value));
          iter_000 = iter_000->rest;
          if (!((boolean)(collect_000))) {
            {
              collect_000 = cons(((oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_CPP_TRANSLATE_CPP) ? cpp_translate_name(par) : java_translate_name(par)), NIL);
              if (parameters->the_cons_list == NIL) {
                parameters->the_cons_list = collect_000;
              }
              else {
                add_cons_to_end_of_cons_list(parameters->the_cons_list, collect_000);
              }
            }
          }
          else {
            {
              collect_000->rest = cons(((oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_CPP_TRANSLATE_CPP) ? cpp_translate_name(par) : java_translate_name(par)), NIL);
              collect_000 = collect_000->rest;
            }
          }
        }
      }
      for (;;) {
        if (cursor >= bodylength) {
          break;
        }
        ch = body[cursor];
        if (ch == '/') {
          cursor = cursor + 1;
          if (cursor < bodylength) {
            switch (body[cursor]) {
              case '/': 
                { Input_String_Stream* comment = new_input_string_stream(string_subsequence(body, cursor, NULL_INTEGER));

                  cursor = cursor + strlen((read_line(comment, dummy2)));
                }
              break;
              case '*': 
                cursor = string_search(body, "*/", cursor);
                if (cursor == NULL_INTEGER) {
                  { 
                    BIND_STELLA_SPECIAL(oPRINTREADABLYpo, boolean, TRUE);
                    signal_translation_error();
                    if (!(suppress_warningsP())) {
                      print_error_context(">> ERROR: ", STANDARD_ERROR);
                      *(STANDARD_ERROR->native_stream) << endl << " " << "Illegal " << "`" << oTRANSLATOROUTPUTLANGUAGEo.get() << "'" << " verbatim code in " << "`" << de_uglify_parse_tree(method) << "'" << "." << endl;
                    }
                  }
                  return (NULL);
                }
                else {
                  cursor = cursor + 2;
                }
              break;
              default:
              break;
            }
          }
        }
        else if (string_memberP(identifierchars, ch) &&
            (!(oCHARACTER_TYPE_TABLEo[(int)(unsigned char) ch] == KWD_CPP_TRANSLATE_DIGIT))) {
          end = cursor + 1;
          { int i = NULL_INTEGER;
            int iter_001 = end;
            int upper_bound_000 = bodylength - 1;

            while (iter_001 <= upper_bound_000) {
              i = iter_001;
              iter_001 = iter_001 + 1;
              if (string_memberP(identifierchars, body[i])) {
                end = end + 1;
              }
              else {
                break;
              }
            }
          }
          parameterposition = parameters->position(wrap_string(string_subsequence(body, cursor, end)), NULL_INTEGER);
          if (parameterposition != NULL_INTEGER) {
            result = cons(wrap_string(string_subsequence(body, bodystart, cursor)), result);
            result = cons(cons(parameters->nth(parameterposition), cons(wrap_integer(parameterposition), NIL)), result);
            bodystart = end;
          }
          cursor = end;
        }
        else {
          cursor = cursor + 1;
        }
      }
      if (bodystart < bodylength) {
        result = cons(wrap_string(string_subsequence(body, bodystart, bodylength)), result);
      }
      return (result->reverse());
    }
  }
}

Object* cpp_translate_inline_call_tree(Cons* tree) {
  { Cons* calltree = ((Cons*)(tree->rest->value));
    Cons* arguments = ((calltree->value == SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION) ? calltree->nth_rest(2) : calltree->nth_rest(3));
    Cons* tokenizedbody = tokenize_verbatim_method_body(calltree);

    if (((boolean)(tokenizedbody))) {
      { List* inlinedparameters = new_list();
        char* inlinedbody = NULL;
        boolean successP = TRUE;

        { 
          BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
          { Object* token = NULL;
            Cons* iter_000 = tokenizedbody;

            while (!(iter_000 == NIL)) {
              token = iter_000->value;
              iter_000 = iter_000->rest;
              { Surrogate* test_value_000 = safe_primary_type(token);

                if (subtype_of_stringP(test_value_000)) {
                  { Object* token_000 = token;
                    String_Wrapper* token = ((String_Wrapper*)(token_000));

                    *(oCURRENT_STREAMo.get()->native_stream) << token->wrapper_value;
                  }
                }
                else if (test_value_000 == SGT_CPP_TRANSLATE_STELLA_CONS) {
                  { Object* token_001 = token;
                    Cons* token = ((Cons*)(token_001));

                    { String_Wrapper* parameter = ((String_Wrapper*)(token->value));
                      Integer_Wrapper* position = ((Integer_Wrapper*)(token->rest->value));
                      Object* argument = arguments->nth(position->wrapper_value);

                      if (!side_effect_free_expressionP(argument)) {
                        if (inlinedparameters->memberP(parameter)) {
                          {
                            successP = FALSE;
                            break;
                          }
                        }
                        else {
                          inlinedparameters->insert(parameter);
                        }
                      }
                      if (!(atomic_expressionP(argument))) {
                        *(oCURRENT_STREAMo.get()->native_stream) << "(";
                      }
                      cpp_output_statement(cpp_translate_a_tree(copy_cons_tree(argument)));
                      if (!(atomic_expressionP(argument))) {
                        *(oCURRENT_STREAMo.get()->native_stream) << ")";
                      }
                    }
                  }
                }
                else {
                  { Output_String_Stream* stream_000 = new_output_string_stream();

                    *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
                    throw *new_stella_exception(stream_000->the_string_reader());
                  }
                }
              }
            }
          }
          inlinedbody = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
          if (successP) {
            return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_VERBATIM, new_verbatim_string_wrapper(inlinedbody), NIL));
          }
        }
      }
    }
    return (cpp_translate_a_tree(calltree));
  }
}

Cons* cpp_translate_print_native_stream(Cons* tree) {
  { Cons* otree = cpp_translate_print_stream(tree);

    otree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_NATIVE_STREAM);
    return (otree);
  }
}

Cons* cpp_translate_defprint_unit(Translation_Unit* unit) {
  { Object* printform = unit->code_register;
    Class* renamed_Class = ((Class*)(unit->the_object));
    String_Wrapper* classname = NULL;

    classname = cpp_translate_and_pointerize_type_spec(renamed_Class->class_type);
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_DEFPRINT, classname, cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_a_tree(printform), cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_RETURN, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(SYM_CPP_TRANSLATE_STELLA_STREAM), NIL), NIL), NIL)), NIL)));
  }
}

Cons* cpp_translate_signal(Cons* tree) {
  tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_SIGNAL);
  tree->second_setter(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_DEREFERENCE, cpp_translate_a_tree(tree->rest->value), NIL));
  return (tree);
}

Cons* cpp_translate_handler_case(Cons* tree) {
  tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_HANDLER_CASE);
  tree->rest = cpp_translate_list_of_trees(tree->rest);
  return (tree);
}

Cons* cpp_translate_handle_exception(Cons* tree) {
  { Cons* variabledecl = ((Cons*)(tree->rest->value));
    Object* variable = variabledecl->value;
    Object* exceptiontype = variabledecl->rest->value;
    String_Wrapper* helpervariable = NULL;
    String_Wrapper* helpervariabletype = NULL;

    tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_CATCH);
    if (((boolean)(variable))) {
      helpervariable = wrap_string(string_concatenate("_", cpp_translate_name(((Symbol*)(variable)))->wrapper_value, 0));
      helpervariabletype = wrap_string(string_concatenate(cpp_translate_type_spec(((Standard_Object*)(exceptiontype)))->wrapper_value, "&"));
    }
    tree->second_setter(cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_TYPE, (((boolean)(variable)) ? helpervariabletype : cpp_translate_type_spec(((Standard_Object*)(exceptiontype)))), NIL), ((((boolean)(variable)) ? cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, helpervariable, NIL), NIL) : NIL))->concatenate(NIL, 0)));
    tree->rest->rest = cpp_translate_list_of_trees(tree->rest->rest);
    if (((boolean)(variable))) {
      tree->rest->rest = cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_LOCAL, NULL, cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(exceptiontype))), listO(3, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(((Symbol*)(variable))), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string(string_concatenate("&", helpervariable->wrapper_value)), NIL), NIL))), tree->rest->rest->concatenate(NIL, 0));
    }
    return (tree);
  }
}

Cons* cpp_translate_unwind_protect(Cons* tree) {
  tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_UNWIND_PROTECT);
  tree->rest = cpp_translate_list_of_trees(tree->rest);
  return (tree);
}

Cons* cpp_translate_cast(Cons* tree) {
  { Object* expression = tree->rest->value;
    Surrogate* type = type_spec_to_base_type(((Standard_Object*)(tree->rest->rest->value)));

    if (subtype_ofP(type, SGT_CPP_TRANSLATE_STELLA_FLOAT) &&
        isaP(expression, SGT_CPP_TRANSLATE_STELLA_INTEGER_WRAPPER)) {
      return (((Cons*)(cpp_translate_a_tree(wrap_float(((double)(((Integer_Wrapper*)(expression))->wrapper_value)))))));
    }
    if (subtype_ofP(type, SGT_CPP_TRANSLATE_STELLA_INTEGER) &&
        isaP(expression, SGT_CPP_TRANSLATE_STELLA_FLOAT_WRAPPER)) {
      return (((Cons*)(cpp_translate_a_tree(wrap_integer(((int)(((Float_Wrapper*)(expression))->wrapper_value)))))));
    }
    tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_CAST);
    tree->second_setter(cpp_translate_a_tree(tree->rest->value));
    tree->third_setter(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(tree->rest->rest->value))));
    return (tree);
  }
}

Cons* cpp_translate_mv_setq(Cons* tree) {
  { Cons* variables = ((Cons*)(tree->rest->value));
    Object* functioncall = tree->rest->rest->value;
    Cons* otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN, cpp_translate_a_tree(variables->value), cons(cpp_translate_mv_function_call(((Cons*)(functioncall)), variables->rest), NIL));

    return (otree);
  }
}

Cons* cpp_translate_mv_function_call(Cons* functioncall, Cons* variables) {
  return (((Cons*)(cpp_translate_a_tree(functioncall->concatenate(variables->concatenate(NIL, 0), 0)))));
}

Cons* cpp_translate_define_global_variable_unit(Translation_Unit* unit) {
  { Global_Variable* global = ((Global_Variable*)(unit->the_object));
    Standard_Object* type = global_variable_type_spec(global);
    Object* initialvaluetree = ((unit->code_register == KWD_CPP_TRANSLATE_UNBOUND_SPECIAL_VARIABLE) ? ((Object*)(NULL)) : cpp_translate_a_tree(unit->code_register));
    String_Wrapper* variablename = cpp_translate_global_name(global->variable_name);

    if (global->variable_specialP) {
      if ((!((boolean)(initialvaluetree))) &&
          (special_implementation_style() == KWD_CPP_TRANSLATE_UNBIND_WITH_DESTRUCTORS)) {
        initialvaluetree = cpp_translate_a_tree(type_to_walked_null_value_tree(type_spec_to_base_type(type)));
      }
      return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_SPECIAL, wrap_string(global->documentation), listO(3, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_TYPE, cpp_translate_and_pointerize_type_spec(type), NIL), variablename, ((((boolean)(initialvaluetree)) ? cons(initialvaluetree, NIL) : NIL))->concatenate(NIL, 0))));
    }
    else {
      return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_GLOBAL, wrap_string(global->documentation), listO(3, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_TYPE, cpp_translate_and_pointerize_type_spec(type), NIL), variablename, cons(initialvaluetree, NIL))));
    }
  }
}

boolean symbol_caseP(Object* keyform) {
  if (safe_primary_type(keyform) == SGT_CPP_TRANSLATE_STELLA_CONS) {
    { Object* keyform_000 = keyform;
      Cons* keyform = ((Cons*)(keyform_000));

      return ((keyform->value == SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE) &&
          (keyform->rest->rest->value == SYM_CPP_TRANSLATE_STELLA_SYMBOL_ID));
    }
  }
  else {
    return (FALSE);
  }
}

Cons* cpp_yield_symbol_id_form(int symbolid) {
  { Symbol* symbol = get_sym_from_offset(symbolid);

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_symbol_id(symbol), NIL));
  }
}

Cons* cpp_translate_condition(Cons* condition, boolean symbolcasep) {
  { Cons* translatedactions = cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(condition->rest)->concatenate(NIL, 0));
    Object* keys = condition->value;
    Object* translatedkeys = NULL;
    Cons* translatedkeyslist = NIL;

    if (symbolcasep) {
      if (consP(keys)) {
        {
          { Object* key = NULL;
            Cons* iter_000 = ((Cons*)(keys));
            Cons* collect_000 = NULL;

            while (!(iter_000 == NIL)) {
              key = iter_000->value;
              iter_000 = iter_000->rest;
              if (!((boolean)(collect_000))) {
                {
                  collect_000 = cons(cpp_yield_symbol_id_form(((Integer_Wrapper*)(key))->wrapper_value), NIL);
                  if (translatedkeyslist == NIL) {
                    translatedkeyslist = collect_000;
                  }
                  else {
                    add_cons_to_end_of_cons_list(translatedkeyslist, collect_000);
                  }
                }
              }
              else {
                {
                  collect_000->rest = cons(cpp_yield_symbol_id_form(((Integer_Wrapper*)(key))->wrapper_value), NIL);
                  collect_000 = collect_000->rest;
                }
              }
            }
          }
          translatedkeys = translatedkeyslist;
        }
      }
      else {
        translatedkeys = cpp_yield_symbol_id_form(((Integer_Wrapper*)(keys))->wrapper_value);
      }
    }
    else {
      translatedkeys = (consP(keys) ? cpp_translate_list_of_trees(((Cons*)(keys))) : cpp_translate_a_tree(keys));
    }
    return (cons(translatedkeys, cons(translatedactions, NIL)));
  }
}

Cons* cpp_translate_case_tree(Cons* tree) {
  { Cons* otherwisecondition = NULL;
    Cons* conditions = NIL;
    Object* keyform = NULL;
    boolean symbolcasep = FALSE;

    symbolcasep = symbol_caseP(tree->rest->value);
    keyform = cpp_translate_a_tree(tree->rest->value);
    { Object* condition = NULL;
      Cons* iter_000 = tree->rest->rest;

      while (!(iter_000 == NIL)) {
        condition = iter_000->value;
        iter_000 = iter_000->rest;
        if (safe_primary_type(condition) == SGT_CPP_TRANSLATE_STELLA_CONS) {
          { Object* condition_000 = condition;
            Cons* condition = ((Cons*)(condition_000));

            if (condition->value == SYM_CPP_TRANSLATE_STELLA_OTHERWISE) {
              otherwisecondition = cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(condition->rest)->concatenate(NIL, 0));
            }
            else {
              conditions = cons(cpp_translate_condition(condition, symbolcasep), conditions);
            }
          }
        }
        else {
          { Output_String_Stream* stream_000 = new_output_string_stream();

            *(stream_000->native_stream) << "`" << safe_primary_type(condition) << "'" << " is not a valid case option";
            throw *new_stella_exception(stream_000->the_string_reader());
          }
        }
      }
    }
    tree->rest->rest = NIL;
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_CASE, keyform, cons(otherwisecondition, cons(conditions->reverse(), NIL))));
  }
}

Cons* cpp_translate_cond_tree(Cons* tree) {
  { Cons* otherwisecondition = NULL;
    Cons* conditions = NIL;

    { Object* condition = NULL;
      Cons* iter_000 = tree->rest;

      while (!(iter_000 == NIL)) {
        condition = iter_000->value;
        iter_000 = iter_000->rest;
        if (safe_primary_type(condition) == SGT_CPP_TRANSLATE_STELLA_CONS) {
          { Object* condition_000 = condition;
            Cons* condition = ((Cons*)(condition_000));

            if (condition->value == SYM_CPP_TRANSLATE_STELLA_OTHERWISE) {
              otherwisecondition = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(condition->rest)->concatenate(NIL, 0)), NIL);
            }
            else {
              conditions = cons(cons(cpp_translate_a_tree(condition->value), cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(condition->rest)->concatenate(NIL, 0)), NIL), NIL)), conditions);
            }
          }
        }
        else {
          { Output_String_Stream* stream_000 = new_output_string_stream();

            *(stream_000->native_stream) << "`" << safe_primary_type(condition) << "'" << " is not a valid case option";
            throw *new_stella_exception(stream_000->the_string_reader());
          }
        }
      }
    }
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_COND, otherwisecondition, cons(conditions->reverse(), NIL)));
  }
}

Cons* cpp_translate_loop(Cons* tree) {
  { Cons* body = cpp_translate_list_of_trees(tree->rest);

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_LOOP, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, body->concatenate(NIL, 0)), NIL), NIL));
  }
}

Cons* cpp_translate_while(Cons* tree) {
  { Object* test = cpp_translate_a_tree(tree->rest->value);
    Cons* body = cpp_translate_list_of_trees(tree->rest->rest);

    tree->rest->rest = NIL;
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_WHILE, test, cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, body->concatenate(NIL, 0)), NIL), NIL)));
  }
}

Cons* cpp_translate_progn(Cons* tree) {
  return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(tree->rest)->concatenate(NIL, 0)), NIL));
}

Cons* cpp_translate_with_process_lock(Cons* tree) {
  return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_WITH_PROCESS_LOCK, cpp_translate_a_tree(tree->rest->value), cons(cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(tree->rest->rest)->concatenate(NIL, 0)), NIL)));
}

Cons* cpp_translate_break(Cons* tree) {
  tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_BREAK);
  return (tree);
}

Cons* cpp_translate_continue(Cons* tree) {
  tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_CONTINUE);
  return (tree);
}

Cons* cpp_translate_if_tree(Cons* tree) {
  { Object* test = cpp_translate_a_tree(tree->rest->value);
    Cons* truebody = ((Cons*)(cpp_translate_a_tree(tree->rest->rest->value)));
    Cons* falsebody = ((Cons*)(cpp_translate_a_tree(tree->fourth())));

    if (consP(truebody->value) &&
        (!(truebody->rest == NIL))) {
      truebody = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, truebody->concatenate(NIL, 0)), NIL);
    }
    else {
      truebody = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, truebody, NIL), NIL);
    }
    if (consP(falsebody->value) &&
        (!(falsebody->rest == NIL))) {
      falsebody = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, falsebody->concatenate(NIL, 0)), NIL);
    }
    else {
      falsebody = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_PROGN, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, falsebody, NIL), NIL);
    }
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IF, test, cons(truebody, cons(falsebody, NIL))));
  }
}

Cons* cpp_translate_choose_tree(Cons* tree) {
  return (cpp_translate_operator_call(cons(wrap_string("?"), cons(wrap_string(":"), NIL)), tree->rest, 3));
}

Cons* cpp_translate_when_tree(Cons* tree) {
  { Object* test = cpp_translate_a_tree(tree->rest->value);
    Cons* body = cpp_translate_list_of_trees(tree->rest->rest);

    tree->rest->rest = NIL;
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_WHEN, test, cons(cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, body->concatenate(NIL, 0)), NIL)));
  }
}

Cons* cpp_translate_unless_tree(Cons* tree) {
  { Object* test = cpp_translate_a_tree(tree->rest->value);
    Cons* body = cpp_translate_list_of_trees(tree->rest->rest);

    tree->rest->rest = NIL;
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_UNLESS, test, cons(cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, body->concatenate(NIL, 0)), NIL)));
  }
}

Cons* cpp_translate_foreach_tree(Cons* tree) {
  { Cons* iteratorbindings = ((Cons*)(tree->rest->value));
    Cons* cursorbindings = ((Cons*)(tree->rest->rest->value));
    Object* continuationtest = cpp_translate_a_tree(tree->fourth());
    Cons* body = cpp_translate_list_of_trees(tree->nth_rest(4));
    Cons* declaration = NIL;
    Cons* declarations = NIL;
    Cons* nextassignments = NIL;
    Symbol* varargsiterator = NULL;

    { Cons* binding = NULL;
      Cons* iter_000 = cursorbindings;
      Cons* collect_000 = NULL;

      while (!(iter_000 == NIL)) {
        binding = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        nextassignments = cons(cpp_translate_a_tree(binding->rest->rest->value), nextassignments);
        declaration = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(binding->rest->value))), cons(cpp_translate_a_tree(binding->value), cons(cpp_translate_a_tree(type_to_walked_null_value_tree(type_spec_to_base_type(((Standard_Object*)(binding->rest->value))))), NIL)));
        if (!((boolean)(collect_000))) {
          {
            collect_000 = cons(declaration, NIL);
            if (declarations == NIL) {
              declarations = collect_000;
            }
            else {
              add_cons_to_end_of_cons_list(declarations, collect_000);
            }
          }
        }
        else {
          {
            collect_000->rest = cons(declaration, NIL);
            collect_000 = collect_000->rest;
          }
        }
      }
    }
    { Cons* binding = NULL;
      Cons* iter_001 = iteratorbindings;
      Cons* collect_001 = NULL;

      while (!(iter_001 == NIL)) {
        binding = ((Cons*)(iter_001->value));
        iter_001 = iter_001->rest;
        if (sub_type_spec_ofP(((Standard_Object*)(binding->rest->value)), SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST_ITERATOR)) {
          varargsiterator = ((Symbol*)(binding->value));
          declarations = declarations->concatenate(cpp_yield_va_iterator_declarations(varargsiterator), 0);
          continue;
        }
        else {
          declaration = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(binding->rest->value))), cons(cpp_translate_a_tree(binding->value), cons(cpp_translate_a_tree(binding->rest->rest->value), NIL)));
        }
        if (!((boolean)(collect_001))) {
          {
            collect_001 = cons(declaration, NIL);
            if (declarations == NIL) {
              declarations = collect_001;
            }
            else {
              add_cons_to_end_of_cons_list(declarations, collect_001);
            }
          }
        }
        else {
          {
            collect_001->rest = cons(declaration, NIL);
            collect_001 = collect_001->rest;
          }
        }
      }
    }
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK, declarations, cons(cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, ((((boolean)(varargsiterator)) ? cpp_yield_va_start_tree(varargsiterator) : NIL))->concatenate(cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_FOREACH, continuationtest, cons(nextassignments->reverse(), cons(body, NIL))), ((((boolean)(varargsiterator)) ? cpp_yield_va_end_tree(varargsiterator) : NIL))->concatenate(NIL, 0)), 0)), NIL)));
  }
}

Cons* cpp_yield_va_start_tree(Symbol* iteratorvar) {
  return (cons(listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(SYM_CPP_TRANSLATE_STELLA_VA_START), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, cpp_translate_a_tree(iteratorvar), cons(cpp_translate_a_tree(variable_arguments_name(oMETHODBEINGWALKEDo.get())), NIL)), NIL), NIL));
}

Cons* cpp_yield_va_end_tree(Symbol* iteratorvar) {
  return (cons(listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(SYM_CPP_TRANSLATE_STELLA_VA_END), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, cpp_translate_a_tree(iteratorvar), NIL), NIL), NIL));
}

Symbol* cpp_yield_va_iterator_helper_variable(Symbol* iteratorvar) {
  return (intern_symbol(string_concatenate(iteratorvar->symbol_name, "-COUNT", 0)));
}

Cons* cpp_yield_va_iterator_declarations(Symbol* iteratorvar) {
  return (listO(3, cons(cpp_translate_and_pointerize_type_spec(SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST_ITERATOR), cons(cpp_translate_a_tree(iteratorvar), NIL)), cons(cpp_translate_and_pointerize_type_spec(SGT_CPP_TRANSLATE_STELLA_INTEGER), cons(cpp_translate_a_tree(cpp_yield_va_iterator_helper_variable(iteratorvar)), cons(cpp_translate_a_tree(variable_arguments_name(oMETHODBEINGWALKEDo.get())), NIL))), NIL));
}

Cons* cpp_translate_argument_list_tree(Symbol* renamed_Operator, Surrogate* owner, Object* argument) {
  owner = owner;
  if (renamed_Operator == SYM_CPP_TRANSLATE_STELLA_ALLOCATE_ITERATOR) {
    { 
      BIND_STELLA_SPECIAL(oPRINTREADABLYpo, boolean, TRUE);
      signal_translation_error();
      if (!(suppress_warningsP())) {
        print_error_context(">> ERROR: ", STANDARD_ERROR);
        *(STANDARD_ERROR->native_stream) << endl << " " << "Cannot handle explicit calls to " << "`ARGUMENT-LIST.ALLOCATE-ITERATOR' in C++" << "." << endl;
      }
    }
    return (((Cons*)(cpp_translate_a_tree(argument))));
  }
  else if (renamed_Operator == SYM_CPP_TRANSLATE_STELLA_LENGTH) {
    return (((Cons*)(cpp_translate_a_tree(variable_arguments_name(oMETHODBEINGWALKEDo.get())))));
  }
  else if (renamed_Operator == SYM_CPP_TRANSLATE_STELLA_NEXTp) {
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_BINARY_OP, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_UNARY_OP, cpp_translate_a_tree(cpp_yield_va_iterator_helper_variable(((Symbol*)(argument)))), cpp_lookup_operator_table(SYM_CPP_TRANSLATE_STELLA___)->concatenate(NIL, 0)), cpp_lookup_operator_table(SYM_CPP_TRANSLATE_STELLA_g)->concatenate(cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL, wrap_integer(0), NIL), NIL), 0)));
  }
  else if (renamed_Operator == SYM_CPP_TRANSLATE_STELLA_ARGUMENT) {
    return (listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(SYM_CPP_TRANSLATE_STELLA_VA_ARG), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, cpp_translate_a_tree(argument), cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_and_pointerize_type_spec(variable_arguments_type(oMETHODBEINGWALKEDo.get())), NIL), NIL)), NIL));
  }
  else {
    { 
      BIND_STELLA_SPECIAL(oPRINTREADABLYpo, boolean, TRUE);
      signal_translation_error();
      if (!(suppress_warningsP())) {
        print_error_context(">> ERROR: ", STANDARD_ERROR);
        *(STANDARD_ERROR->native_stream) << endl << " " << "Cannot translate call to " << "`" << de_uglify_parse_tree(renamed_Operator) << "'" << " on an `ARGUMENT-LIST'" << "." << endl;
      }
    }
    return (listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(renamed_Operator), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, cpp_translate_a_tree(argument), NIL), NIL));
  }
}

Cons* cpp_translate_the_code(Cons* tree) {
  { Cons* otree = NULL;

    { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(tree->rest->value));

      if (test_value_000 == KWD_CPP_TRANSLATE_FUNCTION) {
        otree = listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_CAST, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_POINTER, cpp_translate_function_name_from_name(((Symbol*)(tree->rest->rest->value))), NIL), wrap_string("cpp_function_code"), NIL);
      }
      else if (test_value_000 == KWD_CPP_TRANSLATE_METHOD) {
        otree = listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_CAST, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_POINTER, cpp_translate_method_name_from_name(((Symbol*)(tree->fourth())), ((Standard_Object*)(tree->rest->rest->value))), NIL), wrap_string("cpp_method_code"), NIL);
      }
      else {
        { Output_String_Stream* stream_000 = new_output_string_stream();

          *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
          throw *new_stella_exception(stream_000->the_string_reader());
        }
      }
    }
    return (otree);
  }
}

Cons* cpp_translate_sys_pointer_to_function(Cons* tree) {
  { char* functionname = cpp_translate_name(((Symbol*)(tree->rest->value)))->wrapper_value;
    Cons* otree = NULL;

    if (tree->rest->rest->value == SYM_CPP_TRANSLATE_STELLA_TRUE) {
      functionname = string_concatenate(functionname, "_setter", 0);
    }
    otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_POINTER, wrap_string(functionname), NIL);
    return (otree);
  }
}

Cons* cpp_translate_sys_new(Cons* tree) {
  { Standard_Object* typespec = ((Standard_Object*)(tree->rest->value));

    if (array_type_specifierP(typespec)) {
      return (cpp_translate_new_array(tree));
    }
    else {
      return (listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(yield_constructor_name(type_spec_to_class(typespec))), NIL), cpp_translate_actual_parameters(tree->rest->rest), NIL));
    }
  }
}

Cons* cpp_translate_new_array(Cons* tree) {
  { boolean dummy1;

    { Parametric_Type_Specifier* arraytype = ((Parametric_Type_Specifier*)(tree->rest->value));
      Object* initialelement = tree->rest->rest->value;
      Cons* dimensions = cpp_translate_list_of_trees(tree->rest->rest->rest);
      Standard_Object* elementtype = extract_parameter_type(arraytype, SYM_CPP_TRANSLATE_STELLA_ANY_VALUE, dummy1);

      return (listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, (cpp_use_garbage_collectorP() ? wrap_string("new (GC)") : wrap_string("new")), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ARRAY_REFERENCE, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_and_pointerize_type_spec(elementtype), NIL), dimensions->concatenate(NIL, 0)), NIL), NIL));
    }
  }
}

Cons* cpp_translate_void_sys(Cons* tree) {
  return (((Cons*)(cpp_translate_a_tree(tree->rest->value))));
}

Cons* cpp_translate_typed_sys(Cons* tree) {
  return (((Cons*)(cpp_translate_a_tree(tree->rest->value))));
}

Object* cpp_translate_bad_sys(Cons* tree) {
  { Object* returntype = tree->rest->rest->value;

    if (returntype == SGT_CPP_TRANSLATE_STELLA_VOID) {
      return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string("illegal_stella_statement_flagged_by_the_translator"), NIL), NIL));
    }
    else {
      return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string("illegal_stella_expression_flagged_by_the_translator"), NIL));
    }
  }
}

Cons* cpp_translate_sys_referenced_slot_value(Cons* tree) {
  { Object* objectref = tree->fourth();
    Object* slotname = tree->rest->rest->value;

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_SLOT_VALUE, cpp_translate_a_tree(objectref), cons(cpp_translate_name(((Symbol*)(slotname))), NIL)));
  }
}

Cons* cpp_translate_sys_slot_value(Cons* tree) {
  { Surrogate* objecttype = ((Surrogate*)(tree->rest->value));
    Object* objectref = tree->fourth();
    Symbol* slotname = true_slot_name(((Symbol*)(tree->rest->rest->value)), objecttype);

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE, cpp_translate_a_tree(objectref), cons(cpp_translate_name(slotname), NIL)));
  }
}

Cons* cpp_translate_sys_slot_value_setter(Cons* tree) {
  { Object* objectref = tree->fourth();
    Surrogate* objecttype = ((Surrogate*)(tree->rest->value));
    Symbol* slotname = true_slot_name(((Symbol*)(tree->rest->rest->value)), objecttype);
    Object* valueref = cpp_translate_a_tree(tree->fifth());
    Cons* otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE_SETTER, cpp_translate_a_tree(objectref), cons(cpp_translate_name(slotname), cons(valueref, NIL)));

    tree->third_setter(NULL);
    tree->fourth_setter(NULL);
    tree->fifth_setter(NULL);
    return (otree);
  }
}

Cons* cpp_translate_make_tree(Cons* tree) {
  { Class* renamed_Class = ((Symbol*)(tree->rest->value))->lookup_class();
    String_Wrapper* classname = ((((String_Wrapper*)(dynamic_slot_value(renamed_Class->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE, NULL_STRING_WRAPPER)))->wrapper_value != NULL) ? wrap_string(((String_Wrapper*)(dynamic_slot_value(renamed_Class->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE, NULL_STRING_WRAPPER)))->wrapper_value) : cpp_translate_class_name(((Generalized_Symbol*)(tree->rest->value))));
    Cons* otree = listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_MAKE, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, classname, NIL), cpp_translate_actual_parameters(tree->rest->rest), NIL);

    return (otree);
  }
}

Cons* cpp_translate_startup_time_progn(Cons* tree) {
  { Object* otree = cpp_translate_a_tree(tree->rest->value);

    tree->rest = NIL;
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_STARTUP_TIME_PROGN, otree, NIL));
  }
}

boolean cpp_stream_is_standard_outputP(Object* tree) {
  if (safe_primary_type(tree) == SGT_CPP_TRANSLATE_STELLA_CONS) {
    { Object* tree_000 = tree;
      Cons* tree = ((Cons*)(tree_000));

      return (equal_cons_treesP(tree, get_quoted_tree("((SYS-SLOT-VALUE @OUTPUT-STREAM NATIVE-STREAM STANDARD-OUTPUT) \"/STELLA\")", "/STELLA")));
    }
  }
  else {
    return (FALSE);
  }
}

Cons* cpp_translate_print_stream(Cons* tree) {
  tree->first_setter(SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_STREAM);
  if (subtype_of_keywordP(safe_primary_type(tree->rest->value))) {
    { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(tree->rest->value));

      if ((test_value_000 == KWD_CPP_TRANSLATE_WARN) ||
          ((test_value_000 == KWD_CPP_TRANSLATE_ERROR) ||
           (test_value_000 == KWD_CPP_TRANSLATE_CONTINUABLE_ERROR))) {
        tree->second_setter(SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_ERROR);
      }
      else {
        { Output_String_Stream* stream_000 = new_output_string_stream();

          *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
          throw *new_stella_exception(stream_000->the_string_reader());
        }
      }
    }
  }
  else {
    if (cpp_stream_is_standard_outputP(tree->rest->value)) {
      tree->second_setter(SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_OUT);
    }
    else {
      tree->second_setter(cpp_translate_a_tree(tree->rest->value));
    }
  }
  substitute_cons_tree(tree->rest->rest, SYM_CPP_TRANSLATE_STELLA_ENDL, SYM_CPP_TRANSLATE_STELLA_EOL);
  cpp_translate_list_of_trees(tree->rest->rest);
  return (tree);
}

Cons* cpp_translate_setq_tree(Cons* tree) {
  { Global_Variable* global = ((Symbol*)(tree->rest->value))->lookup_global_variable();

    if (((boolean)(global)) &&
        (global->variable_specialP &&
         (special_implementation_style() == KWD_CPP_TRANSLATE_UNBIND_WITH_DESTRUCTORS))) {
      return (listO(6, SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_METHOD_CALL, SYM_CPP_TRANSLATE_STELLA_NULL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(SYM_CPP_TRANSLATE_STELLA_SET), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_global_name(((Symbol*)(tree->rest->value))), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, cpp_translate_a_tree(tree->rest->rest->value), NIL), NIL));
    }
    else {
      return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN, cpp_translate_a_tree(tree->rest->value), cons(cpp_translate_a_tree(tree->rest->rest->value), NIL)));
    }
  }
}

Cons* cpp_translate_null() {
  return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string("NULL"), NIL));
}

Cons* Object::cpp_translate_atomic_tree() {
  { Object* tree = this;

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL, tree, NIL));
  }
}

Cons* Keyword::cpp_translate_atomic_tree() {
  { Keyword* tree = this;

    if (use_hardcoded_symbolsP()) {
      return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_SYMBOL, tree, NIL));
    }
    else {
      return (yield_symbol_constant_name(tree)->cpp_translate_atomic_tree());
    }
  }
}

Cons* Surrogate::cpp_translate_atomic_tree() {
  { Surrogate* tree = this;

    if (use_hardcoded_symbolsP()) {
      return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_SYMBOL, tree, NIL));
    }
    else {
      return (yield_symbol_constant_name(tree)->cpp_translate_atomic_tree());
    }
  }
}

Cons* Symbol::cpp_translate_atomic_tree() {
  { Symbol* tree = this;

    { Global_Variable* globalvar = tree->soft_permanentify()->lookup_global_variable();

      if (((boolean)(globalvar))) {
        { Cons* otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_global_name(tree), NIL);

          if (globalvar->variable_specialP &&
              (special_implementation_style() == KWD_CPP_TRANSLATE_UNBIND_WITH_DESTRUCTORS)) {
            otree = listO(5, SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_METHOD_CALL, SYM_CPP_TRANSLATE_STELLA_NULL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(SYM_CPP_TRANSLATE_STELLA_GET), NIL), otree, cons(cons(SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, NIL), NIL));
          }
          return (otree);
        }
      }
      else {
        return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(tree), NIL));
      }
    }
  }
}

Cons* Quoted_Expression::cpp_translate_atomic_tree() {
  { Quoted_Expression* tree = this;

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL, tree, NIL));
  }
}

Cons* cpp_translate_let_tree(Cons* tree) {
  { Cons* odeclarations = NIL;

    { Object* declaration = NULL;
      Cons* iter_000 = ((Cons*)(tree->rest->value));

      while (!(iter_000 == NIL)) {
        declaration = iter_000->value;
        iter_000 = iter_000->rest;
        { Cons* d = ((Cons*)(declaration));

          odeclarations = cons(cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(d->rest->value))), cons(cpp_translate_a_tree(d->value), cons(cpp_translate_a_tree(d->rest->rest->value), NIL))), odeclarations);
        }
      }
    }
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK, odeclarations->reverse(), cons(cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(tree->rest->rest)->concatenate(NIL, 0)), NIL)));
  }
}

String_Wrapper* cpp_translate_type_spec(Standard_Object* typespec) {
  { Surrogate* test_value_000 = safe_primary_type(typespec);

    if (subtype_of_parametric_type_specifierP(test_value_000)) {
      { Standard_Object* typespec_000 = typespec;
        Parametric_Type_Specifier* typespec = ((Parametric_Type_Specifier*)(typespec_000));

        if (array_type_specifierP(typespec)) {
          return (cpp_translate_array_type(typespec));
        }
        if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_CPP_TRANSLATE_CPP_STANDALONE) {
          return (wrap_string(string_concatenate(cpp_translate_type_spec(typespec->specifier_base_type)->wrapper_value, "<", 2, cpp_translate_and_pointerize_type_spec(((Standard_Object*)(typespec->specifier_parameter_types->first())))->wrapper_value, ">")));
        }
        else if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_CPP_TRANSLATE_CPP) {
          return (cpp_translate_type_spec(typespec->specifier_base_type));
        }
        else {
          { Output_String_Stream* stream_000 = new_output_string_stream();

            *(stream_000->native_stream) << "`" << oTRANSLATOROUTPUTLANGUAGEo.get() << "'" << " is not a valid case option";
            throw *new_stella_exception(stream_000->the_string_reader());
          }
        }
      }
    }
    else if (subtype_of_surrogateP(test_value_000)) {
      { Standard_Object* typespec_001 = typespec;
        Surrogate* typespec = ((Surrogate*)(typespec_001));

        if (((String_Wrapper*)(dynamic_slot_value(((Class*)(typespec->surrogate_value))->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE, NULL_STRING_WRAPPER)))->wrapper_value != NULL) {
          return (wrap_string(((String_Wrapper*)(dynamic_slot_value(((Class*)(typespec->surrogate_value))->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE, NULL_STRING_WRAPPER)))->wrapper_value));
        }
        else {
          return (cpp_translate_class_typename(type_to_symbol(((Class*)(typespec->surrogate_value))->class_type)));
        }
      }
    }
    else {
      { Output_String_Stream* stream_001 = new_output_string_stream();

        *(stream_001->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
        throw *new_stella_exception(stream_001->the_string_reader());
      }
    }
  }
}

String_Wrapper* cpp_translate_and_pointerize_type_spec(Standard_Object* typespec) {
  { Surrogate* basetype = type_spec_to_base_type(typespec);
    String_Wrapper* translatedtype = cpp_translate_type_spec(typespec);

    if (create_native_classP(((Class*)(basetype->surrogate_value))) ||
        exception_classP(((Class*)(basetype->surrogate_value)))) {
      translatedtype->wrapper_value = string_concatenate(translatedtype->wrapper_value, "*", 0);
    }
    return (translatedtype);
  }
}

String_Wrapper* cpp_translate_and_referencize_type_spec(Standard_Object* typespec) {
  { Surrogate* basetype = type_spec_to_base_type(typespec);
    String_Wrapper* translatedtype = cpp_translate_type_spec(typespec);

    translatedtype->wrapper_value = (cpp_translated_array_typeP(translatedtype) ? cpp_generate_array_typed_entity("&", translatedtype->wrapper_value) : string_concatenate(translatedtype->wrapper_value, (create_native_classP(((Class*)(basetype->surrogate_value))) ? (char*)"*&" : (char*)"&"), 0));
    return (translatedtype);
  }
}

String_Wrapper* cpp_translate_array_type(Parametric_Type_Specifier* arraytype) {
  { boolean dummy1;

    { List* dimensions = array_type_dimensions(arraytype);
      Standard_Object* elementtype = extract_parameter_type(arraytype, SYM_CPP_TRANSLATE_STELLA_ANY_VALUE, dummy1);
      char* translatedtype = "";
      char* temp = NULL;

      if (dimensions->length() == 1) {
        return (wrap_string(string_concatenate(cpp_translate_and_pointerize_type_spec(elementtype)->wrapper_value, "*", 0)));
      }
      { Integer_Wrapper* dim = NULL;
        int i = NULL_INTEGER;
        Cons* iter_000 = dimensions->the_cons_list;
        int iter_001 = 0;

        while (!(iter_000 == NIL)) {
          dim = ((Integer_Wrapper*)(iter_000->value));
          iter_000 = iter_000->rest;
          i = iter_001;
          iter_001 = iter_001 + 1;
          if (i == 0) {
            temp = "(*)";
          }
          else if (!((boolean)(dim))) {
            temp = "[]";
          }
          else {
            temp = string_concatenate("[", stringify(dim), 1, "]");
          }
          translatedtype = string_concatenate(translatedtype, temp, 0);
        }
      }
      if (array_type_specifierP(elementtype)) {
        { 
          BIND_STELLA_SPECIAL(oPRINTREADABLYpo, boolean, TRUE);
          signal_translation_error();
          if (!(suppress_warningsP())) {
            print_error_context(">> ERROR: ", STANDARD_ERROR);
            *(STANDARD_ERROR->native_stream) << endl << " " << "Can't yet handle nested arrays in C++: " << "`" << de_uglify_parse_tree(arraytype) << "'" << "." << endl;
          }
        }
        elementtype = SGT_CPP_TRANSLATE_STELLA_UNKNOWN;
      }
      temp = cpp_translate_and_pointerize_type_spec(elementtype)->wrapper_value;
      translatedtype = string_concatenate(temp, " ", 1, translatedtype);
      return (wrap_string(translatedtype));
    }
  }
}

boolean cpp_translated_array_typeP(Object* translatedtype) {
  { Surrogate* test_value_000 = safe_primary_type(translatedtype);

    if (test_value_000 == SGT_CPP_TRANSLATE_STELLA_CONS) {
      { Object* translatedtype_000 = translatedtype;
        Cons* translatedtype = ((Cons*)(translatedtype_000));

        return (cpp_translated_array_typeP(translatedtype->last()));
      }
    }
    else if (subtype_of_stringP(test_value_000)) {
      { Object* translatedtype_001 = translatedtype;
        String_Wrapper* translatedtype = ((String_Wrapper*)(translatedtype_001));

        { char* transtype = translatedtype->wrapper_value;

          return ((transtype[(strlen(transtype) - 1)] == ']') &&
              ((string_search(transtype, "(*)", 0) != NULL_INTEGER) ||
               (string_search(transtype, "(*&)", 0) != NULL_INTEGER)));
        }
      }
    }
    else {
    }
  }
  return (FALSE);
}

char* cpp_generate_array_typed_entity(char* entity, char* translatedarraytype) {
  { boolean referencetypeP = string_search(translatedarraytype, "(*&)", 0) != NULL_INTEGER;

    if (referencetypeP) {
      return (replace_substrings(translatedarraytype, string_concatenate("(*&", entity, 1, ")"), "(*&)"));
    }
    else {
      return (replace_substrings(translatedarraytype, string_concatenate("(*", entity, 1, ")"), "(*)"));
    }
  }
}

char* cpp_create_character_substitution_table() {
  { char* table = make_string(256, '_');

    { int code = NULL_INTEGER;
      int iter_000 = (int)(unsigned char) '0';
      int upper_bound_000 = (int)(unsigned char) '9';
      boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

      while (unboundedP_000 ||
          (iter_000 <= upper_bound_000)) {
        code = iter_000;
        iter_000 = iter_000 + 1;
        table[code] = '=';
      }
    }
    { int code = NULL_INTEGER;
      int iter_001 = (int)(unsigned char) 'A';
      int upper_bound_001 = (int)(unsigned char) 'Z';
      boolean unboundedP_001 = upper_bound_001 == NULL_INTEGER;

      while (unboundedP_001 ||
          (iter_001 <= upper_bound_001)) {
        code = iter_001;
        iter_001 = iter_001 + 1;
        table[code] = '=';
      }
    }
    { int code = NULL_INTEGER;
      int iter_002 = (int)(unsigned char) 'a';
      int upper_bound_002 = (int)(unsigned char) 'z';
      boolean unboundedP_002 = upper_bound_002 == NULL_INTEGER;

      while (unboundedP_002 ||
          (iter_002 <= upper_bound_002)) {
        code = iter_002;
        iter_002 = iter_002 + 1;
        table[code] = '=';
      }
    }
    table[((int)(unsigned char) '_')] = '=';
    table[((int)(unsigned char) ' ')] = '_';
    table[((int)(unsigned char) '!')] = 'X';
    table[((int)(unsigned char) '"')] = '_';
    table[((int)(unsigned char) '#')] = 'H';
    table[((int)(unsigned char) '$')] = 'B';
    table[((int)(unsigned char) '%')] = 'R';
    table[((int)(unsigned char) '&')] = 'A';
    table[((int)(unsigned char) '\'')] = 'Q';
    table[((int)(unsigned char) '(')] = '_';
    table[((int)(unsigned char) ')')] = '_';
    table[((int)(unsigned char) '*')] = 'O';
    table[((int)(unsigned char) '+')] = 'I';
    table[((int)(unsigned char) ',')] = '_';
    table[((int)(unsigned char) '-')] = '_';
    table[((int)(unsigned char) '.')] = 'D';
    table[((int)(unsigned char) '/')] = 'S';
    table[((int)(unsigned char) ':')] = 'C';
    table[((int)(unsigned char) ';')] = '_';
    table[((int)(unsigned char) '<')] = 'L';
    table[((int)(unsigned char) '=')] = 'E';
    table[((int)(unsigned char) '>')] = 'G';
    table[((int)(unsigned char) '?')] = 'P';
    table[((int)(unsigned char) '@')] = 'M';
    table[((int)(unsigned char) '[')] = 'J';
    table[((int)(unsigned char) '\\')] = '_';
    table[((int)(unsigned char) ']')] = 'K';
    table[((int)(unsigned char) '^')] = 'U';
    table[((int)(unsigned char) '`')] = '_';
    table[((int)(unsigned char) '{')] = 'Y';
    table[((int)(unsigned char) '|')] = 'V';
    table[((int)(unsigned char) '}')] = 'Z';
    table[((int)(unsigned char) '~')] = 'T';
    return (table);
  }
}

char* oCPP_CHARACTER_SUBSTITUTION_TABLEo = NULL;

char* replace_first_character_with_string(char* string, char* newprefix) {
  return (string_concatenate(newprefix, string_subsequence(string, 1, NULL_INTEGER)));
}

char* cpp_substitute_forbidden_characters(char* name, Keyword* caseconvention) {
  { char* result = NULL;
    char substitution = NULL_CHARACTER;

    switch (name[0]) {
      case '0': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "zero"));
      break;
      case '1': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "one"));
      break;
      case '2': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "two"));
      break;
      case '3': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "three"));
      break;
      case '4': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "four"));
      break;
      case '5': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "five"));
      break;
      case '6': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "six"));
      break;
      case '7': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "seven"));
      break;
      case '8': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "eight"));
      break;
      case '9': 
        result = string_to_mutable_string(replace_first_character_with_string(name, "nine"));
      break;
      default:
        result = strcpy(new (GC) char[strlen(name)+1], name);
      break;
    }
    { int i = NULL_INTEGER;
      int iter_000 = 0;
      int upper_bound_000 = strlen(result) - 1;

      while (iter_000 <= upper_bound_000) {
        i = iter_000;
        iter_000 = iter_000 + 1;
        substitution = oCPP_CHARACTER_SUBSTITUTION_TABLEo[((int)(unsigned char) (result[i]))];
        if (!(substitution == '=')) {
          if (caseconvention == KWD_CPP_TRANSLATE_UPPERCASE) {
            result[i] = (oCHARACTER_DOWNCASE_TABLEo[((int)(unsigned char) substitution)]);
          }
          else if (caseconvention == KWD_CPP_TRANSLATE_LOWERCASE) {
            result[i] = (oCHARACTER_UPCASE_TABLEo[((int)(unsigned char) substitution)]);
          }
          else if (caseconvention == KWD_CPP_TRANSLATE_CAPITALIZED) {
            result[i] = (oCHARACTER_UPCASE_TABLEo[((int)(unsigned char) substitution)]);
          }
          else {
            { Output_String_Stream* stream_000 = new_output_string_stream();

              *(stream_000->native_stream) << "`" << caseconvention << "'" << " is not a valid case option";
              throw *new_stella_exception(stream_000->the_string_reader());
            }
          }
        }
      }
    }
    return (result);
  }
}

char* cpp_change_case(Generalized_Symbol* symbol, Keyword* caseconvention) {
  { Memoization_Table* memo_table_000 = ((Memoization_Table*)(SGT_CPP_TRANSLATE_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000->surrogate_value));
    Cons* memoized_entry_000 = NULL;
    Object* memoized_value_000 = NULL;

    if (!((boolean)(memo_table_000))) {
      initialize_memoization_table(SGT_CPP_TRANSLATE_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000, "(:MAX-VALUES 2000)");
      memo_table_000 = ((Memoization_Table*)(SGT_CPP_TRANSLATE_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000->surrogate_value));
    }
    if (oMEMOIZATION_ENABLEDpo) {
      memoized_entry_000 = lookup_mru_memoized_value(((Mru_Memoization_Table*)(memo_table_000)), symbol, caseconvention, oMODULEo.get(), MEMOIZED_NULL_VALUE, -1);
      memoized_value_000 = memoized_entry_000->value;
    }
    if (((boolean)(memoized_value_000))) {
      if (memoized_value_000 == MEMOIZED_NULL_VALUE) {
        memoized_value_000 = NULL;
      }
    }
    else {
      memoized_value_000 = wrap_string(help_cpp_change_case(symbol, caseconvention));
      if (oMEMOIZATION_ENABLEDpo) {
        memoized_entry_000->value = ((!((boolean)(memoized_value_000))) ? MEMOIZED_NULL_VALUE : memoized_value_000);
      }
    }
    { Object* value_000 = memoized_value_000;

      return (((String_Wrapper*)(value_000))->wrapper_value);
    }
  }
}

char* help_cpp_change_case(Generalized_Symbol* symbol, Keyword* caseconvention) {
  { Module* module = ((Module*)(symbol->home_context));
    char* name = symbol->symbol_name;

    if (!((boolean)(module))) {
      module = oMODULEo.get();
    }
    if (module->case_sensitiveP ||
        (!(compute_symbol_escape_code(name, FALSE) == KWD_CPP_TRANSLATE_UNESCAPED))) {
      return (make_matching_name_full(name, KWD_CPP_TRANSLATE_NO, KWD_CPP_TRANSLATE_NO, "- ", "", "", "", "", KWD_CPP_TRANSLATE_PRESERVE, "_"));
    }
    if (caseconvention == KWD_CPP_TRANSLATE_UPPERCASE) {
      return (make_matching_name_full(name, KWD_CPP_TRANSLATE_NO, KWD_CPP_TRANSLATE_NO, "- ", "", "", "", "", KWD_CPP_TRANSLATE_UPCASE, "_"));
    }
    else if (caseconvention == KWD_CPP_TRANSLATE_LOWERCASE) {
      return (make_matching_name_full(name, KWD_CPP_TRANSLATE_NO, KWD_CPP_TRANSLATE_NO, "- ", "", "", "", "", KWD_CPP_TRANSLATE_DOWNCASE, "_"));
    }
    else if (caseconvention == KWD_CPP_TRANSLATE_CAPITALIZED) {
      return (make_matching_name_full(name, KWD_CPP_TRANSLATE_NO, KWD_CPP_TRANSLATE_NO, "- ", "", "", "", "", KWD_CPP_TRANSLATE_TITLECASE, "_"));
    }
    else {
      { Output_String_Stream* stream_000 = new_output_string_stream();

        *(stream_000->native_stream) << "`" << caseconvention << "'" << " is not a valid case option";
        throw *new_stella_exception(stream_000->the_string_reader());
      }
    }
  }
}

char* cpp_yield_namespace_prefix_from_module(Module* module) {
  if (!((boolean)(module))) {
    module = oMODULEo.get();
  }
  { char* packageprefix = module->cpp_package();
    boolean packageprefixinheritedP = ((String_Wrapper*)(dynamic_slot_value(module->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_MODULE_CPP_PACKAGE, NULL_STRING_WRAPPER)))->wrapper_value == NULL;

    if (packageprefixinheritedP) {
      { char* relativemodulepath = module->module_full_name;

        return (string_concatenate(packageprefix, cpp_substitute_forbidden_characters(string_substitute(string_downcase(relativemodulepath), '_', '/'), KWD_CPP_TRANSLATE_LOWERCASE), 0));
      }
    }
    else {
      return (packageprefix);
    }
  }
}

char* cpp_yield_namespace_prefix(Generalized_Symbol* symbol) {
  return (cpp_yield_namespace_prefix_from_module(((Module*)(symbol->home_context))));
}

DEFINE_STELLA_SPECIAL(oCPP_NAME_QUALIFICATION_MODEo, Keyword* , NULL);

Keyword* cpp_name_qualification_mode() {
  return (oCPP_NAME_QUALIFICATION_MODEo.get());
}

boolean cpp_qualify_nameP(Generalized_Symbol* namesymbol) {
  { Module* symbolmodule = ((Module*)(namesymbol->home_context));
    Module* namespacemodule = (((boolean)(oCPP_CURRENT_UNIT_MODULEo.get())) ? oCPP_CURRENT_UNIT_MODULEo.get() : oMODULEo.get());

    if ((!((boolean)(symbolmodule))) ||
        (namesymbol == SYM_CPP_TRANSLATE_STELLA_NULL)) {
      return (FALSE);
    }
    if (oCPP_NAME_QUALIFICATION_MODEo.get() == KWD_CPP_TRANSLATE_FULL) {
      return (TRUE);
    }
    else if (oCPP_NAME_QUALIFICATION_MODEo.get() == KWD_CPP_TRANSLATE_NEVER) {
      return (FALSE);
    }
    else if (oCPP_NAME_QUALIFICATION_MODEo.get() == KWD_CPP_TRANSLATE_CLEVER) {
      if (symbolmodule == namespacemodule) {
        return (FALSE);
      }
      else if (!visible_fromP(symbolmodule, namespacemodule)) {
        return (TRUE);
      }
      else {
        { Surrogate* test_value_000 = safe_primary_type(namesymbol);

          if (subtype_of_symbolP(test_value_000)) {
            { Generalized_Symbol* namesymbol_000 = namesymbol;
              Symbol* namesymbol = ((Symbol*)(namesymbol_000));

              return (!(lookup_visible_symbols_in_module(namesymbol->symbol_name, namespacemodule, FALSE)->rest == NIL));
            }
          }
          else if (subtype_of_surrogateP(test_value_000)) {
            { Generalized_Symbol* namesymbol_001 = namesymbol;
              Surrogate* namesymbol = ((Surrogate*)(namesymbol_001));

              return (!(lookup_visible_surrogates_in_module(namesymbol->symbol_name, namespacemodule, FALSE)->rest == NIL));
            }
          }
          else {
            { Output_String_Stream* stream_000 = new_output_string_stream();

              *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
              throw *new_stella_exception(stream_000->the_string_reader());
            }
          }
        }
      }
    }
    else {
      { Output_String_Stream* stream_001 = new_output_string_stream();

        *(stream_001->native_stream) << "`" << oCPP_NAME_QUALIFICATION_MODEo.get() << "'" << " is not a valid case option";
        throw *new_stella_exception(stream_001->the_string_reader());
      }
    }
  }
}

char* oCPP_NAMESPACE_SEPARATORo = "::";

char* cpp_yield_qualified_name(char* translatedname, Generalized_Symbol* sourcesymbol) {
  if (!(cpp_qualify_nameP(sourcesymbol))) {
    return (translatedname);
  }
  { char* prefix = cpp_yield_namespace_prefix(sourcesymbol);

    if (string_eqlP(prefix, "")) {
      return (translatedname);
    }
    else {
      return (string_concatenate(prefix, oCPP_NAMESPACE_SEPARATORo, 1, translatedname));
    }
  }
}

String_Wrapper* cpp_translate_name(Symbol* namesymbol) {
  { String_Wrapper* reservedname = cpp_lookup_reserved_word_table(namesymbol);

    if (!((boolean)(namesymbol))) {
      return (wrap_string("NULL"));
    }
    if (((boolean)(reservedname))) {
      return (reservedname);
    }
    return (wrap_string(cpp_substitute_forbidden_characters(cpp_change_case(namesymbol, KWD_CPP_TRANSLATE_LOWERCASE), KWD_CPP_TRANSLATE_LOWERCASE)));
  }
}

String_Wrapper* cpp_translate_global_name(Symbol* namesymbol) {
  if (!((boolean)(namesymbol))) {
    return (wrap_string("NULL"));
  }
  return (wrap_string(cpp_yield_qualified_name(cpp_substitute_forbidden_characters(cpp_change_case(namesymbol, KWD_CPP_TRANSLATE_UPPERCASE), KWD_CPP_TRANSLATE_UPPERCASE), namesymbol)));
}

String_Wrapper* cpp_translate_class_parameter_name(Symbol* namesymbol) {
  return (wrap_string(cpp_substitute_forbidden_characters(cpp_change_case(namesymbol, KWD_CPP_TRANSLATE_UPPERCASE), KWD_CPP_TRANSLATE_UPPERCASE)));
}

String_Wrapper* cpp_translate_return_parameter_name(Symbol* namesymbol, int parameternumber) {
  { Symbol* returnsymbol = intern_symbol(string_concatenate(namesymbol->symbol_name, integer_to_string(parameternumber), 0));
    String_Wrapper* translatedname = cpp_translate_name(returnsymbol);

    return (translatedname);
  }
}

String_Wrapper* cpp_translate_symbol_constant_name(Generalized_Symbol* symbol) {
  { char* prefix = NULL;

    { Surrogate* test_value_000 = safe_primary_type(symbol);

      if (subtype_of_symbolP(test_value_000)) {
        { Generalized_Symbol* symbol_000 = symbol;
          Symbol* symbol = ((Symbol*)(symbol_000));

          prefix = string_concatenate("SYM_", ((Module*)(symbol->home_context))->context_name(), 0);
        }
      }
      else if (subtype_of_surrogateP(test_value_000)) {
        { Generalized_Symbol* symbol_001 = symbol;
          Surrogate* symbol = ((Surrogate*)(symbol_001));

          prefix = string_concatenate("SGT_", ((Module*)(symbol->home_context))->context_name(), 0);
        }
      }
      else if (subtype_of_keywordP(test_value_000)) {
        { Generalized_Symbol* symbol_002 = symbol;
          Keyword* symbol = ((Keyword*)(symbol_002));

          prefix = "KWD";
        }
      }
      else {
        { Output_String_Stream* stream_000 = new_output_string_stream();

          *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
          throw *new_stella_exception(stream_000->the_string_reader());
        }
      }
    }
    return (wrap_string(cpp_substitute_forbidden_characters(string_concatenate(prefix, string_concatenate("_", symbol->symbol_name, 0), 0), KWD_CPP_TRANSLATE_UPPERCASE)));
  }
}

String_Wrapper* cpp_translate_symbol_constant_id(Generalized_Symbol* symbol) {
  { String_Wrapper* translatedsymbol = cpp_translate_symbol_constant_name(symbol);

    translatedsymbol->wrapper_value = string_concatenate(translatedsymbol->wrapper_value, "_id", 0);
    return (translatedsymbol);
  }
}

String_Wrapper* cpp_translate_symbol_name(Symbol* symbol) {
  return (cpp_translate_symbol_constant_name(symbol));
}

String_Wrapper* cpp_translate_symbol_id(Symbol* symbol) {
  return (cpp_translate_symbol_constant_id(symbol));
}

String_Wrapper* cpp_translate_surrogate_name(Surrogate* surrogate) {
  return (cpp_translate_symbol_constant_name(surrogate));
}

String_Wrapper* cpp_translate_surrogate_id(Surrogate* surrogate) {
  return (cpp_translate_symbol_constant_id(surrogate));
}

String_Wrapper* cpp_translate_keyword_name(Keyword* keyword) {
  return (cpp_translate_symbol_constant_name(keyword));
}

String_Wrapper* cpp_translate_keyword_id(Keyword* keyword) {
  return (cpp_translate_symbol_constant_id(keyword));
}

String_Wrapper* cpp_translate_class_typename(Generalized_Symbol* namesymbol) {
  { Surrogate* realnamesymbol = ((Class*)(namesymbol->surrogatify()->surrogate_value))->class_type;

    return (wrap_string(cpp_yield_qualified_name(cpp_substitute_forbidden_characters(cpp_change_case(realnamesymbol, KWD_CPP_TRANSLATE_CAPITALIZED), KWD_CPP_TRANSLATE_CAPITALIZED), realnamesymbol)));
  }
}

String_Wrapper* cpp_translate_class_name(Generalized_Symbol* namesymbol) {
  return (cpp_translate_type_spec(namesymbol->surrogatify()));
}

boolean cpp_reference_typeP(Standard_Object* typespec) {
  return (FALSE);
}

String_Wrapper* cpp_referencize_type(Standard_Object* typespec) {
  return (wrap_string(string_substitute(cpp_translate_type_spec(typespec)->wrapper_value, '&', '*')));
}

Object* cpp_translate_function_parameter(Symbol* name, Standard_Object* type, Method_Slot* method) {
  type = compute_relative_type_spec(type, method->slot_owner);
  if (((Boolean_Wrapper*)(dynamic_slot_value(method->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp, FALSE_WRAPPER)))->wrapper_value &&
      ((variable_arguments_name(method) == name) &&
       pass_variable_arguments_as_listP(method))) {
    type = yield_listified_variable_arguments_type(method);
  }
  return (cons((cpp_reference_typeP(type) ? cpp_referencize_type(type) : cpp_translate_and_pointerize_type_spec(type)), cons(cpp_translate_name(name), NIL)));
}

Cons* cpp_translate_return_parameter(int parameternumber, Standard_Object* parametertype) {
  return (cons(cpp_translate_and_referencize_type_spec(parametertype), cons(cpp_translate_return_parameter_name(SYM_CPP_TRANSLATE_STELLA__RETURN, parameternumber), NIL)));
}

Cons* cpp_translate_function_parameters(Method_Slot* method) {
  { boolean skipfirstparameterP = !cpp_method_object_is_functionP(method);
    boolean variableargumentsP = ((Boolean_Wrapper*)(dynamic_slot_value(method->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp, FALSE_WRAPPER)))->wrapper_value &&
        (!pass_variable_arguments_as_listP(method));
    Cons* translatedparameters = NIL;

    { Symbol* pname = NULL;
      Standard_Object* ptype = NULL;
      int i = NULL_INTEGER;
      Cons* iter_000 = method->method_parameter_names_reader()->the_cons_list;
      Cons* iter_001 = method->method_parameter_type_specifiers_reader()->the_cons_list;
      int iter_002 = 1;
      Cons* collect_000 = NULL;

      while ((!(iter_000 == NIL)) &&
          (!(iter_001 == NIL))) {
        pname = ((Symbol*)(iter_000->value));
        iter_000 = iter_000->rest;
        ptype = ((Standard_Object*)(iter_001->value));
        iter_001 = iter_001->rest;
        i = iter_002;
        iter_002 = iter_002 + 1;
        if (((!skipfirstparameterP) ||
            (i > 1)) &&
            ((!variableargumentsP) ||
             (!(pname == variable_arguments_name(method))))) {
          if (!((boolean)(collect_000))) {
            {
              collect_000 = cons(cpp_translate_function_parameter(pname, ptype, method), NIL);
              if (translatedparameters == NIL) {
                translatedparameters = collect_000;
              }
              else {
                add_cons_to_end_of_cons_list(translatedparameters, collect_000);
              }
            }
          }
          else {
            {
              collect_000->rest = cons(cpp_translate_function_parameter(pname, ptype, method), NIL);
              collect_000 = collect_000->rest;
            }
          }
        }
      }
    }
    { Standard_Object* rtype = NULL;
      int rtypeindex = NULL_INTEGER;
      Cons* iter_003 = method->method_return_type_specifiers_reader()->rest();
      int iter_004 = 1;
      Cons* collect_001 = NULL;

      while (!(iter_003 == NIL)) {
        rtype = ((Standard_Object*)(iter_003->value));
        iter_003 = iter_003->rest;
        rtypeindex = iter_004;
        iter_004 = iter_004 + 1;
        if (!((boolean)(collect_001))) {
          {
            collect_001 = cons(cpp_translate_return_parameter(rtypeindex, rtype), NIL);
            if (translatedparameters == NIL) {
              translatedparameters = collect_001;
            }
            else {
              add_cons_to_end_of_cons_list(translatedparameters, collect_001);
            }
          }
        }
        else {
          {
            collect_001->rest = cons(cpp_translate_return_parameter(rtypeindex, rtype), NIL);
            collect_001 = collect_001->rest;
          }
        }
      }
    }
    return (translatedparameters->concatenate(((variableargumentsP ? cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_VAR_ARGS, cpp_translate_name(variable_arguments_name(method)), NIL), NIL) : NIL))->concatenate(NIL, 0), 0));
  }
}

boolean slot_reader_from_nameP(Symbol* methodname, Standard_Object* methodowner) {
  { Class* ownerclass = ((Class*)(((Surrogate*)(methodowner))->surrogate_value));
    Slot* slot = lookup_slot(ownerclass, methodname);

    return (((boolean)(slot)) &&
        isaP(slot, SGT_CPP_TRANSLATE_STELLA_STORAGE_SLOT));
  }
}

boolean slot_readerP(Method_Slot* method) {
  { Slot* lookedupslot = NULL;

    if (!(method->method_functionP)) {
      lookedupslot = lookup_slot(((Class*)(method->slot_owner->surrogate_value)), method->slot_name);
    }
    return (((boolean)(lookedupslot)) &&
        isaP(lookedupslot, SGT_CPP_TRANSLATE_STELLA_STORAGE_SLOT));
  }
}

String_Wrapper* cpp_translate_constructor_name(Method_Slot* constructor) {
  return (cpp_translate_class_name(constructor->slot_name));
}

String_Wrapper* cpp_translate_function_name_from_name(Symbol* functionname) {
  { Method_Slot* function = lookup_function(functionname);

    if (((boolean)(function))) {
      return (cpp_translate_function_name(function));
    }
    else {
      return (cpp_translate_name(functionname));
    }
  }
}

String_Wrapper* cpp_translate_function_name(Method_Slot* function) {
  { Symbol* functionname = yield_renamed_name_if_native(function->slot_name, KWD_CPP_TRANSLATE_CPP, KWD_CPP_TRANSLATE_FUNCTION);
    char* translatedname = NULL;

    if (cpp_method_object_is_overloaded_functionP(function)) {
      functionname = cpp_create_overloaded_function_name(functionname, function->slot_owner);
    }
    translatedname = cpp_translate_name(functionname)->wrapper_value;
    if (function->method_setterP) {
      translatedname = string_concatenate(translatedname, "_setter", 0);
    }
    if (slot_readerP(function)) {
      translatedname = string_concatenate(translatedname, "_reader", 0);
    }
    return (wrap_string(cpp_yield_qualified_name(translatedname, function->slot_name)));
  }
}

String_Wrapper* cpp_translate_method_name_from_name(Symbol* methodname, Standard_Object* methodowner) {
  { char* translatedname = cpp_translate_name(yield_renamed_name_if_native(methodname, KWD_CPP_TRANSLATE_CPP, KWD_CPP_TRANSLATE_FUNCTION))->wrapper_value;

    if (slot_reader_from_nameP(methodname, methodowner)) {
      translatedname = string_concatenate(translatedname, "_reader", 0);
    }
    return (wrap_string(string_concatenate(cpp_translate_class_name(((Generalized_Symbol*)(methodowner)))->wrapper_value, "::", 1, translatedname)));
  }
}

String_Wrapper* cpp_translate_method_name(Method_Slot* method) {
  { Surrogate* methodtype = method->slot_owner;
    String_Wrapper* translatedname = cpp_translate_function_name(method);

    if (cpp_method_object_is_functionP(method)) {
      return (translatedname);
    }
    else {
      return (wrap_string(string_concatenate(cpp_translate_class_name(intern_symbol_in_module(methodtype->symbol_name, ((Module*)(methodtype->home_context)), TRUE))->wrapper_value, "::", 1, translatedname->wrapper_value)));
    }
  }
}

Cons* delete_quoted_null_statements(Cons* trees) {
  return (trees->remove(SYM_CPP_TRANSLATE_STELLA_NULL));
}

boolean cpp_method_object_is_functionP(Method_Slot* method) {
  return (method->method_functionP ||
      cpp_method_object_is_overloaded_functionP(method));
}

boolean cpp_method_object_is_overloaded_functionP(Method_Slot* method) {
  return ((!method->method_functionP) &&
      ((((String_Wrapper*)(dynamic_slot_value(((Class*)(method->slot_owner->surrogate_value))->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE, NULL_STRING_WRAPPER)))->wrapper_value != NULL) &&
       ((!((Boolean_Wrapper*)(dynamic_slot_value(method->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_METHOD_NATIVEp, FALSE_WRAPPER)))->wrapper_value) ||
        subtype_ofP(method->slot_owner, SGT_CPP_TRANSLATE_STELLA_LITERAL))));
}

Cons* wrap_method_body_with_cpp_auxiliary_declarations(Cons* methodbody, Cons* declarations) {
  { Cons* odeclarations = NIL;
    Cons* otree = NULL;

    declarations = declarations->reverse();
    { Object* declaration = NULL;
      Cons* iter_000 = declarations;

      while (!(iter_000 == NIL)) {
        declaration = iter_000->value;
        iter_000 = iter_000->rest;
        { Cons* d = ((Cons*)(declaration));

          odeclarations = cons(cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(d->rest->value))), cons(cpp_translate_a_tree(d->value), ((((boolean)(d->rest->rest->value)) ? cons_list(1, cpp_translate_a_tree(d->rest->rest->value)) : NIL))->concatenate(NIL, 0))), odeclarations);
        }
      }
    }
    otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK, odeclarations->reverse(), cons(methodbody, NIL)), NIL);
    return (otree);
  }
}

Cons* cpp_translate_define_method_unit(Translation_Unit* unit) {
  { 
    BIND_STELLA_SPECIAL(oMETHODBEINGWALKEDo, Method_Slot*, NULL);
    BIND_STELLA_SPECIAL(oCURRENTDUMMYINDEXo, int, 0);
    BIND_STELLA_SPECIAL(oDUMMYDECLARATIONSo, Cons*, NIL);
    { Method_Slot* method = ((Method_Slot*)(unit->the_object));
      boolean unitisfunction = cpp_method_object_is_functionP(method);
      Cons* bodytree = ((Cons*)(unit->code_register));
      Cons* returntype = NULL;
      Cons* otree = NIL;
      Cons* translatedmethodbody = NULL;

      oMETHODBEINGWALKEDo.set(method);
      bodytree = delete_quoted_null_statements(bodytree);
      if (!unitisfunction) {
        oDUMMYDECLARATIONSo.set(cons(cons(((Symbol*)(method->method_parameter_names_reader()->first())), cons(method->slot_owner, cons(SYM_CPP_TRANSLATE_STELLA_THIS, NIL))), oDUMMYDECLARATIONSo.get()));
      }
      translatedmethodbody = cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, cpp_translate_list_of_trees(bodytree)->concatenate(NIL, 0));
      if (!(oDUMMYDECLARATIONSo.get() == NIL)) {
        translatedmethodbody = wrap_method_body_with_cpp_auxiliary_declarations(translatedmethodbody, oDUMMYDECLARATIONSo.get());
      }
      if (((String_Wrapper*)(dynamic_slot_value(method->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_DOCUMENTATION, NULL_STRING_WRAPPER)))->wrapper_value != NULL) {
        translatedmethodbody->rest = cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_COMMENT, wrap_string(((String_Wrapper*)(dynamic_slot_value(method->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_DOCUMENTATION, NULL_STRING_WRAPPER)))->wrapper_value), NIL), translatedmethodbody->rest->concatenate(NIL, 0));
      }
      returntype = (cpp_constructorP(method) ? NIL : cons(cpp_translate_and_pointerize_type_spec(compute_most_general_return_type(method, method->compute_return_type_spec(method->slot_owner))), NIL));
      otree = cons((unitisfunction ? SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION : SYM_CPP_TRANSLATE_STELLA_CPP_METHOD), cons(returntype, cons(cpp_translate_method_name(method), cons(cpp_translate_function_parameters(method), cons(translatedmethodbody, NIL)))));
      return (otree);
    }
  }
}

Cons* cpp_translate_return_tree(Cons* tree) {
  { Cons* otree = NULL;
    Cons* returnassignments = NIL;
    Cons* returnvariables = NIL;
    Cons* methodotherreturntypes = oMETHODBEINGWALKEDo.get()->method_return_type_specifiers_reader()->rest();
    Object* returnexpression = NULL;
    Cons* translatedreturnexpression = NIL;
    boolean needtemporaryreturnvariableP = FALSE;

    { Object* exp = NULL;
      int parameternum = NULL_INTEGER;
      Cons* iter_000 = tree->rest->rest;
      int iter_001 = 1;

      while (!(iter_000 == NIL)) {
        exp = iter_000->value;
        iter_000 = iter_000->rest;
        parameternum = iter_001;
        iter_001 = iter_001 + 1;
        if (!side_effect_free_expressionP(exp)) {
          needtemporaryreturnvariableP = TRUE;
        }
        returnassignments = cons(listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_return_parameter_name(SYM_CPP_TRANSLATE_STELLA__RETURN, parameternum), NIL), cpp_translate_a_tree(exp), NIL), returnassignments);
      }
    }
    returnassignments = returnassignments->reverse();
    returnexpression = tree->rest->value;
    if ((methodotherreturntypes->length() > 0) &&
        ((tree->rest->rest == NIL) &&
         (consP(returnexpression) &&
          (((boolean)(((Cons*)(returnexpression))->value)) &&
           ((((Cons*)(returnexpression))->value == SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION) ||
            (((Cons*)(returnexpression))->value == SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD)))))) {
      {
        { Standard_Object* type = NULL;
          int parameternum = NULL_INTEGER;
          Cons* iter_002 = methodotherreturntypes;
          int iter_003 = 1;
          Cons* collect_000 = NULL;

          while (!(iter_002 == NIL)) {
            type = ((Standard_Object*)(iter_002->value));
            iter_002 = iter_002->rest;
            parameternum = iter_003;
            iter_003 = iter_003 + 1;
            if (!((boolean)(collect_000))) {
              {
                collect_000 = cons(intern_symbol(cpp_translate_return_parameter_name(SYM_CPP_TRANSLATE_STELLA__RETURN, parameternum)->wrapper_value), NIL);
                if (returnvariables == NIL) {
                  returnvariables = collect_000;
                }
                else {
                  add_cons_to_end_of_cons_list(returnvariables, collect_000);
                }
              }
            }
            else {
              {
                collect_000->rest = cons(intern_symbol(cpp_translate_return_parameter_name(SYM_CPP_TRANSLATE_STELLA__RETURN, parameternum)->wrapper_value), NIL);
                collect_000 = collect_000->rest;
              }
            }
          }
        }
        translatedreturnexpression = cpp_translate_mv_function_call(((Cons*)(returnexpression)), returnvariables);
      }
    }
    else {
      translatedreturnexpression = ((Cons*)(cpp_translate_a_tree(returnexpression)));
    }
    if (returnassignments == NIL) {
      if (tree->rest == NIL) {
        otree = cons(SYM_CPP_TRANSLATE_STELLA_CPP_RETURN, NIL);
      }
      else {
        otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_RETURN, translatedreturnexpression, NIL);
      }
    }
    else {
      if (needtemporaryreturnvariableP) {
        { char* tempvar = "_return_temp";

          otree = listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK, cons(cons(cpp_translate_and_pointerize_type_spec(oMETHODBEINGWALKEDo.get()->compute_return_type_spec(oMETHODBEINGWALKEDo.get()->slot_owner)), listO(3, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string(tempvar), NIL), translatedreturnexpression, NIL)), NIL), cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, returnassignments->concatenate(cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_RETURN, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, wrap_string(tempvar), NIL), NIL), NIL), 0)), NIL);
        }
      }
      else {
        otree = cons(SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS, returnassignments->concatenate(cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_RETURN, translatedreturnexpression, NIL), NIL), 0));
      }
    }
    return (otree);
  }
}

Cons* cpp_translate_actual_parameters(Cons* tree) {
  return (cons(SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, cpp_translate_list_of_trees(tree)->concatenate(NIL, 0)));
}

Cons* cpp_translate_variable_length_actuals(Cons* actuals, Method_Slot* method) {
  { int nofparameters = method->method_parameter_names_reader()->length();
    int restargumentstart = (cpp_method_object_is_functionP(method) ? (nofparameters - 1) : (nofparameters - 2));
    Cons* otree = NIL;
    boolean pusheddummy = FALSE;

    { Object* actual = NULL;
      int i = NULL_INTEGER;
      Cons* iter_000 = actuals;
      int iter_001 = 0;

      while (!(iter_000 == NIL)) {
        actual = iter_000->value;
        iter_000 = iter_000->rest;
        i = iter_001;
        iter_001 = iter_001 + 1;
        if (i == restargumentstart) {
          pusheddummy = TRUE;
          { int result = actuals->length() - restargumentstart;

            otree = cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL, wrap_integer(result), NIL), otree);
          }
        }
        otree = cons(cpp_translate_a_tree(actual), otree);
      }
    }
    if (!(pusheddummy)) {
      otree = cons(listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL, wrap_integer(0), NIL), otree);
    }
    return (cons(SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS, otree->reverse()->concatenate(NIL, 0)));
  }
}

Cons* cpp_translate_call_method_setter(Cons* tree) {
  { Object* methodname = tree->rest->rest->value;
    Object* objectref = cpp_translate_a_tree(tree->fourth());
    Object* valueref = cpp_translate_a_tree(tree->fifth());

    return (listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SETTER_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_name(((Symbol*)(methodname))), NIL), objectref, cons(valueref, NIL)));
  }
}

Symbol* cpp_create_overloaded_function_name(Symbol* functionname, Surrogate* classtype) {
  return (intern_symbol(string_concatenate(classtype->symbol_name, string_concatenate("-", functionname->symbol_name, 0), 0)));
}

Cons* cpp_translate_method_call(Cons* tree, boolean referencedP) {
  { Symbol* methodname = ((Symbol*)(tree->rest->value));
    Surrogate* owner = ((Surrogate*)(tree->value));
    Cons* arguments = tree->rest->rest;

    if ((methodname == SYM_CPP_TRANSLATE_STELLA_DEFINEDp) ||
        (methodname == SYM_CPP_TRANSLATE_STELLA_NULLp)) {
      return (cpp_translate_definedP_method_call(owner, arguments->value, methodname == SYM_CPP_TRANSLATE_STELLA_NULLp));
    }
    else if ((methodname == SYM_CPP_TRANSLATE_STELLA_NTH) ||
        (methodname == SYM_CPP_TRANSLATE_STELLA_NTH_SETTER)) {
      return (cpp_translate_nth_method_call(methodname, owner, arguments));
    }
    else if ((methodname == SYM_CPP_TRANSLATE_STELLA_AREF) ||
        (methodname == SYM_CPP_TRANSLATE_STELLA_AREF_SETTER)) {
      return (cpp_translate_aref_method_call(methodname, owner, arguments));
    }
    else {
      if ((owner == SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST) ||
          (owner == SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST_ITERATOR)) {
        return (cpp_translate_argument_list_tree(methodname, owner, arguments->value));
      }
    }
    return (cpp_translate_normal_method_call(methodname, owner, arguments, referencedP));
  }
}

Cons* cpp_translate_normal_method_call(Symbol* methodname, Surrogate* owner, Cons* arguments, boolean referencedP) {
  { Slot* slot = lookup_slot(((Class*)(owner->surrogate_value)), methodname);
    Method_Slot* method = (method_slotP(slot) ? ((Method_Slot*)(slot)) : NULL);
    Object* firstarg = arguments->value;
    Cons* otherargs = arguments->rest;

    { Cons* renamed_Operator = cpp_lookup_operator_table(methodname->soft_permanentify());

      if (((boolean)(renamed_Operator))) {
        return (cpp_translate_operator_call(renamed_Operator, arguments, arguments->length()));
      }
    }
    if (((boolean)(method)) &&
        cpp_method_object_is_overloaded_functionP(method)) {
      return (cpp_translate_function_call(cons(cpp_create_overloaded_function_name(methodname, owner), arguments->concatenate(NIL, 0)), method));
    }
    { String_Wrapper* translatedname = cpp_translate_name(yield_renamed_name_if_native(methodname, KWD_CPP_TRANSLATE_CPP, KWD_CPP_TRANSLATE_FUNCTION));

      if ((!((boolean)(method))) &&
          slot_reader_from_nameP(methodname, owner)) {
        translatedname->wrapper_value = string_concatenate(translatedname->wrapper_value, "_reader", 0);
      }
      return (cons((referencedP ? SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_METHOD_CALL : SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CALL), listO(4, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_class_name(intern_symbol_in_module(owner->symbol_name, ((Module*)(owner->home_context)), TRUE)), NIL), listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, translatedname, NIL), cpp_translate_a_tree(firstarg), cons(((((boolean)(method)) &&
          (((Boolean_Wrapper*)(dynamic_slot_value(method->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp, FALSE_WRAPPER)))->wrapper_value &&
           (!pass_variable_arguments_as_listP(method)))) ? cpp_translate_variable_length_actuals(otherargs, method) : cpp_translate_actual_parameters(otherargs)), NIL))));
    }
  }
}

Cons* cpp_translate_definedP_method_call(Surrogate* argumenttype, Object* argument, boolean nullP) {
  { Object* nullvalue = type_to_walked_null_value_tree(argumenttype);

    if (optimize_boolean_testsP() &&
        subtype_ofP(argumenttype, SGT_CPP_TRANSLATE_STELLA_OBJECT)) {
      argument = listO(3, SYM_CPP_TRANSLATE_STELLA_CAST, argument, cons(SGT_CPP_TRANSLATE_STELLA_BOOLEAN, NIL));
      if (nullP) {
        return (cpp_translate_operator_call(cpp_lookup_operator_table(SYM_CPP_TRANSLATE_STELLA_NOT), cons(argument, NIL), 1));
      }
      else {
        return (((Cons*)(cpp_translate_a_tree(argument))));
      }
    }
    else {
      return (cpp_translate_operator_call(cpp_lookup_operator_table((nullP ? SYM_CPP_TRANSLATE_STELLA_EQp : SYM_CPP_TRANSLATE_STELLA_xe)), cons(argument, cons(nullvalue, NIL)), 2));
    }
  }
}

Cons* cpp_translate_nth_method_call(Symbol* renamed_Operator, Surrogate* owner, Cons* arguments) {
  { boolean setterP = renamed_Operator == SYM_CPP_TRANSLATE_STELLA_NTH_SETTER;
    Object* collection = arguments->value;
    Object* position = arguments->last();
    Object* value = (setterP ? arguments->rest->value : ((Object*)(NULL)));
    Cons* tree = NULL;

    if ((owner == SGT_CPP_TRANSLATE_STELLA_STRING) ||
        ((owner == SGT_CPP_TRANSLATE_STELLA_MUTABLE_STRING) ||
         (owner == SGT_CPP_TRANSLATE_STELLA_NATIVE_VECTOR))) {
      if ((owner == SGT_CPP_TRANSLATE_STELLA_NATIVE_VECTOR) ||
          method_call_inlining_enabledP()) {
        collection = cpp_translate_a_tree(collection);
        tree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ARRAY_REFERENCE, collection, cons(cpp_translate_a_tree(position), NIL));
        if (setterP) {
          tree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN, tree, cons(cpp_translate_a_tree(value), NIL));
        }
        return (tree);
      }
    }
    else {
    }
    return (cpp_translate_normal_method_call(renamed_Operator, owner, arguments, FALSE));
  }
}

Cons* cpp_translate_aref_method_call(Symbol* renamed_Operator, Surrogate* owner, Cons* arguments) {
  if (owner == SGT_CPP_TRANSLATE_STELLA_ARRAY) {
    { boolean setterP = renamed_Operator == SYM_CPP_TRANSLATE_STELLA_AREF_SETTER;
      Cons* otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ARRAY_REFERENCE, cpp_translate_a_tree(arguments->value), cpp_translate_list_of_trees((setterP ? arguments->rest->rest : arguments->rest))->concatenate(NIL, 0));

      if (setterP) {
        otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN, otree, cons(cpp_translate_a_tree(arguments->rest->value), NIL));
      }
      return (otree);
    }
  }
  else {
    { Output_String_Stream* stream_000 = new_output_string_stream();

      *(stream_000->native_stream) << "`" << owner << "'" << " is not a valid case option";
      throw *new_stella_exception(stream_000->the_string_reader());
    }
  }
}

Cons* cpp_translate_code_signature(Cons* signature) {
  { Cons* translatedreturntypes = NIL;
    Cons* translatedparametertypes = NIL;

    { Object* returntype = NULL;
      Cons* iter_000 = ((Cons*)(signature->value));
      Cons* collect_000 = NULL;

      while (!(iter_000 == NIL)) {
        returntype = iter_000->value;
        iter_000 = iter_000->rest;
        if (!((boolean)(collect_000))) {
          {
            collect_000 = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(returntype))), NIL);
            if (translatedreturntypes == NIL) {
              translatedreturntypes = collect_000;
            }
            else {
              add_cons_to_end_of_cons_list(translatedreturntypes, collect_000);
            }
          }
        }
        else {
          {
            collect_000->rest = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(returntype))), NIL);
            collect_000 = collect_000->rest;
          }
        }
      }
    }
    { Object* parametertype = NULL;
      Cons* iter_001 = signature->rest;
      Cons* collect_001 = NULL;

      while (!(iter_001 == NIL)) {
        parametertype = iter_001->value;
        iter_001 = iter_001->rest;
        if (!((boolean)(collect_001))) {
          {
            collect_001 = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(parametertype))), NIL);
            if (translatedparametertypes == NIL) {
              translatedparametertypes = collect_001;
            }
            else {
              add_cons_to_end_of_cons_list(translatedparametertypes, collect_001);
            }
          }
        }
        else {
          {
            collect_001->rest = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(parametertype))), NIL);
            collect_001 = collect_001->rest;
          }
        }
      }
    }
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_SIGNATURE, translatedreturntypes, cons(translatedparametertypes, NIL)));
  }
}

Cons* cpp_translate_method_code_signature(Cons* signature) {
  { Cons* translatedreturntypes = NIL;
    Cons* translatedparametertypes = NIL;
    String_Wrapper* translatedobjecttype = cpp_translate_type_spec(((Standard_Object*)(signature->rest->value)));

    { Object* returntype = NULL;
      Cons* iter_000 = ((Cons*)(signature->value));
      Cons* collect_000 = NULL;

      while (!(iter_000 == NIL)) {
        returntype = iter_000->value;
        iter_000 = iter_000->rest;
        if (!((boolean)(collect_000))) {
          {
            collect_000 = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(returntype))), NIL);
            if (translatedreturntypes == NIL) {
              translatedreturntypes = collect_000;
            }
            else {
              add_cons_to_end_of_cons_list(translatedreturntypes, collect_000);
            }
          }
        }
        else {
          {
            collect_000->rest = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(returntype))), NIL);
            collect_000 = collect_000->rest;
          }
        }
      }
    }
    { Object* parametertype = NULL;
      Cons* iter_001 = signature->rest->rest;
      Cons* collect_001 = NULL;

      while (!(iter_001 == NIL)) {
        parametertype = iter_001->value;
        iter_001 = iter_001->rest;
        if (!((boolean)(collect_001))) {
          {
            collect_001 = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(parametertype))), NIL);
            if (translatedparametertypes == NIL) {
              translatedparametertypes = collect_001;
            }
            else {
              add_cons_to_end_of_cons_list(translatedparametertypes, collect_001);
            }
          }
        }
        else {
          {
            collect_001->rest = cons(cpp_translate_and_pointerize_type_spec(((Standard_Object*)(parametertype))), NIL);
            collect_001 = collect_001->rest;
          }
        }
      }
    }
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SIGNATURE, translatedreturntypes, cons(translatedobjecttype, cons(translatedparametertypes, NIL))));
  }
}

Cons* cpp_translate_call_function_code(Cons* tree) {
  { Cons* signature = cpp_translate_code_signature(((Cons*)(tree->rest->value)));
    Object* functionnameexpr = cpp_translate_a_tree(tree->rest->rest->value);
    Cons* functionargs = tree->rest->rest->rest;

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCALL, signature, cons(functionnameexpr, cons(cpp_translate_actual_parameters(functionargs), NIL))));
  }
}

Cons* cpp_translate_call_method_code(Cons* tree) {
  { Cons* signature = cpp_translate_method_code_signature(((Cons*)(tree->rest->value)));
    Object* methodnameexpr = cpp_translate_a_tree(tree->rest->rest->value);
    Object* theobject = tree->rest->rest->rest->value;
    Cons* methodargs = tree->rest->rest->rest->rest;

    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CODE_CALL, signature, cons(methodnameexpr, cons(cpp_translate_a_tree(theobject), cons(cpp_translate_actual_parameters(methodargs), NIL)))));
  }
}

Cons* get_last_n_elements(Cons* list, int n) {
  n = list->length() - n;
  if (n < 0) {
    n = 0;
  }
  return (list->nth_rest(n));
}

Cons* cpp_translate_function_call(Cons* tree, Method_Slot* method) {
  { Symbol* functionname = ((Symbol*)(tree->value));
    Cons* functionargs = copy_cons_list(tree->rest);
    Object* firstarg = functionargs->value;
    Method_Slot* function = (((boolean)(method)) ? method : lookup_function(functionname));
    Cons* renamed_Operator = cpp_lookup_operator_table(functionname->soft_permanentify());
    Cons* otree = NULL;
    Cons* dummyargs = NIL;
    int numberofunusedreturnparameters = 0;
    Cons* unusedreturntypes = NIL;
    Symbol* dummyname = NULL;

    if ((functionname == SYM_CPP_TRANSLATE_STELLA_GET_SYM) ||
        ((functionname == SYM_CPP_TRANSLATE_STELLA_GET_KWD) ||
         (functionname == SYM_CPP_TRANSLATE_STELLA_GET_SGT))) {
      if (subtype_of_integerP(safe_primary_type(firstarg))) {
        { Object* firstarg_000 = firstarg;
          Integer_Wrapper* firstarg = ((Integer_Wrapper*)(firstarg_000));

          return (cpp_translate_hardcoded_symbol_reference(functionname, firstarg->wrapper_value));
        }
      }
      else {
      }
    }
    else {
    }
    numberofunusedreturnparameters = (function->method_parameter_names_reader()->length() + (function->method_return_type_specifiers_reader()->length() - 1)) - functionargs->length();
    if (numberofunusedreturnparameters > 0) {
      unusedreturntypes = get_last_n_elements(function->method_return_type_specifiers_reader()->rest(), numberofunusedreturnparameters);
      { Object* unusedparametertype = NULL;
        Cons* iter_000 = unusedreturntypes;

        while (!(iter_000 == NIL)) {
          unusedparametertype = iter_000->value;
          iter_000 = iter_000->rest;
          oCURRENTDUMMYINDEXo.set(oCURRENTDUMMYINDEXo.get() + 1);
          dummyname = intern_symbol(cpp_translate_return_parameter_name(SYM_CPP_TRANSLATE_STELLA_DUMMY, oCURRENTDUMMYINDEXo.get())->wrapper_value);
          oDUMMYDECLARATIONSo.set(cons(cons(dummyname, cons(unusedparametertype, NIL)), oDUMMYDECLARATIONSo.get()));
          dummyargs = cons(dummyname, dummyargs);
        }
      }
      functionargs->concatenate(dummyargs->reverse(), 0);
    }
    if (((boolean)(renamed_Operator))) {
      otree = cpp_translate_operator_call(renamed_Operator, functionargs, functionargs->length());
    }
    else {
      otree = listO(4, SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_IDENT, cpp_translate_function_name(function), NIL), ((((Boolean_Wrapper*)(dynamic_slot_value(function->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp, FALSE_WRAPPER)))->wrapper_value &&
          (!pass_variable_arguments_as_listP(function))) ? cpp_translate_variable_length_actuals(functionargs, function) : cpp_translate_actual_parameters(functionargs)), NIL);
    }
    return (otree);
  }
}

Cons* cpp_translate_operator_tree(Cons* tree) {
  { Cons* renamed_Operator = cpp_lookup_operator_table(((Symbol*)(tree->value)));
    Cons* args = tree->rest;
    int arity = NULL_INTEGER;

    { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(tree->value));

      if ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_AND) ||
          ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_OR) ||
           ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_EQp) ||
            ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_g) ||
             ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_ge) ||
              ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_l) ||
               (test_value_000 == SYM_CPP_TRANSLATE_STELLA_le))))))) {
        arity = 2;
      }
      else if ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_NOT) ||
          ((test_value_000 == SYM_CPP_TRANSLATE_STELLA_ii) ||
           (test_value_000 == SYM_CPP_TRANSLATE_STELLA___))) {
        arity = 1;
      }
      else {
        { Output_String_Stream* stream_000 = new_output_string_stream();

          *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
          throw *new_stella_exception(stream_000->the_string_reader());
        }
      }
    }
    return (cpp_translate_operator_call(renamed_Operator, args, arity));
  }
}

Cons* cpp_translate_operator_call(Cons* operatornames, Cons* arguments, int arity) {
  { Cons* otree = NULL;

    switch (arity) {
      case 1: 
        otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_UNARY_OP, operatornames->value, cons(cpp_translate_a_tree(arguments->value), NIL));
      break;
      case 2: 
        if (arguments->length() > 2) {
          otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_BINARY_OP, cpp_translate_a_tree(arguments->value), cons(operatornames->value, cons(cpp_translate_operator_call(((Cons*)(copy_cons_tree(operatornames))), arguments->rest, 2), NIL)));
        }
        else {
          otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_BINARY_OP, cpp_translate_a_tree(arguments->value), cons(operatornames->value, cons(cpp_translate_a_tree(arguments->rest->value), NIL)));
        }
      break;
      case 3: 
        otree = listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_TERNARY_OP, cpp_translate_a_tree(arguments->value), cons(operatornames->value, cons(cpp_translate_a_tree(arguments->rest->value), cons(operatornames->rest->value, cons(cpp_translate_a_tree(arguments->rest->rest->value), NIL)))));
      break;
      default:
        { Output_String_Stream* stream_000 = new_output_string_stream();

          *(stream_000->native_stream) << "`" << arity << "'" << " is not a valid case option";
          throw *new_stella_exception(stream_000->the_string_reader());
        }
      break;
    }
    return (otree);
  }
}

Cons* cpp_translate_hardcoded_symbol_reference(Symbol* renamed_Operator, int offset) {
  { Generalized_Symbol* symbol = NULL;

    if (renamed_Operator == SYM_CPP_TRANSLATE_STELLA_GET_SYM) {
      symbol = get_sym_from_offset(offset);
    }
    else if (renamed_Operator == SYM_CPP_TRANSLATE_STELLA_GET_KWD) {
      symbol = get_kwd_from_offset(offset);
    }
    else if (renamed_Operator == SYM_CPP_TRANSLATE_STELLA_GET_SGT) {
      symbol = get_sgt_from_offset(offset);
    }
    else {
      { Output_String_Stream* stream_000 = new_output_string_stream();

        *(stream_000->native_stream) << "`" << renamed_Operator << "'" << " is not a valid case option";
        throw *new_stella_exception(stream_000->the_string_reader());
      }
    }
    return (listO(3, SYM_CPP_TRANSLATE_STELLA_CPP_SYMBOL, symbol, NIL));
  }
}

void help_startup_cpp_translate1() {
  {
    KWD_CPP_TRANSLATE_USE_CPP_GARBAGE_COLLECTOR = ((Keyword*)(intern_rigid_symbol_wrt_module("USE-CPP-GARBAGE-COLLECTOR", NULL, 2)));
    SGT_CPP_TRANSLATE_STELLA_KEY_VALUE_LIST = ((Surrogate*)(intern_rigid_symbol_wrt_module("KEY-VALUE-LIST", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_ii = ((Symbol*)(intern_rigid_symbol_wrt_module("++", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA___ = ((Symbol*)(intern_rigid_symbol_wrt_module("--", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_i = ((Symbol*)(intern_rigid_symbol_wrt_module("+", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA__ = ((Symbol*)(intern_rigid_symbol_wrt_module("-", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_o = ((Symbol*)(intern_rigid_symbol_wrt_module("*", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_s = ((Symbol*)(intern_rigid_symbol_wrt_module("/", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_EQp = ((Symbol*)(intern_rigid_symbol_wrt_module("EQ?", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_xe = ((Symbol*)(intern_rigid_symbol_wrt_module("!=", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_g = ((Symbol*)(intern_rigid_symbol_wrt_module(">", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ge = ((Symbol*)(intern_rigid_symbol_wrt_module(">=", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_eg = ((Symbol*)(intern_rigid_symbol_wrt_module("=>", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_l = ((Symbol*)(intern_rigid_symbol_wrt_module("<", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_el = ((Symbol*)(intern_rigid_symbol_wrt_module("=<", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_le = ((Symbol*)(intern_rigid_symbol_wrt_module("<=", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_AND = ((Symbol*)(intern_rigid_symbol_wrt_module("AND", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_OR = ((Symbol*)(intern_rigid_symbol_wrt_module("OR", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_NOT = ((Symbol*)(intern_rigid_symbol_wrt_module("NOT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CHOOSE = ((Symbol*)(intern_rigid_symbol_wrt_module("CHOOSE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ASM = ((Symbol*)(intern_rigid_symbol_wrt_module("ASM", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_AUTO = ((Symbol*)(intern_rigid_symbol_wrt_module("AUTO", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_BREAK = ((Symbol*)(intern_rigid_symbol_wrt_module("BREAK", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("CASE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CATCH = ((Symbol*)(intern_rigid_symbol_wrt_module("CATCH", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CHAR = ((Symbol*)(intern_rigid_symbol_wrt_module("CHAR", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CLASS = ((Symbol*)(intern_rigid_symbol_wrt_module("CLASS", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CONST = ((Symbol*)(intern_rigid_symbol_wrt_module("CONST", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CONTINUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CONTINUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_DEFAULT = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFAULT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_DELETE = ((Symbol*)(intern_rigid_symbol_wrt_module("DELETE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_DO = ((Symbol*)(intern_rigid_symbol_wrt_module("DO", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_DOUBLE = ((Symbol*)(intern_rigid_symbol_wrt_module("DOUBLE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ELSE = ((Symbol*)(intern_rigid_symbol_wrt_module("ELSE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ENUM = ((Symbol*)(intern_rigid_symbol_wrt_module("ENUM", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_EXTERN = ((Symbol*)(intern_rigid_symbol_wrt_module("EXTERN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_FLOAT = ((Symbol*)(intern_rigid_symbol_wrt_module("FLOAT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_FOR = ((Symbol*)(intern_rigid_symbol_wrt_module("FOR", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_FRIEND = ((Symbol*)(intern_rigid_symbol_wrt_module("FRIEND", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_GOTO = ((Symbol*)(intern_rigid_symbol_wrt_module("GOTO", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_IF = ((Symbol*)(intern_rigid_symbol_wrt_module("IF", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_INLINE = ((Symbol*)(intern_rigid_symbol_wrt_module("INLINE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_INT = ((Symbol*)(intern_rigid_symbol_wrt_module("INT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_LONG = ((Symbol*)(intern_rigid_symbol_wrt_module("LONG", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_NEW = ((Symbol*)(intern_rigid_symbol_wrt_module("NEW", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_OPERATOR = ((Symbol*)(intern_rigid_symbol_wrt_module("OPERATOR", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_PRIVATE = ((Symbol*)(intern_rigid_symbol_wrt_module("PRIVATE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_PROTECTED = ((Symbol*)(intern_rigid_symbol_wrt_module("PROTECTED", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_PUBLIC = ((Symbol*)(intern_rigid_symbol_wrt_module("PUBLIC", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_REGISTER = ((Symbol*)(intern_rigid_symbol_wrt_module("REGISTER", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_RETURN = ((Symbol*)(intern_rigid_symbol_wrt_module("RETURN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SHORT = ((Symbol*)(intern_rigid_symbol_wrt_module("SHORT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SIGNED = ((Symbol*)(intern_rigid_symbol_wrt_module("SIGNED", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SIZEOF = ((Symbol*)(intern_rigid_symbol_wrt_module("SIZEOF", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_STATIC = ((Symbol*)(intern_rigid_symbol_wrt_module("STATIC", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_STRUCT = ((Symbol*)(intern_rigid_symbol_wrt_module("STRUCT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SWITCH = ((Symbol*)(intern_rigid_symbol_wrt_module("SWITCH", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_TEMPLATE = ((Symbol*)(intern_rigid_symbol_wrt_module("TEMPLATE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_THROW = ((Symbol*)(intern_rigid_symbol_wrt_module("THROW", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_TRY = ((Symbol*)(intern_rigid_symbol_wrt_module("TRY", NULL, 0)));
  }
}

void help_startup_cpp_translate2() {
  {
    SYM_CPP_TRANSLATE_STELLA_TYPEDEF = ((Symbol*)(intern_rigid_symbol_wrt_module("TYPEDEF", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_UNION = ((Symbol*)(intern_rigid_symbol_wrt_module("UNION", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_UNSIGNED = ((Symbol*)(intern_rigid_symbol_wrt_module("UNSIGNED", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VIRTUAL = ((Symbol*)(intern_rigid_symbol_wrt_module("VIRTUAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VOID = ((Symbol*)(intern_rigid_symbol_wrt_module("VOID", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VOLATILE = ((Symbol*)(intern_rigid_symbol_wrt_module("VOLATILE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_WHILE = ((Symbol*)(intern_rigid_symbol_wrt_module("WHILE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_TYPENAME = ((Symbol*)(intern_rigid_symbol_wrt_module("TYPENAME", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_GLOBAL_VARIABLE = ((Symbol*)(intern_rigid_symbol_wrt_module("GLOBAL-VARIABLE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_TYPE = ((Symbol*)(intern_rigid_symbol_wrt_module("TYPE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_MACRO = ((Symbol*)(intern_rigid_symbol_wrt_module("MACRO", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_PRINT_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("PRINT-METHOD", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_STARTUP_TIME_PROGN = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-TIME-PROGN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VERBATIM = ((Symbol*)(intern_rigid_symbol_wrt_module("VERBATIM", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_CONS = ((Surrogate*)(intern_rigid_symbol_wrt_module("CONS", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_SPECIAL = ((Symbol*)(intern_rigid_symbol_wrt_module("SPECIAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_UNWIND_PROTECT = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-UNWIND-PROTECT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_SIGNAL = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-SIGNAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_HANDLER_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-HANDLER-CASE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_HANDLE_EXCEPTION = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-HANDLE-EXCEPTION", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VOID_SYS = ((Symbol*)(intern_rigid_symbol_wrt_module("VOID-SYS", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_BAD_SYS = ((Symbol*)(intern_rigid_symbol_wrt_module("BAD-SYS", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_TYPED_SYS = ((Symbol*)(intern_rigid_symbol_wrt_module("TYPED-SYS", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SETQ = ((Symbol*)(intern_rigid_symbol_wrt_module("SETQ", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-SLOT-VALUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_SLOT_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-REFERENCED-SLOT-VALUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE_SETTER = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-SLOT-VALUE-SETTER", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-CALL-METHOD", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_CALL_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-REFERENCED-CALL-METHOD", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-CALL-FUNCTION", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_PROGN = ((Symbol*)(intern_rigid_symbol_wrt_module("PROGN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_WITH_PROCESS_LOCK = ((Symbol*)(intern_rigid_symbol_wrt_module("WITH-PROCESS-LOCK", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_LOOP = ((Symbol*)(intern_rigid_symbol_wrt_module("LOOP", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_FOREACH = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-FOREACH", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_LET = ((Symbol*)(intern_rigid_symbol_wrt_module("LET", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CAST = ((Symbol*)(intern_rigid_symbol_wrt_module("CAST", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SAFE_CAST = ((Symbol*)(intern_rigid_symbol_wrt_module("SAFE-CAST", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_WHEN = ((Symbol*)(intern_rigid_symbol_wrt_module("WHEN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_UNLESS = ((Symbol*)(intern_rigid_symbol_wrt_module("UNLESS", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_COND = ((Symbol*)(intern_rigid_symbol_wrt_module("COND", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_MAKE = ((Symbol*)(intern_rigid_symbol_wrt_module("MAKE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_NEW = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-NEW", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_MV_SETQ = ((Symbol*)(intern_rigid_symbol_wrt_module("MV-SETQ", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION_CODE = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-CALL-FUNCTION-CODE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD_CODE = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-CALL-METHOD-CODE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_INLINE_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-INLINE-CALL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_THE_CODE = ((Symbol*)(intern_rigid_symbol_wrt_module("THE-CODE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYS_POINTER_TO_FUNCTION = ((Symbol*)(intern_rigid_symbol_wrt_module("SYS-POINTER-TO-FUNCTION", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_IGNORE = ((Symbol*)(intern_rigid_symbol_wrt_module("IGNORE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_PRINT_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("PRINT-STREAM", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_PRINT_NATIVE_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("PRINT-NATIVE-STREAM", NULL, 0)));
    KWD_CPP_TRANSLATE_CPP = ((Keyword*)(intern_rigid_symbol_wrt_module("CPP", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_CPP_VERBATIM = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_VERBATIM", NULL, 0)));
    KWD_CPP_TRANSLATE_UNBIND_WITH_DESTRUCTORS = ((Keyword*)(intern_rigid_symbol_wrt_module("UNBIND-WITH-DESTRUCTORS", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION_CALL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_IDENT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_IDENT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_ACTUALS", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_BLOCK", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_STATEMENTS", NULL, 0)));
  }
}

void help_startup_cpp_translate3() {
  {
    SYM_CPP_TRANSLATE_STELLA_CPP_COMMENT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_COMMENT", NULL, 0)));
    KWD_CPP_TRANSLATE_DIGIT = ((Keyword*)(intern_rigid_symbol_wrt_module("DIGIT", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_NATIVE_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_PRINT_NATIVE_STREAM", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_DEFPRINT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_DEFPRINT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_RETURN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_RETURN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("STREAM", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_SIGNAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SIGNAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_DEREFERENCE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_DEREFERENCE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_HANDLER_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_HANDLER_CASE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_CATCH = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CATCH", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_TYPE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_TYPE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_LOCAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_LOCAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_UNWIND_PROTECT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_UNWIND_PROTECT", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_FLOAT = ((Surrogate*)(intern_rigid_symbol_wrt_module("FLOAT", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_INTEGER_WRAPPER = ((Surrogate*)(intern_rigid_symbol_wrt_module("INTEGER-WRAPPER", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_INTEGER = ((Surrogate*)(intern_rigid_symbol_wrt_module("INTEGER", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_FLOAT_WRAPPER = ((Surrogate*)(intern_rigid_symbol_wrt_module("FLOAT-WRAPPER", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_CPP_CAST = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CAST", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_ASSIGN", NULL, 0)));
    KWD_CPP_TRANSLATE_UNBOUND_SPECIAL_VARIABLE = ((Keyword*)(intern_rigid_symbol_wrt_module("UNBOUND-SPECIAL-VARIABLE", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_CPP_SPECIAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SPECIAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_GLOBAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_GLOBAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SYMBOL_ID = ((Symbol*)(intern_rigid_symbol_wrt_module("SYMBOL-ID", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_OTHERWISE = ((Symbol*)(intern_rigid_symbol_wrt_module("OTHERWISE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CASE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_PROGN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_PROGN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_COND = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_COND", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_LOOP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_LOOP", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_WHILE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_WHILE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_WITH_PROCESS_LOCK = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_WITH_PROCESS_LOCK", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_BREAK = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_BREAK", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_CONTINUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CONTINUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_IF = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_IF", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_WHEN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_WHEN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_UNLESS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_UNLESS", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST_ITERATOR = ((Surrogate*)(intern_rigid_symbol_wrt_module("ARGUMENT-LIST-ITERATOR", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_CPP_FOREACH = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FOREACH", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VA_START = ((Symbol*)(intern_rigid_symbol_wrt_module("VA_START", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VA_END = ((Symbol*)(intern_rigid_symbol_wrt_module("VA_END", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ALLOCATE_ITERATOR = ((Symbol*)(intern_rigid_symbol_wrt_module("ALLOCATE-ITERATOR", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_LENGTH = ((Symbol*)(intern_rigid_symbol_wrt_module("LENGTH", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_NEXTp = ((Symbol*)(intern_rigid_symbol_wrt_module("NEXT?", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ARGUMENT = ((Symbol*)(intern_rigid_symbol_wrt_module("ARGUMENT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_BINARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_BINARY_OP", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_UNARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_UNARY_OP", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_LITERAL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_VA_ARG = ((Symbol*)(intern_rigid_symbol_wrt_module("VA_ARG", NULL, 0)));
    KWD_CPP_TRANSLATE_FUNCTION = ((Keyword*)(intern_rigid_symbol_wrt_module("FUNCTION", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_POINTER = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION_POINTER", NULL, 0)));
    KWD_CPP_TRANSLATE_METHOD = ((Keyword*)(intern_rigid_symbol_wrt_module("METHOD", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_POINTER = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_POINTER", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_TRUE = ((Symbol*)(intern_rigid_symbol_wrt_module("TRUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ANY_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("ANY-VALUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_ARRAY_REFERENCE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_ARRAY_REFERENCE", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_VOID = ((Surrogate*)(intern_rigid_symbol_wrt_module("VOID", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_SLOT_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_REFERENCED_SLOT_VALUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SLOT_VALUE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE_SETTER = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SLOT_VALUE_SETTER", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE = ((Symbol*)(intern_rigid_symbol_wrt_module("CLASS-CPP-NATIVE-TYPE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_MAKE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_MAKE", NULL, 0)));
  }
}

void help_startup_cpp_translate4() {
  {
    SYM_CPP_TRANSLATE_STELLA_CPP_STARTUP_TIME_PROGN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_STARTUP_TIME_PROGN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_PRINT_STREAM", NULL, 0)));
    KWD_CPP_TRANSLATE_WARN = ((Keyword*)(intern_rigid_symbol_wrt_module("WARN", NULL, 2)));
    KWD_CPP_TRANSLATE_ERROR = ((Keyword*)(intern_rigid_symbol_wrt_module("ERROR", NULL, 2)));
    KWD_CPP_TRANSLATE_CONTINUABLE_ERROR = ((Keyword*)(intern_rigid_symbol_wrt_module("CONTINUABLE-ERROR", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_ERROR = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_STANDARD_ERROR", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_OUT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_STANDARD_OUT", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_ENDL = ((Symbol*)(intern_rigid_symbol_wrt_module("ENDL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_EOL = ((Symbol*)(intern_rigid_symbol_wrt_module("EOL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_METHOD_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_REFERENCED_METHOD_CALL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_NULL = ((Symbol*)(intern_rigid_symbol_wrt_module("NULL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_SET = ((Symbol*)(intern_rigid_symbol_wrt_module("SET", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_SYMBOL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SYMBOL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_GET = ((Symbol*)(intern_rigid_symbol_wrt_module("GET", NULL, 0)));
    KWD_CPP_TRANSLATE_CPP_STANDALONE = ((Keyword*)(intern_rigid_symbol_wrt_module("CPP-STANDALONE", NULL, 2)));
    SGT_CPP_TRANSLATE_STELLA_UNKNOWN = ((Surrogate*)(intern_rigid_symbol_wrt_module("UNKNOWN", NULL, 1)));
    KWD_CPP_TRANSLATE_UPPERCASE = ((Keyword*)(intern_rigid_symbol_wrt_module("UPPERCASE", NULL, 2)));
    KWD_CPP_TRANSLATE_LOWERCASE = ((Keyword*)(intern_rigid_symbol_wrt_module("LOWERCASE", NULL, 2)));
    KWD_CPP_TRANSLATE_CAPITALIZED = ((Keyword*)(intern_rigid_symbol_wrt_module("CAPITALIZED", NULL, 2)));
    SGT_CPP_TRANSLATE_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000 = ((Surrogate*)(intern_rigid_symbol_wrt_module("CPP-CHANGE-CASE-MEMO-TABLE-000", NULL, 1)));
    KWD_CPP_TRANSLATE_UNESCAPED = ((Keyword*)(intern_rigid_symbol_wrt_module("UNESCAPED", NULL, 2)));
    KWD_CPP_TRANSLATE_NO = ((Keyword*)(intern_rigid_symbol_wrt_module("NO", NULL, 2)));
    KWD_CPP_TRANSLATE_PRESERVE = ((Keyword*)(intern_rigid_symbol_wrt_module("PRESERVE", NULL, 2)));
    KWD_CPP_TRANSLATE_UPCASE = ((Keyword*)(intern_rigid_symbol_wrt_module("UPCASE", NULL, 2)));
    KWD_CPP_TRANSLATE_DOWNCASE = ((Keyword*)(intern_rigid_symbol_wrt_module("DOWNCASE", NULL, 2)));
    KWD_CPP_TRANSLATE_TITLECASE = ((Keyword*)(intern_rigid_symbol_wrt_module("TITLECASE", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_MODULE_CPP_PACKAGE = ((Symbol*)(intern_rigid_symbol_wrt_module("MODULE-CPP-PACKAGE", NULL, 0)));
    KWD_CPP_TRANSLATE_CLEVER = ((Keyword*)(intern_rigid_symbol_wrt_module("CLEVER", NULL, 2)));
    KWD_CPP_TRANSLATE_FULL = ((Keyword*)(intern_rigid_symbol_wrt_module("FULL", NULL, 2)));
    KWD_CPP_TRANSLATE_NEVER = ((Keyword*)(intern_rigid_symbol_wrt_module("NEVER", NULL, 2)));
    SYM_CPP_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-VARIABLE-ARGUMENTS?", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA__RETURN = ((Symbol*)(intern_rigid_symbol_wrt_module("_RETURN", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_VAR_ARGS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_VAR_ARGS", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_STORAGE_SLOT = ((Surrogate*)(intern_rigid_symbol_wrt_module("STORAGE-SLOT", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_METHOD_NATIVEp = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-NATIVE?", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_LITERAL = ((Surrogate*)(intern_rigid_symbol_wrt_module("LITERAL", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_THIS = ((Symbol*)(intern_rigid_symbol_wrt_module("THIS", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_DOCUMENTATION = ((Symbol*)(intern_rigid_symbol_wrt_module("DOCUMENTATION", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SETTER_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_SETTER_CALL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_DEFINEDp = ((Symbol*)(intern_rigid_symbol_wrt_module("DEFINED?", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_NULLp = ((Symbol*)(intern_rigid_symbol_wrt_module("NULL?", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_NTH = ((Symbol*)(intern_rigid_symbol_wrt_module("NTH", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_NTH_SETTER = ((Symbol*)(intern_rigid_symbol_wrt_module("NTH-SETTER", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_AREF = ((Symbol*)(intern_rigid_symbol_wrt_module("AREF", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_AREF_SETTER = ((Symbol*)(intern_rigid_symbol_wrt_module("AREF-SETTER", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST = ((Surrogate*)(intern_rigid_symbol_wrt_module("ARGUMENT-LIST", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_CALL", NULL, 0)));
    SGT_CPP_TRANSLATE_STELLA_OBJECT = ((Surrogate*)(intern_rigid_symbol_wrt_module("OBJECT", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_BOOLEAN = ((Surrogate*)(intern_rigid_symbol_wrt_module("BOOLEAN", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_STRING = ((Surrogate*)(intern_rigid_symbol_wrt_module("STRING", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_MUTABLE_STRING = ((Surrogate*)(intern_rigid_symbol_wrt_module("MUTABLE-STRING", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_NATIVE_VECTOR = ((Surrogate*)(intern_rigid_symbol_wrt_module("NATIVE-VECTOR", NULL, 1)));
    SGT_CPP_TRANSLATE_STELLA_ARRAY = ((Surrogate*)(intern_rigid_symbol_wrt_module("ARRAY", NULL, 1)));
    SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_SIGNATURE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION_SIGNATURE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SIGNATURE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_SIGNATURE", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_FUNCALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCALL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CODE_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_CODE_CALL", NULL, 0)));
    SYM_CPP_TRANSLATE_STELLA_GET_SYM = ((Symbol*)(intern_rigid_symbol_wrt_module("GET-SYM", NULL, 0)));
  }
}

void help_startup_cpp_translate5() {
  {
    define_function_object("CPP-USE-GARBAGE-COLLECTOR?", "(DEFUN (CPP-USE-GARBAGE-COLLECTOR? BOOLEAN) ())", ((cpp_function_code)(&cpp_use_garbage_collectorP)), NULL);
    define_function_object("CPP-LOOKUP-OPERATOR-TABLE", "(DEFUN (CPP-LOOKUP-OPERATOR-TABLE CONS) ((OPERATOR SYMBOL)))", ((cpp_function_code)(&cpp_lookup_operator_table)), NULL);
    define_function_object("CPP-YIELD-RENAMED-RESERVED-WORD", "(DEFUN (CPP-YIELD-RENAMED-RESERVED-WORD STRING-WRAPPER) ((WORD SYMBOL)))", ((cpp_function_code)(&cpp_yield_renamed_reserved_word)), NULL);
    define_function_object("CPP-CREATE-RESERVED-WORD-TABLE", "(DEFUN (CPP-CREATE-RESERVED-WORD-TABLE STRING-HASH-TABLE) ())", ((cpp_function_code)(&cpp_create_reserved_word_table)), NULL);
    define_function_object("CPP-LOOKUP-RESERVED-WORD-TABLE", "(DEFUN (CPP-LOOKUP-RESERVED-WORD-TABLE STRING-WRAPPER) ((WORD SYMBOL)))", ((cpp_function_code)(&cpp_lookup_reserved_word_table)), NULL);
    define_function_object("CPP-TRANSLATE-UNIT", "(DEFUN (CPP-TRANSLATE-UNIT CONS) ((UNIT TRANSLATION-UNIT)))", ((cpp_function_code)(&cpp_translate_unit)), NULL);
    define_function_object("CPP-TRANSLATE-LIST-OF-TREES", "(DEFUN (CPP-TRANSLATE-LIST-OF-TREES CONS) ((TREES CONS)))", ((cpp_function_code)(&cpp_translate_list_of_trees)), NULL);
    define_function_object("CPP-TRANSLATE-A-TREE", "(DEFUN (CPP-TRANSLATE-A-TREE OBJECT) ((TREE OBJECT)))", ((cpp_function_code)(&cpp_translate_a_tree)), NULL);
    define_function_object("CPP-TRANSLATE-VERBATIM-TREE", "(DEFUN (CPP-TRANSLATE-VERBATIM-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_verbatim_tree)), NULL);
    define_function_object("CPP-TRANSLATE-SPECIAL-TREE", "(DEFUN (CPP-TRANSLATE-SPECIAL-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_special_tree)), NULL);
    define_function_object("CPP-TRANSLATE-INLINE-TREE", "(DEFUN (CPP-TRANSLATE-INLINE-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_inline_tree)), NULL);
    define_function_object("TOKENIZE-VERBATIM-METHOD-BODY", "(DEFUN (TOKENIZE-VERBATIM-METHOD-BODY CONS) ((TREE CONS)))", ((cpp_function_code)(&tokenize_verbatim_method_body)), NULL);
    define_function_object("CPP-TRANSLATE-INLINE-CALL-TREE", "(DEFUN (CPP-TRANSLATE-INLINE-CALL-TREE OBJECT) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_inline_call_tree)), NULL);
    define_function_object("CPP-TRANSLATE-PRINT-NATIVE-STREAM", "(DEFUN (CPP-TRANSLATE-PRINT-NATIVE-STREAM CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_print_native_stream)), NULL);
    define_function_object("CPP-TRANSLATE-DEFPRINT-UNIT", "(DEFUN (CPP-TRANSLATE-DEFPRINT-UNIT CONS) ((UNIT TRANSLATION-UNIT)))", ((cpp_function_code)(&cpp_translate_defprint_unit)), NULL);
    define_function_object("CPP-TRANSLATE-SIGNAL", "(DEFUN (CPP-TRANSLATE-SIGNAL CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_signal)), NULL);
    define_function_object("CPP-TRANSLATE-HANDLER-CASE", "(DEFUN (CPP-TRANSLATE-HANDLER-CASE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_handler_case)), NULL);
    define_function_object("CPP-TRANSLATE-HANDLE-EXCEPTION", "(DEFUN (CPP-TRANSLATE-HANDLE-EXCEPTION CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_handle_exception)), NULL);
    define_function_object("CPP-TRANSLATE-UNWIND-PROTECT", "(DEFUN (CPP-TRANSLATE-UNWIND-PROTECT CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_unwind_protect)), NULL);
    define_function_object("CPP-TRANSLATE-CAST", "(DEFUN (CPP-TRANSLATE-CAST CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_cast)), NULL);
    define_function_object("CPP-TRANSLATE-MV-SETQ", "(DEFUN (CPP-TRANSLATE-MV-SETQ CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_mv_setq)), NULL);
    define_function_object("CPP-TRANSLATE-MV-FUNCTION-CALL", "(DEFUN (CPP-TRANSLATE-MV-FUNCTION-CALL CONS) ((FUNCTIONCALL CONS) (VARIABLES CONS)))", ((cpp_function_code)(&cpp_translate_mv_function_call)), NULL);
    define_function_object("CPP-TRANSLATE-DEFINE-GLOBAL-VARIABLE-UNIT", "(DEFUN (CPP-TRANSLATE-DEFINE-GLOBAL-VARIABLE-UNIT CONS) ((UNIT TRANSLATION-UNIT)))", ((cpp_function_code)(&cpp_translate_define_global_variable_unit)), NULL);
    define_function_object("SYMBOL-CASE?", "(DEFUN (SYMBOL-CASE? BOOLEAN) ((KEYFORM OBJECT)))", ((cpp_function_code)(&symbol_caseP)), NULL);
    define_function_object("CPP-YIELD-SYMBOL-ID-FORM", "(DEFUN (CPP-YIELD-SYMBOL-ID-FORM CONS) ((SYMBOLID INTEGER)))", ((cpp_function_code)(&cpp_yield_symbol_id_form)), NULL);
    define_function_object("CPP-TRANSLATE-CONDITION", "(DEFUN (CPP-TRANSLATE-CONDITION CONS) ((CONDITION CONS) (SYMBOLCASEP BOOLEAN)))", ((cpp_function_code)(&cpp_translate_condition)), NULL);
    define_function_object("CPP-TRANSLATE-CASE-TREE", "(DEFUN (CPP-TRANSLATE-CASE-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_case_tree)), NULL);
    define_function_object("CPP-TRANSLATE-COND-TREE", "(DEFUN (CPP-TRANSLATE-COND-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_cond_tree)), NULL);
    define_function_object("CPP-TRANSLATE-LOOP", "(DEFUN (CPP-TRANSLATE-LOOP CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_loop)), NULL);
    define_function_object("CPP-TRANSLATE-WHILE", "(DEFUN (CPP-TRANSLATE-WHILE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_while)), NULL);
    define_function_object("CPP-TRANSLATE-PROGN", "(DEFUN (CPP-TRANSLATE-PROGN CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_progn)), NULL);
    define_function_object("CPP-TRANSLATE-WITH-PROCESS-LOCK", "(DEFUN (CPP-TRANSLATE-WITH-PROCESS-LOCK CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_with_process_lock)), NULL);
    define_function_object("CPP-TRANSLATE-BREAK", "(DEFUN (CPP-TRANSLATE-BREAK CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_break)), NULL);
    define_function_object("CPP-TRANSLATE-CONTINUE", "(DEFUN (CPP-TRANSLATE-CONTINUE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_continue)), NULL);
    define_function_object("CPP-TRANSLATE-IF-TREE", "(DEFUN (CPP-TRANSLATE-IF-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_if_tree)), NULL);
    define_function_object("CPP-TRANSLATE-CHOOSE-TREE", "(DEFUN (CPP-TRANSLATE-CHOOSE-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_choose_tree)), NULL);
    define_function_object("CPP-TRANSLATE-WHEN-TREE", "(DEFUN (CPP-TRANSLATE-WHEN-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_when_tree)), NULL);
    define_function_object("CPP-TRANSLATE-UNLESS-TREE", "(DEFUN (CPP-TRANSLATE-UNLESS-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_unless_tree)), NULL);
    define_function_object("CPP-TRANSLATE-FOREACH-TREE", "(DEFUN (CPP-TRANSLATE-FOREACH-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_foreach_tree)), NULL);
    define_function_object("CPP-YIELD-VA-START-TREE", "(DEFUN (CPP-YIELD-VA-START-TREE CONS) ((ITERATORVAR SYMBOL)))", ((cpp_function_code)(&cpp_yield_va_start_tree)), NULL);
    define_function_object("CPP-YIELD-VA-END-TREE", "(DEFUN (CPP-YIELD-VA-END-TREE CONS) ((ITERATORVAR SYMBOL)))", ((cpp_function_code)(&cpp_yield_va_end_tree)), NULL);
    define_function_object("CPP-YIELD-VA-ITERATOR-HELPER-VARIABLE", "(DEFUN (CPP-YIELD-VA-ITERATOR-HELPER-VARIABLE SYMBOL) ((ITERATORVAR SYMBOL)))", ((cpp_function_code)(&cpp_yield_va_iterator_helper_variable)), NULL);
    define_function_object("CPP-YIELD-VA-ITERATOR-DECLARATIONS", "(DEFUN (CPP-YIELD-VA-ITERATOR-DECLARATIONS CONS) ((ITERATORVAR SYMBOL)))", ((cpp_function_code)(&cpp_yield_va_iterator_declarations)), NULL);
    define_function_object("CPP-TRANSLATE-ARGUMENT-LIST-TREE", "(DEFUN (CPP-TRANSLATE-ARGUMENT-LIST-TREE CONS) ((OPERATOR SYMBOL) (OWNER TYPE) (ARGUMENT OBJECT)))", ((cpp_function_code)(&cpp_translate_argument_list_tree)), NULL);
    define_function_object("CPP-TRANSLATE-THE-CODE", "(DEFUN (CPP-TRANSLATE-THE-CODE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_the_code)), NULL);
    define_function_object("CPP-TRANSLATE-SYS-POINTER-TO-FUNCTION", "(DEFUN (CPP-TRANSLATE-SYS-POINTER-TO-FUNCTION CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_sys_pointer_to_function)), NULL);
    define_function_object("CPP-TRANSLATE-SYS-NEW", "(DEFUN (CPP-TRANSLATE-SYS-NEW CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_sys_new)), NULL);
    define_function_object("CPP-TRANSLATE-NEW-ARRAY", "(DEFUN (CPP-TRANSLATE-NEW-ARRAY CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_new_array)), NULL);
    define_function_object("CPP-TRANSLATE-VOID-SYS", "(DEFUN (CPP-TRANSLATE-VOID-SYS CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_void_sys)), NULL);
    define_function_object("CPP-TRANSLATE-TYPED-SYS", "(DEFUN (CPP-TRANSLATE-TYPED-SYS CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_typed_sys)), NULL);
    define_function_object("CPP-TRANSLATE-BAD-SYS", "(DEFUN (CPP-TRANSLATE-BAD-SYS OBJECT) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_bad_sys)), NULL);
    define_function_object("CPP-TRANSLATE-SYS-REFERENCED-SLOT-VALUE", "(DEFUN (CPP-TRANSLATE-SYS-REFERENCED-SLOT-VALUE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_sys_referenced_slot_value)), NULL);
    define_function_object("CPP-TRANSLATE-SYS-SLOT-VALUE", "(DEFUN (CPP-TRANSLATE-SYS-SLOT-VALUE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_sys_slot_value)), NULL);
    define_function_object("CPP-TRANSLATE-SYS-SLOT-VALUE-SETTER", "(DEFUN (CPP-TRANSLATE-SYS-SLOT-VALUE-SETTER CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_sys_slot_value_setter)), NULL);
    define_function_object("CPP-TRANSLATE-MAKE-TREE", "(DEFUN (CPP-TRANSLATE-MAKE-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_make_tree)), NULL);
    define_function_object("CPP-TRANSLATE-STARTUP-TIME-PROGN", "(DEFUN (CPP-TRANSLATE-STARTUP-TIME-PROGN CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_startup_time_progn)), NULL);
    define_function_object("CPP-STREAM-IS-STANDARD-OUTPUT?", "(DEFUN (CPP-STREAM-IS-STANDARD-OUTPUT? BOOLEAN) ((TREE OBJECT)))", ((cpp_function_code)(&cpp_stream_is_standard_outputP)), NULL);
    define_function_object("CPP-TRANSLATE-PRINT-STREAM", "(DEFUN (CPP-TRANSLATE-PRINT-STREAM CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_print_stream)), NULL);
    define_function_object("CPP-TRANSLATE-SETQ-TREE", "(DEFUN (CPP-TRANSLATE-SETQ-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_setq_tree)), NULL);
    define_function_object("CPP-TRANSLATE-NULL", "(DEFUN (CPP-TRANSLATE-NULL CONS) ())", ((cpp_function_code)(&cpp_translate_null)), NULL);
  }
}

void help_startup_cpp_translate6() {
  {
    define_method_object("(DEFMETHOD (CPP-TRANSLATE-ATOMIC-TREE CONS) ((TREE OBJECT)))", ((cpp_method_code)(&Object::cpp_translate_atomic_tree)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD (CPP-TRANSLATE-ATOMIC-TREE CONS) ((TREE KEYWORD)))", ((cpp_method_code)(&Keyword::cpp_translate_atomic_tree)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD (CPP-TRANSLATE-ATOMIC-TREE CONS) ((TREE SURROGATE)))", ((cpp_method_code)(&Surrogate::cpp_translate_atomic_tree)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD (CPP-TRANSLATE-ATOMIC-TREE CONS) ((TREE SYMBOL)))", ((cpp_method_code)(&Symbol::cpp_translate_atomic_tree)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD (CPP-TRANSLATE-ATOMIC-TREE CONS) ((TREE QUOTED-EXPRESSION)))", ((cpp_method_code)(&Quoted_Expression::cpp_translate_atomic_tree)), ((cpp_method_code)(NULL)));
    define_function_object("CPP-TRANSLATE-LET-TREE", "(DEFUN (CPP-TRANSLATE-LET-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_let_tree)), NULL);
    define_function_object("CPP-TRANSLATE-TYPE-SPEC", "(DEFUN (CPP-TRANSLATE-TYPE-SPEC STRING-WRAPPER) ((TYPESPEC TYPE-SPEC)))", ((cpp_function_code)(&cpp_translate_type_spec)), NULL);
    define_function_object("CPP-TRANSLATE-AND-POINTERIZE-TYPE-SPEC", "(DEFUN (CPP-TRANSLATE-AND-POINTERIZE-TYPE-SPEC STRING-WRAPPER) ((TYPESPEC TYPE-SPEC)))", ((cpp_function_code)(&cpp_translate_and_pointerize_type_spec)), NULL);
    define_function_object("CPP-TRANSLATE-AND-REFERENCIZE-TYPE-SPEC", "(DEFUN (CPP-TRANSLATE-AND-REFERENCIZE-TYPE-SPEC STRING-WRAPPER) ((TYPESPEC TYPE-SPEC)))", ((cpp_function_code)(&cpp_translate_and_referencize_type_spec)), NULL);
    define_function_object("CPP-TRANSLATE-ARRAY-TYPE", "(DEFUN (CPP-TRANSLATE-ARRAY-TYPE STRING-WRAPPER) ((ARRAYTYPE PARAMETRIC-TYPE-SPECIFIER)))", ((cpp_function_code)(&cpp_translate_array_type)), NULL);
    define_function_object("CPP-TRANSLATED-ARRAY-TYPE?", "(DEFUN (CPP-TRANSLATED-ARRAY-TYPE? BOOLEAN) ((TRANSLATEDTYPE OBJECT)))", ((cpp_function_code)(&cpp_translated_array_typeP)), NULL);
    define_function_object("CPP-GENERATE-ARRAY-TYPED-ENTITY", "(DEFUN (CPP-GENERATE-ARRAY-TYPED-ENTITY STRING) ((ENTITY STRING) (TRANSLATEDARRAYTYPE STRING)))", ((cpp_function_code)(&cpp_generate_array_typed_entity)), NULL);
    define_function_object("CPP-CREATE-CHARACTER-SUBSTITUTION-TABLE", "(DEFUN (CPP-CREATE-CHARACTER-SUBSTITUTION-TABLE STRING) ())", ((cpp_function_code)(&cpp_create_character_substitution_table)), NULL);
    define_function_object("REPLACE-FIRST-CHARACTER-WITH-STRING", "(DEFUN (REPLACE-FIRST-CHARACTER-WITH-STRING STRING) ((STRING STRING) (NEWPREFIX STRING)))", ((cpp_function_code)(&replace_first_character_with_string)), NULL);
    define_function_object("CPP-SUBSTITUTE-FORBIDDEN-CHARACTERS", "(DEFUN (CPP-SUBSTITUTE-FORBIDDEN-CHARACTERS STRING) ((NAME STRING) (CASECONVENTION KEYWORD)))", ((cpp_function_code)(&cpp_substitute_forbidden_characters)), NULL);
    define_function_object("CPP-CHANGE-CASE", "(DEFUN (CPP-CHANGE-CASE STRING) ((SYMBOL GENERALIZED-SYMBOL) (CASECONVENTION KEYWORD)))", ((cpp_function_code)(&cpp_change_case)), NULL);
    define_function_object("HELP-CPP-CHANGE-CASE", "(DEFUN (HELP-CPP-CHANGE-CASE STRING) ((SYMBOL GENERALIZED-SYMBOL) (CASECONVENTION KEYWORD)))", ((cpp_function_code)(&help_cpp_change_case)), NULL);
    define_function_object("CPP-YIELD-NAMESPACE-PREFIX-FROM-MODULE", "(DEFUN (CPP-YIELD-NAMESPACE-PREFIX-FROM-MODULE STRING) ((MODULE MODULE)))", ((cpp_function_code)(&cpp_yield_namespace_prefix_from_module)), NULL);
    define_function_object("CPP-YIELD-NAMESPACE-PREFIX", "(DEFUN (CPP-YIELD-NAMESPACE-PREFIX STRING) ((SYMBOL GENERALIZED-SYMBOL)))", ((cpp_function_code)(&cpp_yield_namespace_prefix)), NULL);
    define_function_object("CPP-NAME-QUALIFICATION-MODE", "(DEFUN (CPP-NAME-QUALIFICATION-MODE KEYWORD) () :GLOBALLY-INLINE? TRUE (RETURN *CPP-NAME-QUALIFICATION-MODE*))", ((cpp_function_code)(&cpp_name_qualification_mode)), NULL);
    define_function_object("CPP-QUALIFY-NAME?", "(DEFUN (CPP-QUALIFY-NAME? BOOLEAN) ((NAMESYMBOL GENERALIZED-SYMBOL)))", ((cpp_function_code)(&cpp_qualify_nameP)), NULL);
    define_function_object("CPP-YIELD-QUALIFIED-NAME", "(DEFUN (CPP-YIELD-QUALIFIED-NAME STRING) ((TRANSLATEDNAME STRING) (SOURCESYMBOL GENERALIZED-SYMBOL)))", ((cpp_function_code)(&cpp_yield_qualified_name)), NULL);
    define_function_object("CPP-TRANSLATE-NAME", "(DEFUN (CPP-TRANSLATE-NAME STRING-WRAPPER) ((NAMESYMBOL SYMBOL)))", ((cpp_function_code)(&cpp_translate_name)), NULL);
    define_function_object("CPP-TRANSLATE-GLOBAL-NAME", "(DEFUN (CPP-TRANSLATE-GLOBAL-NAME STRING-WRAPPER) ((NAMESYMBOL SYMBOL)))", ((cpp_function_code)(&cpp_translate_global_name)), NULL);
    define_function_object("CPP-TRANSLATE-CLASS-PARAMETER-NAME", "(DEFUN (CPP-TRANSLATE-CLASS-PARAMETER-NAME STRING-WRAPPER) ((NAMESYMBOL SYMBOL)))", ((cpp_function_code)(&cpp_translate_class_parameter_name)), NULL);
    define_function_object("CPP-TRANSLATE-RETURN-PARAMETER-NAME", "(DEFUN (CPP-TRANSLATE-RETURN-PARAMETER-NAME STRING-WRAPPER) ((NAMESYMBOL SYMBOL) (PARAMETERNUMBER INTEGER)))", ((cpp_function_code)(&cpp_translate_return_parameter_name)), NULL);
    define_function_object("CPP-TRANSLATE-SYMBOL-CONSTANT-NAME", "(DEFUN (CPP-TRANSLATE-SYMBOL-CONSTANT-NAME STRING-WRAPPER) ((SYMBOL GENERALIZED-SYMBOL)))", ((cpp_function_code)(&cpp_translate_symbol_constant_name)), NULL);
    define_function_object("CPP-TRANSLATE-SYMBOL-CONSTANT-ID", "(DEFUN (CPP-TRANSLATE-SYMBOL-CONSTANT-ID STRING-WRAPPER) ((SYMBOL GENERALIZED-SYMBOL)))", ((cpp_function_code)(&cpp_translate_symbol_constant_id)), NULL);
    define_function_object("CPP-TRANSLATE-SYMBOL-NAME", "(DEFUN (CPP-TRANSLATE-SYMBOL-NAME STRING-WRAPPER) ((SYMBOL SYMBOL)))", ((cpp_function_code)(&cpp_translate_symbol_name)), NULL);
    define_function_object("CPP-TRANSLATE-SYMBOL-ID", "(DEFUN (CPP-TRANSLATE-SYMBOL-ID STRING-WRAPPER) ((SYMBOL SYMBOL)))", ((cpp_function_code)(&cpp_translate_symbol_id)), NULL);
    define_function_object("CPP-TRANSLATE-SURROGATE-NAME", "(DEFUN (CPP-TRANSLATE-SURROGATE-NAME STRING-WRAPPER) ((SURROGATE SURROGATE)))", ((cpp_function_code)(&cpp_translate_surrogate_name)), NULL);
    define_function_object("CPP-TRANSLATE-SURROGATE-ID", "(DEFUN (CPP-TRANSLATE-SURROGATE-ID STRING-WRAPPER) ((SURROGATE SURROGATE)))", ((cpp_function_code)(&cpp_translate_surrogate_id)), NULL);
    define_function_object("CPP-TRANSLATE-KEYWORD-NAME", "(DEFUN (CPP-TRANSLATE-KEYWORD-NAME STRING-WRAPPER) ((KEYWORD KEYWORD)))", ((cpp_function_code)(&cpp_translate_keyword_name)), NULL);
    define_function_object("CPP-TRANSLATE-KEYWORD-ID", "(DEFUN (CPP-TRANSLATE-KEYWORD-ID STRING-WRAPPER) ((KEYWORD KEYWORD)))", ((cpp_function_code)(&cpp_translate_keyword_id)), NULL);
    define_function_object("CPP-TRANSLATE-CLASS-TYPENAME", "(DEFUN (CPP-TRANSLATE-CLASS-TYPENAME STRING-WRAPPER) ((NAMESYMBOL GENERALIZED-SYMBOL)))", ((cpp_function_code)(&cpp_translate_class_typename)), NULL);
    define_function_object("CPP-TRANSLATE-CLASS-NAME", "(DEFUN (CPP-TRANSLATE-CLASS-NAME STRING-WRAPPER) ((NAMESYMBOL GENERALIZED-SYMBOL)))", ((cpp_function_code)(&cpp_translate_class_name)), NULL);
    define_function_object("CPP-REFERENCE-TYPE?", "(DEFUN (CPP-REFERENCE-TYPE? BOOLEAN) ((TYPESPEC TYPE-SPEC)))", ((cpp_function_code)(&cpp_reference_typeP)), NULL);
    define_function_object("CPP-REFERENCIZE-TYPE", "(DEFUN (CPP-REFERENCIZE-TYPE STRING-WRAPPER) ((TYPESPEC TYPE-SPEC)))", ((cpp_function_code)(&cpp_referencize_type)), NULL);
    define_function_object("CPP-TRANSLATE-FUNCTION-PARAMETER", "(DEFUN (CPP-TRANSLATE-FUNCTION-PARAMETER OBJECT) ((NAME SYMBOL) (TYPE TYPE-SPEC) (METHOD METHOD-SLOT)))", ((cpp_function_code)(&cpp_translate_function_parameter)), NULL);
    define_function_object("CPP-TRANSLATE-RETURN-PARAMETER", "(DEFUN (CPP-TRANSLATE-RETURN-PARAMETER CONS) ((PARAMETERNUMBER INTEGER) (PARAMETERTYPE TYPE-SPEC)))", ((cpp_function_code)(&cpp_translate_return_parameter)), NULL);
    define_function_object("CPP-TRANSLATE-FUNCTION-PARAMETERS", "(DEFUN (CPP-TRANSLATE-FUNCTION-PARAMETERS CONS) ((METHOD METHOD-SLOT)))", ((cpp_function_code)(&cpp_translate_function_parameters)), NULL);
    define_function_object("SLOT-READER-FROM-NAME?", "(DEFUN (SLOT-READER-FROM-NAME? BOOLEAN) ((METHODNAME SYMBOL) (METHODOWNER TYPE-SPEC)))", ((cpp_function_code)(&slot_reader_from_nameP)), NULL);
    define_function_object("SLOT-READER?", "(DEFUN (SLOT-READER? BOOLEAN) ((METHOD METHOD-SLOT)))", ((cpp_function_code)(&slot_readerP)), NULL);
    define_function_object("CPP-TRANSLATE-CONSTRUCTOR-NAME", "(DEFUN (CPP-TRANSLATE-CONSTRUCTOR-NAME STRING-WRAPPER) ((CONSTRUCTOR METHOD-SLOT)))", ((cpp_function_code)(&cpp_translate_constructor_name)), NULL);
    define_function_object("CPP-TRANSLATE-FUNCTION-NAME-FROM-NAME", "(DEFUN (CPP-TRANSLATE-FUNCTION-NAME-FROM-NAME STRING-WRAPPER) ((FUNCTIONNAME SYMBOL)))", ((cpp_function_code)(&cpp_translate_function_name_from_name)), NULL);
    define_function_object("CPP-TRANSLATE-FUNCTION-NAME", "(DEFUN (CPP-TRANSLATE-FUNCTION-NAME STRING-WRAPPER) ((FUNCTION METHOD-SLOT)))", ((cpp_function_code)(&cpp_translate_function_name)), NULL);
    define_function_object("CPP-TRANSLATE-METHOD-NAME-FROM-NAME", "(DEFUN (CPP-TRANSLATE-METHOD-NAME-FROM-NAME STRING-WRAPPER) ((METHODNAME SYMBOL) (METHODOWNER TYPE-SPEC)))", ((cpp_function_code)(&cpp_translate_method_name_from_name)), NULL);
    define_function_object("CPP-TRANSLATE-METHOD-NAME", "(DEFUN (CPP-TRANSLATE-METHOD-NAME STRING-WRAPPER) ((METHOD METHOD-SLOT)))", ((cpp_function_code)(&cpp_translate_method_name)), NULL);
    define_function_object("DELETE-QUOTED-NULL-STATEMENTS", "(DEFUN (DELETE-QUOTED-NULL-STATEMENTS CONS) ((TREES CONS)))", ((cpp_function_code)(&delete_quoted_null_statements)), NULL);
    define_function_object("CPP-METHOD-OBJECT-IS-FUNCTION?", "(DEFUN (CPP-METHOD-OBJECT-IS-FUNCTION? BOOLEAN) ((METHOD METHOD-SLOT)))", ((cpp_function_code)(&cpp_method_object_is_functionP)), NULL);
    define_function_object("CPP-METHOD-OBJECT-IS-OVERLOADED-FUNCTION?", "(DEFUN (CPP-METHOD-OBJECT-IS-OVERLOADED-FUNCTION? BOOLEAN) ((METHOD METHOD-SLOT)))", ((cpp_function_code)(&cpp_method_object_is_overloaded_functionP)), NULL);
    define_function_object("WRAP-METHOD-BODY-WITH-CPP-AUXILIARY-DECLARATIONS", "(DEFUN (WRAP-METHOD-BODY-WITH-CPP-AUXILIARY-DECLARATIONS CONS) ((METHODBODY CONS) (DECLARATIONS CONS)))", ((cpp_function_code)(&wrap_method_body_with_cpp_auxiliary_declarations)), NULL);
    define_function_object("CPP-TRANSLATE-DEFINE-METHOD-UNIT", "(DEFUN (CPP-TRANSLATE-DEFINE-METHOD-UNIT CONS) ((UNIT TRANSLATION-UNIT)))", ((cpp_function_code)(&cpp_translate_define_method_unit)), NULL);
    define_function_object("CPP-TRANSLATE-RETURN-TREE", "(DEFUN (CPP-TRANSLATE-RETURN-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_return_tree)), NULL);
    define_function_object("CPP-TRANSLATE-ACTUAL-PARAMETERS", "(DEFUN (CPP-TRANSLATE-ACTUAL-PARAMETERS CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_actual_parameters)), NULL);
    define_function_object("CPP-TRANSLATE-VARIABLE-LENGTH-ACTUALS", "(DEFUN (CPP-TRANSLATE-VARIABLE-LENGTH-ACTUALS CONS) ((ACTUALS CONS) (METHOD METHOD-SLOT)))", ((cpp_function_code)(&cpp_translate_variable_length_actuals)), NULL);
    define_function_object("CPP-TRANSLATE-CALL-METHOD-SETTER", "(DEFUN (CPP-TRANSLATE-CALL-METHOD-SETTER CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_call_method_setter)), NULL);
    define_function_object("CPP-CREATE-OVERLOADED-FUNCTION-NAME", "(DEFUN (CPP-CREATE-OVERLOADED-FUNCTION-NAME SYMBOL) ((FUNCTIONNAME SYMBOL) (CLASSTYPE TYPE)))", ((cpp_function_code)(&cpp_create_overloaded_function_name)), NULL);
    define_function_object("CPP-TRANSLATE-METHOD-CALL", "(DEFUN (CPP-TRANSLATE-METHOD-CALL CONS) ((TREE CONS) (REFERENCED? BOOLEAN)))", ((cpp_function_code)(&cpp_translate_method_call)), NULL);
    define_function_object("CPP-TRANSLATE-NORMAL-METHOD-CALL", "(DEFUN (CPP-TRANSLATE-NORMAL-METHOD-CALL CONS) ((METHODNAME SYMBOL) (OWNER TYPE) (ARGUMENTS CONS) (REFERENCED? BOOLEAN)))", ((cpp_function_code)(&cpp_translate_normal_method_call)), NULL);
  }
}

void startup_cpp_translate() {
  { 
    BIND_STELLA_SPECIAL(oMODULEo, Module*, oSTELLA_MODULEo);
    BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
    if (current_startup_time_phaseP(2)) {
      help_startup_cpp_translate1();
      help_startup_cpp_translate2();
      help_startup_cpp_translate3();
      help_startup_cpp_translate4();
      SYM_CPP_TRANSLATE_STELLA_GET_KWD = ((Symbol*)(intern_rigid_symbol_wrt_module("GET-KWD", NULL, 0)));
      SYM_CPP_TRANSLATE_STELLA_GET_SGT = ((Symbol*)(intern_rigid_symbol_wrt_module("GET-SGT", NULL, 0)));
      SYM_CPP_TRANSLATE_STELLA_DUMMY = ((Symbol*)(intern_rigid_symbol_wrt_module("DUMMY", NULL, 0)));
      SYM_CPP_TRANSLATE_STELLA_CPP_TERNARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_TERNARY_OP", NULL, 0)));
      SYM_CPP_TRANSLATE_STELLA_STARTUP_CPP_TRANSLATE = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-CPP-TRANSLATE", NULL, 0)));
      SYM_CPP_TRANSLATE_STELLA_METHOD_STARTUP_CLASSNAME = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-STARTUP-CLASSNAME", NULL, 0)));
    }
    if (current_startup_time_phaseP(4)) {
      oOPERATOR_TABLEo = ((Key_Value_List*)(dictionary(SGT_CPP_TRANSLATE_STELLA_KEY_VALUE_LIST, 36, SYM_CPP_TRANSLATE_STELLA_ii, cons(wrap_string("++"), NIL), SYM_CPP_TRANSLATE_STELLA___, cons(wrap_string("--"), NIL), SYM_CPP_TRANSLATE_STELLA_i, cons(wrap_string("+"), NIL), SYM_CPP_TRANSLATE_STELLA__, cons(wrap_string("-"), NIL), SYM_CPP_TRANSLATE_STELLA_o, cons(wrap_string("*"), NIL), SYM_CPP_TRANSLATE_STELLA_s, cons(wrap_string("/"), NIL), SYM_CPP_TRANSLATE_STELLA_EQp, cons(wrap_string("=="), NIL), SYM_CPP_TRANSLATE_STELLA_xe, cons(wrap_string("!="), NIL), SYM_CPP_TRANSLATE_STELLA_g, cons(wrap_string(">"), NIL), SYM_CPP_TRANSLATE_STELLA_ge, cons(wrap_string(">="), NIL), SYM_CPP_TRANSLATE_STELLA_eg, cons(wrap_string(">="), NIL), SYM_CPP_TRANSLATE_STELLA_l, cons(wrap_string("<"), NIL), SYM_CPP_TRANSLATE_STELLA_el, cons(wrap_string("<="), NIL), SYM_CPP_TRANSLATE_STELLA_le, cons(wrap_string("<="), NIL), SYM_CPP_TRANSLATE_STELLA_AND, cons(wrap_string("&&"), NIL), SYM_CPP_TRANSLATE_STELLA_OR, cons(wrap_string("||"), NIL), SYM_CPP_TRANSLATE_STELLA_NOT, cons(wrap_string("!"), NIL), SYM_CPP_TRANSLATE_STELLA_CHOOSE, cons(wrap_string("?"), cons(wrap_string(":"), NIL)))));
      oCPP_RESERVED_WORD_TABLEo = cpp_create_reserved_word_table();
      oCPP_CHARACTER_SUBSTITUTION_TABLEo = cpp_create_character_substitution_table();
      oCPP_NAME_QUALIFICATION_MODEo.set(KWD_CPP_TRANSLATE_CLEVER);
    }
    if (current_startup_time_phaseP(6)) {
      finalize_classes();
    }
    if (current_startup_time_phaseP(7)) {
      help_startup_cpp_translate5();
      help_startup_cpp_translate6();
      define_function_object("CPP-TRANSLATE-DEFINED?-METHOD-CALL", "(DEFUN (CPP-TRANSLATE-DEFINED?-METHOD-CALL CONS) ((ARGUMENTTYPE TYPE) (ARGUMENT OBJECT) (NULL? BOOLEAN)))", ((cpp_function_code)(&cpp_translate_definedP_method_call)), NULL);
      define_function_object("CPP-TRANSLATE-NTH-METHOD-CALL", "(DEFUN (CPP-TRANSLATE-NTH-METHOD-CALL CONS) ((OPERATOR SYMBOL) (OWNER TYPE) (ARGUMENTS CONS)))", ((cpp_function_code)(&cpp_translate_nth_method_call)), NULL);
      define_function_object("CPP-TRANSLATE-AREF-METHOD-CALL", "(DEFUN (CPP-TRANSLATE-AREF-METHOD-CALL CONS) ((OPERATOR SYMBOL) (OWNER TYPE) (ARGUMENTS CONS)))", ((cpp_function_code)(&cpp_translate_aref_method_call)), NULL);
      define_function_object("CPP-TRANSLATE-CODE-SIGNATURE", "(DEFUN (CPP-TRANSLATE-CODE-SIGNATURE CONS) ((SIGNATURE CONS)))", ((cpp_function_code)(&cpp_translate_code_signature)), NULL);
      define_function_object("CPP-TRANSLATE-METHOD-CODE-SIGNATURE", "(DEFUN (CPP-TRANSLATE-METHOD-CODE-SIGNATURE CONS) ((SIGNATURE CONS)))", ((cpp_function_code)(&cpp_translate_method_code_signature)), NULL);
      define_function_object("CPP-TRANSLATE-CALL-FUNCTION-CODE", "(DEFUN (CPP-TRANSLATE-CALL-FUNCTION-CODE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_call_function_code)), NULL);
      define_function_object("CPP-TRANSLATE-CALL-METHOD-CODE", "(DEFUN (CPP-TRANSLATE-CALL-METHOD-CODE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_call_method_code)), NULL);
      define_function_object("GET-LAST-N-ELEMENTS", "(DEFUN (GET-LAST-N-ELEMENTS CONS) ((LIST CONS) (N INTEGER)))", ((cpp_function_code)(&get_last_n_elements)), NULL);
      define_function_object("CPP-TRANSLATE-FUNCTION-CALL", "(DEFUN (CPP-TRANSLATE-FUNCTION-CALL CONS) ((TREE CONS) (METHOD METHOD-SLOT)))", ((cpp_function_code)(&cpp_translate_function_call)), NULL);
      define_function_object("CPP-TRANSLATE-OPERATOR-TREE", "(DEFUN (CPP-TRANSLATE-OPERATOR-TREE CONS) ((TREE CONS)))", ((cpp_function_code)(&cpp_translate_operator_tree)), NULL);
      define_function_object("CPP-TRANSLATE-OPERATOR-CALL", "(DEFUN (CPP-TRANSLATE-OPERATOR-CALL CONS) ((OPERATORNAMES CONS) (ARGUMENTS CONS) (ARITY INTEGER)))", ((cpp_function_code)(&cpp_translate_operator_call)), NULL);
      define_function_object("CPP-TRANSLATE-HARDCODED-SYMBOL-REFERENCE", "(DEFUN (CPP-TRANSLATE-HARDCODED-SYMBOL-REFERENCE CONS) ((OPERATOR SYMBOL) (OFFSET INTEGER)))", ((cpp_function_code)(&cpp_translate_hardcoded_symbol_reference)), NULL);
      define_function_object("STARTUP-CPP-TRANSLATE", "(DEFUN STARTUP-CPP-TRANSLATE () :PUBLIC? TRUE)", ((cpp_function_code)(&startup_cpp_translate)), NULL);
      { Method_Slot* function = lookup_function(SYM_CPP_TRANSLATE_STELLA_STARTUP_CPP_TRANSLATE);

        set_dynamic_slot_value(function->dynamic_slots, SYM_CPP_TRANSLATE_STELLA_METHOD_STARTUP_CLASSNAME, wrap_string("Startup-Cpp-Translate"), NULL_STRING_WRAPPER);
      }
    }
    if (current_startup_time_phaseP(8)) {
      finalize_slots();
      cleanup_unfinalized_classes();
    }
    if (current_startup_time_phaseP(9)) {
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *DUMMYDECLARATIONS* CONS NULL :DOCUMENTATION \"Temporary List of declarations for unused return parameters\")");
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *CURRENTDUMMYINDEX* INTEGER NULL-INTEGER :DOCUMENTATION \"Current index of dummy parameter for unused return value\")");
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *OPERATOR-TABLE* KEY-VALUE-LIST (DICTIONARY @KEY-VALUE-LIST (QUOTE ++) (CONS (WRAP-LITERAL \"++\") NIL) (QUOTE --) (CONS (WRAP-LITERAL \"--\") NIL) (QUOTE +) (CONS (WRAP-LITERAL \"+\") NIL) (QUOTE -) (CONS (WRAP-LITERAL \"-\") NIL) (QUOTE *) (CONS (WRAP-LITERAL \"*\") NIL) (QUOTE /) (CONS (WRAP-LITERAL \"/\") NIL) (QUOTE EQ?) (CONS (WRAP-LITERAL \"==\") NIL) (QUOTE !=) (CONS (WRAP-LITERAL \"!=\") NIL) (QUOTE >) (CONS (WRAP-LITERAL \">\") NIL) (QUOTE >=) (CONS (WRAP-LITERAL \">=\") NIL) (QUOTE =>) (CONS (WRAP-LITERAL \">=\") NIL) (QUOTE <) (CONS (WRAP-LITERAL \"<\") NIL) (QUOTE =<) (CONS (WRAP-LITERAL \"<=\") NIL) (QUOTE <=) (CONS (WRAP-LITERAL \"<=\") NIL) (QUOTE AND) (CONS (WRAP-LITERAL \"&&\") NIL) (QUOTE OR) (CONS (WRAP-LITERAL \"||\") NIL) (QUOTE NOT) (CONS (WRAP-LITERAL \"!\") NIL) (QUOTE CHOOSE) (CONS (WRAP-LITERAL \"?\") (CONS (WRAP-LITERAL \":\") NIL))) :DOCUMENTATION \"Mapping from STELLA operators to C++ operators\")");
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *CPP-RESERVED-WORD-TABLE* (STRING-HASH-TABLE OF STRING STRING-WRAPPER) (CPP-CREATE-RESERVED-WORD-TABLE))");
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *CPP-CURRENT-UNIT-MODULE* MODULE NULL :DOCUMENTATION \"Home module of the currently translated unit.  Needed for\nproper name translation for units whose home module is different than the\nfile module (occurs in some PowerLoom files - I thought we had outlawed that).\")");
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *CPP-CHARACTER-SUBSTITUTION-TABLE* STRING (CPP-CREATE-CHARACTER-SUBSTITUTION-TABLE))");
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *CPP-NAME-QUALIFICATION-MODE* KEYWORD :CLEVER)");
      define_stella_global_variable_from_stringified_source("(DEFGLOBAL *CPP-NAMESPACE-SEPARATOR* STRING \"::\")");
    }
  }
}

Keyword* KWD_CPP_TRANSLATE_USE_CPP_GARBAGE_COLLECTOR = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_KEY_VALUE_LIST = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ii = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA___ = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_i = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA__ = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_o = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_s = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_EQp = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_xe = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_g = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ge = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_eg = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_l = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_el = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_le = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_AND = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_OR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_NOT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CHOOSE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ASM = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_AUTO = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_BREAK = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CASE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CATCH = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CHAR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CLASS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CONST = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CONTINUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_DEFAULT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_DELETE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_DO = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_DOUBLE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ELSE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ENUM = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_EXTERN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_FLOAT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_FOR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_FRIEND = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_GOTO = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_IF = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_INLINE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_INT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_LONG = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_NEW = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_OPERATOR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_PRIVATE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_PROTECTED = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_PUBLIC = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_REGISTER = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_RETURN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SHORT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SIGNED = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SIZEOF = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_STATIC = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_STRUCT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SWITCH = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_TEMPLATE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_THROW = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_TRY = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_TYPEDEF = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_UNION = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_UNSIGNED = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VIRTUAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VOID = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VOLATILE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_WHILE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_TYPENAME = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_GLOBAL_VARIABLE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_TYPE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_MACRO = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_PRINT_METHOD = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_STARTUP_TIME_PROGN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VERBATIM = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_CONS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SPECIAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_UNWIND_PROTECT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_SIGNAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_HANDLER_CASE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_HANDLE_EXCEPTION = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VOID_SYS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_BAD_SYS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_TYPED_SYS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SETQ = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_SLOT_VALUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_SLOT_VALUE_SETTER = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_REFERENCED_CALL_METHOD = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_PROGN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_WITH_PROCESS_LOCK = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_LOOP = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_FOREACH = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_LET = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CAST = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SAFE_CAST = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_WHEN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_UNLESS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_COND = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_MAKE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_NEW = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_MV_SETQ = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_FUNCTION_CODE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_CALL_METHOD_CODE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_INLINE_CALL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_THE_CODE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYS_POINTER_TO_FUNCTION = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_IGNORE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_PRINT_STREAM = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_PRINT_NATIVE_STREAM = NULL;

Keyword* KWD_CPP_TRANSLATE_CPP = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_VERBATIM = NULL;

Keyword* KWD_CPP_TRANSLATE_UNBIND_WITH_DESTRUCTORS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_CALL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_IDENT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_ACTUALS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_BLOCK = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STATEMENTS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_COMMENT = NULL;

Keyword* KWD_CPP_TRANSLATE_DIGIT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_NATIVE_STREAM = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_DEFPRINT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_RETURN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_STREAM = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SIGNAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_DEREFERENCE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_HANDLER_CASE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CATCH = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_TYPE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_LOCAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_UNWIND_PROTECT = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_FLOAT = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_INTEGER_WRAPPER = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_INTEGER = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_FLOAT_WRAPPER = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CAST = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_ASSIGN = NULL;

Keyword* KWD_CPP_TRANSLATE_UNBOUND_SPECIAL_VARIABLE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SPECIAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_GLOBAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SYMBOL_ID = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_OTHERWISE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CASE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_PROGN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_COND = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_LOOP = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_WHILE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_WITH_PROCESS_LOCK = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_BREAK = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_CONTINUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_IF = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_WHEN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_UNLESS = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST_ITERATOR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FOREACH = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VA_START = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VA_END = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ALLOCATE_ITERATOR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_LENGTH = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_NEXTp = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ARGUMENT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_BINARY_OP = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_UNARY_OP = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_LITERAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_VA_ARG = NULL;

Keyword* KWD_CPP_TRANSLATE_FUNCTION = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_POINTER = NULL;

Keyword* KWD_CPP_TRANSLATE_METHOD = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_POINTER = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_TRUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ANY_VALUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_ARRAY_REFERENCE = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_VOID = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_SLOT_VALUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SLOT_VALUE_SETTER = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CLASS_CPP_NATIVE_TYPE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_MAKE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STARTUP_TIME_PROGN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_PRINT_STREAM = NULL;

Keyword* KWD_CPP_TRANSLATE_WARN = NULL;

Keyword* KWD_CPP_TRANSLATE_ERROR = NULL;

Keyword* KWD_CPP_TRANSLATE_CONTINUABLE_ERROR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_ERROR = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_STANDARD_OUT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_ENDL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_EOL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_REFERENCED_METHOD_CALL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_NULL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_SET = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_SYMBOL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_GET = NULL;

Keyword* KWD_CPP_TRANSLATE_CPP_STANDALONE = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_UNKNOWN = NULL;

Keyword* KWD_CPP_TRANSLATE_UPPERCASE = NULL;

Keyword* KWD_CPP_TRANSLATE_LOWERCASE = NULL;

Keyword* KWD_CPP_TRANSLATE_CAPITALIZED = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_CPP_CHANGE_CASE_MEMO_TABLE_000 = NULL;

Keyword* KWD_CPP_TRANSLATE_UNESCAPED = NULL;

Keyword* KWD_CPP_TRANSLATE_NO = NULL;

Keyword* KWD_CPP_TRANSLATE_PRESERVE = NULL;

Keyword* KWD_CPP_TRANSLATE_UPCASE = NULL;

Keyword* KWD_CPP_TRANSLATE_DOWNCASE = NULL;

Keyword* KWD_CPP_TRANSLATE_TITLECASE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_MODULE_CPP_PACKAGE = NULL;

Keyword* KWD_CPP_TRANSLATE_CLEVER = NULL;

Keyword* KWD_CPP_TRANSLATE_FULL = NULL;

Keyword* KWD_CPP_TRANSLATE_NEVER = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD_VARIABLE_ARGUMENTSp = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA__RETURN = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_VAR_ARGS = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_STORAGE_SLOT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD_NATIVEp = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_LITERAL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_THIS = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_DOCUMENTATION = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SETTER_CALL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_DEFINEDp = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_NULLp = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_NTH = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_NTH_SETTER = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_AREF = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_AREF_SETTER = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_ARGUMENT_LIST = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CALL = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_OBJECT = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_BOOLEAN = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_STRING = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_MUTABLE_STRING = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_NATIVE_VECTOR = NULL;

Surrogate* SGT_CPP_TRANSLATE_STELLA_ARRAY = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCTION_SIGNATURE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_SIGNATURE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_FUNCALL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_METHOD_CODE_CALL = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_GET_SYM = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_GET_KWD = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_GET_SGT = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_DUMMY = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_CPP_TERNARY_OP = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_STARTUP_CPP_TRANSLATE = NULL;

Symbol* SYM_CPP_TRANSLATE_STELLA_METHOD_STARTUP_CLASSNAME = NULL;

} // end of namespace stella
